Attribute VB_Name = "modDSFGen"

'at 1.09
'dsfgenNH2b uses a slightly different record layout for spdata1 than previous versions, saved as dsfgennh2.vbp
'the variable PID has been changed from integer to long
'the acute file and calendex and dmfgen must also be updated with this new record spec

'this program has not been run with nhanes = 0 or nhanes =1 since the most recent changes have been made
'1.10 added 2007-2008 NHANES survey data and modified direct water computations
'This program needs a little more work if you are going to run in in the NHANES = 1 mode (1-day)
'This is not likely to happen so I have not make the changes necessary.  There are stop statements at the
'point where a change will be needed.

'1.11  All  references to g_c_TempRead have been removed
'1.11 Default Concentration factors can now be read in and saved.  A new option button was added
'to allow the user to modify the default conc. factors and have them show up in the appropriate random access file
'(foodsepanh2-03-08-d.ran).

'1.12' the MakeCode$ variable was introduced and included in the DEEM Support File.  The order of the input file specification
'was changed so that all NH and NH2 files are listed together.
'A list of any new RAC or RAC/Foodform combinations showing up in the new set of support files (if any)
'is generated and should be provided to the DEEM user along with the set of new files.  (This is not needed for the current
'set of support files because the list of RAC/FF is the same as previous versions of the support files made for the
'NHANES 03-08 survey.

'THIS program is not intended to be compiled into an exe file. It should be run in the VB6 programming environment
'This program is used to process the raw data files into the final form support files for DEEMFCID and its acute and
'chronic modules. You are always going to find problems when you first introduce new data; that is why it is better
'to run this program in the VB6 environment....it will stop when it finds a problem and you will be able to see what
'is going on at that point.  If it is compiled it will just crash and you will not be able to see where the problem is.

'DSFgen = DEEM Support File Generator
'DSFgen is intended for use by the DEEM support team only, not for public release.
'DSFgen generates the data files needed by DEEM-FCID version 3.0 and later
'As currently set up, DSFgen will generate the supporting data files for 3 different versions of DEEM-FCID:
'  CSFII 1994-96, 1998 with EPA recipes for converting foods as eaten to RACs (ingredients)
'  NHANES 1999-2006, 1-day intake data (second day for 2003-2006 ignored)
'  NHANES 2003-2006, 2-day intake data
'Both of these latter versions use the same EPA recipe set developed to support NHANES 1999-2006
'It should be a fairly straightforward exercise to add more years from NHANES; however, additional recipes for new
'foods consumed after 2006 will be needed.
'As of this writing, the type of water intake data that was provided by SAIC for CSFII is not available for
'the NHANES data. Until these data are available the resulting DEEM support files will be of limited usefulness

'DSFgen is documented in a programmer's manual provided by SRP.  The programmers manual details the
'input data files and their file formats needed to generate the DEEM-FCID supporting files.


Option Explicit
DefInt A-Z

'This is the start of the main code module, and here is where all of the input and output file names are specified.
'As currently configured, DSFgen can generate the supporting data files for 3 different versions of DEEM-FCID.
'Thus there are two or three file names for each version (some of the input files are the same for both the 1-day
'and 2-day versions of NHANES.

'This is where you select which of the 3 different survey sources will be used in generating the DEEM support files
'(rem out the two you do not want)
'Public Const g_c_NHANES = 0  'CSFII 19994-96, 98 2-day
'Public Const g_c_NHANES = 1  'NHANES 1999-2006 1-day means and acute files

Public Const g_c_NHANES = 2  'NHANES 2003-2006 2-day means and acute files

'the following variable was defined to allow the program to read the temporary recipe files provided by EPA
'to test this program.  These files are not in the same format required by DSFgen, but rather than change the
'format specifications, some temporary code was included in order to be able to read the temporary recipes

'All of the following constants related to file names file data must be defined by the user:
'legend :
'UPC = user provided content
'UPN = user provided filename, file is generated by this program
'RA = random access
'FF = flat (text) file
'note that there are some intermediate files (generated internally) named "FoodsTemp.*" or similarly, which do not need to be named or provided by the user

'the following file names are for use with the CSFII 94-98, NANES 1-day, and NHANES 2-day intake data
'if the filename variable ends in 0, it is for CSFII
'if the filename variable ends in NH, it is for any NHANES analysis
'if the filename variable ends in NH1, it is for NHANES 1-day analysis
'if the filename variable ends in NH2, it is for NHANES 2-day analysis

'filename extensions
'*.txt files are flat text files
'*.ran files are random access files
'*.ind and *.ing are random access recipe files

'depending on how g_c_NHANES is defined, the program will select the appropriate file name when program execution is launched
'these variables are all defined in the programmers manual; this is where they are all declared for use by this program

'We start by naming the required input data files, which must be in the format set out in the programmers manual.
'The file names needed for all 3 versions (CSFII, NHANES 1-day, NHANES 2-day) of this program are provided; if you are only interested in one or two of these, just ignore the
'declarations for the irrelevant file names, or rem them out (put an apostrophe at the front of the line, as done in this line)




'The following files and variables with "_NH" are used for both the NHANES 1-day and 2-day support files
Public Const g_c_NPops_NH = 24 'Number of population used with NHANES versions of DEEM-FCID (there are no data on geographic location or season)
Public Const g_c_LastPop_NH = g_c_NPops_NH

Public Const g_c_CatName_NH$ = "Catnamepanh.txt"  'UPC, FF, a list of the active food forms and crop group categories needed by DEEM for NHANES
'This is actual a "passthrough" filename; the file is not opened in this program.  But it is added to list of support files generated by this
'program that is read by DEEM-FCID. It must be generated by the programmer outside this program using a text editor (see programmer manual)
'The following file provides a master list of all active NHANES (NFCS) 8-digit food codes (foods as reported eaten in the surveys) and their programmer-assigned index numbers
Public Const g_c_NFCSIndexFl_NH$ = "NHANESindices99-08.txt" 'UPC, FF a list of all nfcs code/mod code combinations used in the NHANES surveys '1.10
Public Const g_c_RACIndexFl_NH = "FCID-NH-Foods-Sort-d.Txt"  'UPC,FF for NHANES this is list of all RACS with food groups
Public Const g_c_RecipesFl_NH$ = "Recipes_wweia_fcid_1999-08.txt" 'UPC,FF a flat file of all FCID recipes, by NFCS code/mod code, with FCID-RAC ingredients and ratio to total  '1.10
Public Const g_c_SubstituteRecipes_NH$ = "RecipeSubstitutesNH.txt"  'UPC, FF a list of NFCS code/mod code which have no recipe, but instead use a surrogate recipe in the recipe database

Public Const g_c_SurveyFl1_NH$ = "nhintake99-02-fcid"  'root name of survey data for first year
Public Const g_c_NSets1_NH = 1 'number of files in first year survey data set (year here is collection of years)
Public Const g_c_NDays1_NH = 1  'number of days is first set of data (1999-2002)

Public Const g_c_SurveyFl2_NH$ = "nhintake2003-04-fcid"  'root name of survey data for second year
Public Const g_c_NSets2_NH = 1 'number of files in second year survey data set (year here is collection of years)
Public Const g_c_NDays2_NH = 2  'number of days is second set of data (2003-2004)
                                 
Public Const g_c_SurveyFl3_NH$ = "nhintake2005-06-fcid"
Public Const g_c_NSets3_NH = 1 'number of files in third year survey data set (2005-06) (year here is collection of years)
Public Const g_c_NDays3_NH = 2 'number of days in third set of data (2005-2006)

'1.10
Public Const g_c_SurveyFl4_NH$ = "nhintake2007-08-fcid"
Public Const g_c_NSets4_NH = 1 'number of files in fourth year survey data set (2007-08) (year here is collection of years)
Public Const g_c_NDays4_NH = 2 'number of days in fourth set of data (2007-2008)


Public Const g_c_Demographics1_NH$ = "demo99-02.txt"  '1.04 note that the format of this file is not the same as the next two for 2003-2006
Public Const g_c_Demographics2_NH$ = "demographics0304.txt"  '1.04
Public Const g_c_Demographics3_NH$ = "demographics0506.txt"  '1.04
Public Const g_c_Demographics4_NH$ = "demographics0708.txt"  '1.10

'Input Files for CSFII 1994-98
Public Const g_c_CatName_0$ = "Catnamepa.txt"  'UPC, FF, a list of the active food forms and crop group categories needed by DEEM for CSFII

'The following file provides a master list of all active NHANES (NFCS) 8-digit food codes (foods as reported eaten in the surveys) and their programmer-assigned index numbers
Public Const g_c_NFCSIndexFl_0$ = "RCPMod98e.txt"  'UPC, FF a master list of all nfcs code/mod code combinations used in CSFII surveys
Public Const g_c_RACIndexFl_0$ = "EpaFoodw2.txt"  'UPC,FF  for CSFII  (note: this was EpaFoodw2.cod in older versions of DEEM-FCID
Public Const g_c_RecipesFl_0$ = "FCIDRecipes94-98.txt"  'UPC,FF a flat file of all FCID recipes for CSFII 94-96,98, by NFCS code/mod code, with FCID-RAC ingredients and ratio to total
Public Const g_c_SubstituteRecipes_0$ = "RecipeSubstitutes98.txt"  'UPC, FF a list of NFCS code/mod code which have no recipe, but instead use a surrogate recipe in the recipe database
Public Const g_c_WaterFl_0$ = "SAICWater.txt"  'UPC, FF this is the SAIC water data for each individual consistent with CSFII 94-98

Public Const g_c_SurveyFl1_0$ = "CSFII94"  'root name of survey data for first year
Public Const g_c_NSets1_0 = 5 'number of files in first year survey data set
Public Const g_c_NDays1_0 = 2  'number of days in this survey

Public Const g_c_SurveyFl2_0$ = "CSFII95"  'root name of survey data for second year
Public Const g_c_NSets2_0 = 5 'number of files in second year survey data set
Public Const g_c_NDays2_0 = 2 'number of days in this survey

Public Const g_c_SurveyFl3_0$ = "CSFII96"  'root name of survey data for third year
Public Const g_c_NSets3_0 = 5 'number of files in third year survey data set
Public Const g_c_NDays3_0 = 2 'number of days in this survey

Public Const g_c_SurveyFl4_0$ = "CSFII98"  'root name of survey data for fourth year
Public Const g_c_NSets4_0 = 5 'number of files in fourth year survey data set
Public Const g_c_NDays4_0 = 2 'number of days in this survey

'THE FOLLOWING FILES ARE GENERATED BY DSFgen; they list every NFCS code/modification code combinationi used in the CSFII or NHANES surveys



'NHANES general support files (1-day and 2-day):

Public Const g_c_RecipesFlQA_NH$ = "FCIDRecipes99-08QA-d.txt" 'UPN,FF a flat file of all FCID recipes as indexed and processed when the RA recipe files are generated, for QA purposes only
Public Const g_c_RecipeSetIndexRA_NH$ = "EPARecNH99-08-d.ind"  'UPN,RA the index file for recipes generated by this program (these RA recipe files can be used by FARE as well)
Public Const g_c_RecipeSetIngredRA_NH$ = "EPARecNH99-08-d.ing" 'UPN,RA the ingredient file for recipes generated by this program (these RA recipe files can be used by FARE as well)
Public Const g_c_RACSortRA_NH$ = "EpaSortNH-d.ran" 'UPN, numeric and alpha sort data for RACs for DEEM-FCID residue file editor, for NHANES

'NHANES 2-Day specific support files and variables:
Public Const g_c_NFCSCodesUsed_NH2$ = "NFCSCodesUsedNH2-d.txt"  '1.10 UPN,FF
Public Const g_c_SurveyName_NH2$ = "NHANES 2003-2008 2-Day"  '1.10
Public Const g_c_NSurveyYears_NH2 = 3  'nhanes  2003-2004, 2005-2006, 2007-08   '1.10
Public Const g_c_FirstSurveyYear_NH2 = 2  'nhanes  2003-2004 is first part
Public Const g_c_LastSurveyYear_NH2 = 4  'nhanes  2007-2008 is last part


'Chronic means for NHANES 2-day  (output files)
Public Const g_c_MeansFFFileRoot_NH2$ = "ChronicNH-03-08-2d-d"    '1.10 UPN, text file FF intake means by RAC and FF for chronic program (do not include extension)
Public Const g_c_MeansFFFile_NH2$ = "ChronicNHFF-03-08-2d-d.ran"  '1.10 UPN, RA intake means by RAC and FF for chronic program
Public Const g_c_MeansFile_NH2$ = "ChronicNH-03-08-2d-d.ran"      '1.10 UPN,RA intake means by RAC for chronic program

'Acute intake files for NHANES 2-day  (output files)
Public Const g_c_Acute24Fl2_NH2$ = "AcuteNH0304-24-2d-d.ran"  '1.10 name of acute 24-hr intake files, second year
Public Const g_c_AcuteLIFl2_NH2$ = "AcuteNH0304-LI-2d-d.ran"  '1.10 name of acute LI intake files, first year
Public Const g_c_Acute24Fl3_NH2$ = "AcuteNH0506-24-2d-d.ran"  '1.10
Public Const g_c_AcuteLIFl3_NH2$ = "AcuteNH0506-LI-2d-d.ran"  '1.10
Public Const g_c_Acute24Fl4_NH2$ = "AcuteNH0708-24-2d-d.ran"  '1.10
Public Const g_c_AcuteLIFl4_NH2$ = "AcuteNH0708-LI-2d-d.ran"  '1.10

Public Const g_c_FoodsepaRA_NH2$ = "FoodsEPANH2-03-08-d.ran" '1.10 UPN,RA  database of valid RACs w/o foodforms for DEEM FCID main module, 2-day
Public Const g_c_Foodsepa_NH2$ = "FoodsEPANH2-03-08-d.txt"  '1.10 UPN, same info as g_FoodsepaRA_NH2$ but in text file format for QA
Public Const g_c_FFormsepaRA_NH2$ = "FFORMsepaNH2-03-08-d.ran" '1.10 UPN,RA  database of valid RACs with Foodforms for for DEEM FCID main module
Public Const g_c_FFormsepa_NH2$ = "FFORMsepaNH2-03-08-d.txt"  '1.10 text version of g_FFormsepaRA$ for inspection and QA only

Public Const g_c_FileList_NH2$ = "FileListNH2.txt"
Public Const g_c_FileDates_NH2$ = "FileDatesNH2.txt"


'These are old RAC and RAC/FF files that are used to compare with new RAC and RAC/FF file in order to show new RACs and FF's
Public Const g_c_MakeCodeOld1_NH2$ = "03-08-c"
Public Const g_c_FoodsepaOld1_NH2$ = "FoodsEPA03-08-NH2.txt"
Public Const g_c_FFormsepaOld1_NH2$ = "FFORMsepanh2-03-08.FIL"



'These files list the supporting file names and some other parametric data required by each
'of the 3 versions of DEEM-FCID for NHANES 2-day 2003-2008 version:
Public Const g_c_MakeCode_NH2$ = "03-08-d"
Public Const g_c_SupportFileNames_NH2$ = "DEEMlistNH-d.txt"  'UPN, FF



'Public Const g_c_MakeCodeOld2_NH2$ = "03-06-a"
'Public Const g_c_FoodsepaOld2_NH2$ = "FoodsEPA99-06-NH2.txt"  'same set as old1 but used to test code
'Public Const g_c_FFormsepaOld2_NH2$ = "FFORMsepaNH2.FIL"

'Public Const g_c_MakeCodeOld3_NH2$ = "n/a"
'Public Const g_c_FoodsepaOld3_NH2$ = "n/a"
'Public Const g_c_FFormsepaOld3_NH2$ = "n/a"


'NHANES 1-Day specific support files and variables:
Public Const g_c_NFCSCodesUsed_NH1$ = "NFCSCodesUsedNH1.txt"  '1.10 UPN,FF
Public Const g_c_SurveyName_NH1$ = "NHANES 1999-2006 1-Day"  '
Public Const g_c_FirstSurveyYear_NH1 = 1  'nhanes 1999-2002 is first part
Public Const g_c_LastSurveyYear_NH1 = 3  'nhanes 2005-2006 is last part
Public Const g_c_NSurveyYears_NH1 = 3  'nhanes 1999-2002, 2003-2004, 2005-2006
'Chronic means for NHANES 1-day
Public Const g_c_MeansFFFileRoot_NH1$ = "ChronicNH-1d"  '2.0 UPN, text file FF intake means by RAC and FF for chronic program (do not include extension)
Public Const g_c_MeansFFFile_NH1$ = "ChronicFFNH-1d.ran"  '2.0 UPN, RA intake means by RAC and FF for chronic program
Public Const g_c_MeansFile_NH1$ = "ChronicNH-1d.ran"  '2.0 UPN, RA intake means by RAC for chronic program

'Acute intake files for NHANES 1-day (output files)
Public Const g_c_Acute24Fl1_NH1$ = "AcuteNH9902-24-1e.ran"  'name of acute 24-hr intake files, first year
Public Const g_c_AcuteLIFl1_NH1$ = "AcuteNH9902-LI-1e.ran"  'name of acute LI intake files, first year
Public Const g_c_Acute24Fl2_NH1$ = "AcuteNH0304-24-1e.ran"  'name of acute 24-hr intake files, second year
Public Const g_c_AcuteLIFl2_NH1$ = "AcuteNH0304-LI-1e.ran"  'name of acute LI intake files, first year
Public Const g_c_Acute24Fl3_NH1$ = "AcuteNH0506-24-1e.ran"
Public Const g_c_AcuteLIFl3_NH1$ = "AcuteNH0506-LI-1e.ran"

Public Const g_c_FoodsepaRA_NH1$ = "FoodsEPANH1-99-08.ran" '1.03 UPN,RA  database of valid RACs w/o foodforms for DEEM FCID main module, 1-day
Public Const g_c_Foodsepa_NH1$ = "FoodsEPANH1-99-08.txt"  '1.10 UPN, same info as g_FoodsepaRA_NH1$ but in text file format for QA
Public Const g_c_FFormsepaRA_NH1$ = "FFORMsepaNH1-99-08.ran" '1.10 UPN,RA  database of valid RACs with Foodforms for for DEEM FCID main module
Public Const g_c_FFormsepa_NH1$ = "FFORMsepaNH1-99-08.txt"  '1.10 text version of g_FFormsepaRA$ for inspection and QA only

Public Const g_c_FileList_NH1$ = "FileListNH1.txt"
Public Const g_c_FileDates_NH1$ = "FileDatesNH1.txt"

'These files list the supporting file names and some other parametric data required by each
'of the 3 versions of DEEM-FCID for NHANES 1-day 1999-2008 version:
Public Const g_c_MakeCode_NH1$ = "99-08-a"
Public Const g_c_SupportFileNames_NH1$ = "DEEMlistNH1.txt"  'UPN, FF


'CSFII 2-day
Public Const g_c_RecipesFlQA_0$ = "FCIDRecipes94-98QA.txt"  'UPN,FF a flat file of all FCID recipes as indexed and processed when the RA recipe files are generated, for QA purposes only
Public Const g_c_RecipeSetIndexRA_0$ = "EPARec98test.ind"  'UPN,RA the index file for recipes generated by this program (these RA recipe files can be used by FARE as well)
Public Const g_c_RecipeSetIngredRA_0$ = "EPARec98test.ing" 'UPN,RA the ingredient file for recipes generated by this program (these RA recipe files can be used by FARE as well)

Public Const g_c_NFCSCodesUsed_0$ = "NFCSCodesUsed0.txt"  'UPN,FF
Public Const g_c_RACSortRA_0$ = "EpaSortw2.ran" 'UPN, numeric and alpha sort data for RACs for DEEM-FCID residue file editor
Public Const g_c_SurveyName_0$ = "CSFII 1994-96, 1998"  'this is the name of the current survey, for reference.  This is not a file
Public Const g_c_NSurveyYears_0 = 4  'csfii 1994. 1995, 1996, 1998
Public Const g_c_FirstSurveyYear_0 = 1  'csfii 1994 is first part
Public Const g_c_LastSurveyYear_0 = 4  'csfii 1998 is last part
'Chronic means for CSFII
Public Const g_c_MeansFFFileRoot_0$ = "mean4568test2"  '2.0 UPN, FF intake means by RAC and FF for chronic program (do not include extension;
Public Const g_c_MeansFFFile_0$ = "meanFFepa98test.ran"  '2.0 UPN, RA, intake means by RAC and FF for chronic program
Public Const g_c_MeansFile_0$ = "meanepa98test.ran"  '2.0 UPN,RA intake means by RAC for chronic program


'Intake files for csfii acute analysis  (output files), now obsolete
Public Const g_c_Acute24Fl1_0$ = "AcuteTest9424.ran"  'name of acute 24-hr intake files, first year
Public Const g_c_AcuteLIFl1_0$ = "AcuteTest94LI.ran"  'name of acute LI intake files, first year

Public Const g_c_Acute24Fl2_0$ = "AcuteTest9524.ran"  'name of acute 24-hr intake files, second year
Public Const g_c_AcuteLIFl2_0$ = "AcuteTest95LI.ran"  'name of acute LI intake files, second year

Public Const g_c_Acute24Fl3_0$ = "AcuteTest9624.ran"  'name of acute 24-hr intake files, third year
Public Const g_c_AcuteLIFl3_0$ = "AcuteTest96LI.ran"  'name of acute LI intake files, third year

Public Const g_c_Acute24Fl4_0$ = "AcuteTest9824.ran"  'name of acute 24-hr intake files, fourth year
Public Const g_c_AcuteLIFl4_0$ = "AcuteTest98LI.ran"  'name of acute LI intake files, fourth year

Public Const g_c_FoodsepaRA_0$ = "FoodsEPAW2.ran"  'UPN,RA  database of valid RACs w/o foodforms for DEEM FCID main module (same for both 1- and 2-day analyses)
Public Const g_c_Foodsepa_0$ = "FoodsEPAw08.txt"  'UPN, same info as g_FoodsepaRA$ but in text file format for QA

Public Const g_c_FFormsepaRA_0$ = "FFORMsepa98w.ran" 'UPN,RA  database of valid RACs with Foodforms for for DEEM FCID main module
Public Const g_c_FFormsepa_0$ = "FFORMsepa98w.FIL"  'text version of g_FFormsepaRA$ for inspection and QA only

Public Const g_c_PIDFileRA$ = "PID98b.ran"  'this is for CSFII,  not needed with nhanes

Public Const g_c_FileList_0$ = "FileList.txt"
Public Const g_c_FileDates_0$ = "FileDates.txt"

Public Const g_c_MakeCode_0$ = "94-98-a"
Public Const g_c_SupportFileNames_0$ = "DEEMlist98.txt"   'UPN, FF


'These are general constants not associated with any one survey:

Public Const g_c_CompareFile$ = "CompareRACFF.txt"  'file name of compare file for RACs and Foodforms between different support file sets
Public Const g_c_NHeaderLinesMeansFLRoot = 5  'number of doc lines in g_MeansFile$ (number of lines to skip over when reading this file for content)
Public Const g_c_FirstPop = 1  'does not vary with survey; these are provided so that you can calculate intake means for specific populations for QA, but you cannot proceed to assemble all means for DEEM until all g_NPops populations are computed


'THESE NUMERIC CONSTANTS RELATED TO POPULATIONS MUST BE PROVIDED BY THE USER, AND MUST BE CONSISTENT WITH THE PROGRAM CODE

Public Const g_c_NPops_0 = 33  'Number of populations used with CSFII in DEEM-FCID
Public Const g_c_LastPop_0 = g_c_NPops_0  '2.0  ditto


'These are global variable used in this program

Public g_RACIndexFl$ 'name of file with all RACs in the current recipe set, indexed
'note: I used fcidingrednames.vbp to extract RAC names from recipes file for NHANES
Public g_Maxi   'number of RACs in the RAC index file
Public g_CancelRun  'cancels current analysis
Public g_TotUSOnly 'run only the total us pop when computing chronic means
Public g_CGFFNames$  'name of file that contains crop group and food form names (pass through to DEEM-FCID, not actually opened in this program
Public g_NFCSIndexFl$ 'name of file with all NHANES (NFCS) codes and relevant modification codes, indexed
Public g_RACSortRA$  'name of file (RA) with sort order for the RAC index file (both numeric and alpha sort)
Public g_RecipesFl$  'name of file containing the recipe data to be used by this program
Public g_RecipesFlQA$ 'name of file containing the indexed recipe data to be used by this program
Public g_NFCSCodesUsed$ 'name of file listing all NHANES (NFCS) codes
Public g_RecipeSetIndexRA$  'name of RA file with recipe indices
Public g_RecipeSetIngredRA$ 'name of RA file with recipe ingredients
Public g_SubstituteRecipes$ 'name of file with substitute recipe info
Public g_SurveyName$  'name of current survey being processed (CSFII, NHANES 1-day, NHANES 2-day
Public g_NPops  'number of populations for which chronic means are calculated
Public g_LastPop 'the numerical location (1 - g_NPops) of the last chronic means set to be calculated at the current step
Public g_WaterFl$ 'name of water file (SAIC)
Public g_NSurveyParts  'number of year sets in survey: CSFII = 4 (1994, 94, 96, 98), NHANES = 3 (1999-2002, 2003-04, 2005-06)
Public g_FirstSurveyYear 'first year set to process in a given analysis
Public g_LastSurveyYear 'last year set to process in a given analysis
Public g_SurveyFl1$  'filename of survey first year set (input)
Public g_SurveyFl2$  'filename of second year set (input)
Public g_SurveyFl3$  'filename of third year set (input)
Public g_SurveyFl4$  'filename of fourth year set (input)
Public g_NSets1  'number of parts to survey first year set (input)
Public g_NSets2  'number of parts to survey second year set (input)
Public g_NSets3  'number of parts to survey third year set (input)
Public g_NSets4  'number of parts to survey fourth year set (input)
Public g_Acute24Fl1$  'filename of first year survey set, 24 hour total (output)
Public g_Acute24Fl2$   'second
Public g_Acute24Fl3$   'third
Public g_Acute24Fl4$   'fourth
Public g_AcuteLIFl1$  'filename of first year survey set, line item (output)
Public g_AcuteLIFl2$  'second
Public g_AcuteLIFl3$  'third
Public g_AcuteLIFl4$  'fourth
Public g_NDays  'number of days of intake data per individual in the current survey year
Public g_aNDays() 'number of days of intake data per individual in survey (array of all years)
Public g_MeansFFFileRoot$  'root filename of means file generated by this program (by RAC and ff)
Public g_MeansFFFile$  'full filename of means file generated by this program (by RAC and ff)
Public g_MeansFile$  'full filename of means file generated by this program (by RAC only)
Public g_FoodsepaRA$  'the database of valid RACs w/o foodforms for DEEM FCID main module in Random Access format"
Public g_Foodsepa$    'the flat file equivalent of the above file
Public g_FFormsepaRA$ 'the database of valid RACs wiht foodforms for DEEM FCID main module in Random Access format"
Public g_FFormsepa$   'the flat file equivalent of the above file
Public g_SupportFileNames$  'the list of all files generated by this program to be read by DEEM and its modules
Public g_MakeCode$  'the version code for this set of supporting files
Public g_FileList$  'a documentation list of files names that will be used by this program to generate DEEM support files
Public g_FileDates$ 'a documentation list of files generated by this program with dates

Public g_MakeCodeOld1$  'first older Make version for comparison of RAC and FF codes used
Public g_FoodsepaOld1$  'RAC file generated with first older Make version
Public g_FFormsepaOld1$  'RAC/FF file generated with first older Make version
Public g_MakeCodeOld2$   'etc.
Public g_FoodsepaOld2$   'etc.
Public g_FFormsepaOld2$
Public g_MakeCodeOld3$
Public g_FoodsepaOld3$
Public g_FFormsepaOld3$

'These are variables available throughout this module, but not to other modules
'these all need to be changed to m_ instead of g_
Dim g_RecipeLineSpace

Dim g_a_NFCS&()  'array of NFCS (NHANES) codes
Dim g_a_Mod&()   'array of modification codes
Dim g_a_NFCSModIndex() 'array of NFCS/Mod code combo indices
Dim g_a_SortCode$()  'array of variables to be sorted by the sort routine
Dim g_trac#()  'array with total amount of intake by RAC for all FF under that RAC
Dim g_racnw&()  'array of users weighted with stat wts
Dim g_racnu&()  'array of users unweighted
Dim g_FFx()  'array of specific foodforms under each RAC consumed
Dim g_TotDW#  'total drinking water amount (before dividing by number of participants to get mean)
Dim g_nw&  'total population weighted (of defined pop group)
Dim g_nu&  'total population unweighted
Dim g_NDrinkingWaterDaysW&  'number of drinking water days, weighted
Dim g_NDrinkingWaterDaysu&  'number of drinking water days, unweighted
Dim g_NSubRecs  'number of substitute recipes
Dim g_SubRec&() 'arrray of NFCS (NHANES) codes in substitute recipe file
Dim g_SubMod&() 'arrray of modification codes in substitute recipe file
Dim g_SubInd()  'array of index numbers in substitute recipe file
Dim g_MaxNDays  'maximum number of days of intake for any individual in the current survey
Dim g_WaterTimeEst()  '1.02

Dim g_PIDNew&  '1.04


'the following type declarations define the record layout of the random access files generated by this program.
'You must make sure that these same declarations are used in the DEEM programs; if you modify any of these
'record types here you must modify the corresponding type declaration in the DEEM program(s) where these files are used

Type RCPIndex  'recipe index record spec (both CSFII and NHANES)
  nfcs As Long
  mod As Long
  epa As Integer
  FF As Integer
  numing As Integer
  firstrec As Long
End Type

Type RCPIngr  'recipe ingredient record spec  (both CSFII and NHANES)
  epaingr As String * 10
  ingcode As Integer
  FF As Integer
  perc As Single
End Type

'means for CSFII 94-98, 33 subpopulations
Type means  'chronic means spec for all 33 subpopulations
'note: if you change the number of subpopulations you need to modify the subscript here as well
  NSI As Integer
  FF As Integer
  epa As String * 8
  mean(1 To 33) As Single  'note that this upper value must correspond to g_NPops but VB does not allow you to place the variable name here
End Type

'means for NHANES  '24 subpopulations
Type meansNH  'chronic means spec for all 24 subpopulations
'note: if you change the number of subpopulations you need to modify the subscript here as well
  NSI As Integer
  FF As Integer
  epa As String * 10
  mean(1 To 24) As Single  'note that this upper value must correspond to g_NPops but VB does not allow you to place the variable name here
End Type

Type FOODREC98  'RAC definition file  (CSFII)
   NSI As Integer       'index
   fdcd As String * 8   'RAC code (8-digit)
   cat As String * 3    'crop group code
   cf As Single         'default conversion factor (1.0)
   fdnm As String * 39  'RAC name
   nff As Integer       'number of food forms
   fff As Integer       'record number of first food form
End Type

Type FOODRECNH  'RAC definition file  (NHANES)
   NSI As Integer       'index
   fdcd As String * 10   'RAC code (10-digit)
   cat As String * 3    'crop group code
   cf As Single         'default conversion factor (1.0)
   fdnm As String * 39  'RAC name
   nff As Integer       'number of food forms
   fff As Integer       'record number of first food form
End Type


Type FFORMSREC  'foodform definition file (both CSFII and NHANES)
   ffcd As Integer  'foodform code
   ffcf As Single   'foodform concentration factor (all 1.0 for now, historically these were more varied)
End Type


Type IndexRACx  'file which provides the secondary index number for a given RAC as represented by a primary index number (1-556 at present)
'this was essential in CSFII, in NHANES there is no difference between these numbers
  Index As Integer  '(both CSFII and NHANES)
End Type

Type rechh   'household record, most of this pertains to CSFII since NHANES is not organized by HH
  rectype As String * 1 'H
  hhid As Long
  varstrat As Integer
  varunit As Integer
  REGION As String * 1
  urb As String * 1
  hhsize As Integer
  income As Long
  pctpov As Integer
  povcat As String * 1
  fsrcv12 As String * 1
  headf As String * 1
  headm As String * 1
  h20cook As Integer
  h20bevr As Integer
  h20drnk As Integer
  cntd1 As Integer
  cntd2 As Integer
End Type

Type fooddata  'CSFII
   rectype As String * 1
   FoodCode As Long
   FCIndex As Integer
   ModCode As Long
   mcindex As Integer
   FoodAmt As Single
   OccTime As Integer
   occname As Integer
   foodsrce As Integer
   eathome As String * 1
   everhome As String * 1
   combnum As Integer
   combtype As Integer
   saltused As String * 1
   water As Single
   caleq As Single
End Type

'Type spdata1
'   rectype As String * 1
'   hhid As Long
'   SPNUM As Integer
'   linelet As String * 1
'   Age As Integer
'   Sex As String * 1
'   Race As String * 1  '1 = hispanic, 2 = white (non-hisp), 3 = black (non-hisp), 4 = other
'   Origin As String * 1  'not used in deem or calendex with NHANES
'   headhh As String * 1
'   PLStat As String * 1
'   BFStat As String * 1
'   fsauth As String * 1
'   compd1 As String * 1
'   compd2 As String * 1
'   WtDay1 As Long
'   Wt2Day As Long
'   PID As Integer
'   indhhinc As Integer   '1.04 household income (need coded list)
'   indfminc As Integer   '1.04 family income used when hh income is not known
'   indfmpir As Single    '1.04 ratio of family income to poverty level
'End Type

Type spdata1  '1.10 note that this adds one more byte to the record length
   rectype As String * 1
   hhid As Long
   SPNUM As Integer
   linelet As String * 1
   Age As Integer
   Sex As String * 1
   Race As String * 1  '1 = hispanic, 2 = white (non-hisp), 3 = black (non-hisp), 4 = other
   Origin As String * 1  'not used in deem or calendex with NHANES
   headhh As String * 1
   PLStat As String * 1
   BFStat As String * 1
   fsauth As String * 1
   compd1 As String * 1
   compd2 As String * 1
   WtDay1 As Long
   Wt2Day As Long
   PID As Long
   indhhinc As Integer   '1.04 household income (need coded list)
   indfminc As Integer   '1.04 family income used when hh income is not known
   indfmpir As Single    '1.04 ratio of family income to poverty level
End Type


'the following changes in spdata2 were made at 1.05, they should not change record length
'but this new record definition must be used in DEEM Acute, Calendex,  DMFgen, and combfilenh
Type spdata2 'len = 35
   rectype As String * 1
   hgtsp As Integer
   wgtsp As Single '1.05  '4 bytes
   bmi As Single  '1.05   '4 bytes
   
   'hhid As Long  'remd 1.05  '4 bytes
   'SPNUM As Integer 'remd 1.05 '2 bytes
   'wgtsp As integer '1.05  '2 bytes
   
   D1Mnth As Integer
   D1Date As Integer
   D1Year As String * 1
   D1Day As String * 1
   D1NRec As Integer
   D1H2Oo As Integer
   d1h2oh As String * 1
   d1h2oa As String * 1
   D2Mnth As Integer
   D2Date As Integer
   D2Year As String * 1
   D2Day As String * 1
   D2NRec As Integer
   D2H2Oo As Integer
   d2h2oh As String * 1
   d2h2oa As String * 1
End Type

Type lookup  'RAC/FF indices for FCID  CSFII and NHANES
  FFIndex As Integer
End Type

Type RACFF24hr  '24 hour totals for each RACFF  CSFII and NHANES
  Rac As Integer
  amount As Single
End Type

Type RACFFLineItem  'Line item amounts for each RACFF  CSFII and NHANES
  Rac As Integer
  amount As Single
  time As Integer
End Type

Type FoodEPA  'this is  record format for RAC index file (EpaSortW.ran in old DEEM-FCID)  CSFII and NHANES
  EPARAC As Integer
  Alpha As Integer
End Type

Type PIDxx  'CSFII and NHANES
  hhidt As Long
  indivt As Long
End Type

Sub ReadSurvey(mode)
'This is the primary work module in this program; is has all of the following functions, depending on the
'value of the mode variable:

'mode = 1  read dietary survey for parsing and data check
'mode = 2  check the nfcs codes in dietary survey to make sure they are indexed properly
'mode = 3  generate chronic means for each subpop
'mode = 4  generate 24-hour acute intake file
'mode = 5  generate line item acute intake file
'As of this writing the water-related intake data are not available for NHANES (g_c_NHANES > 0)

'These are variable names available only to this subroutine

Dim hh As rechh
Dim LastPop
Dim EPARAC$(), RACNamex$(), SortIndex(), RACIndex(), EPAIndex()
Dim SortVar$()
Dim infwt!(), agewt!()
Dim MaxRACIndex, MaxNFCSIndex
Dim a_ProblemCodes$(), a_IndexUsed()
Dim bu
Dim PC 'problem code index
Dim tp, fcx$
Dim a$
Dim Fl94$, Fl95$, Fl96$, Fl98$
Dim SurveyYear
Dim SetNo
Dim Survey$(), NSets()
Dim Demog$()  '1.04
Dim d, f, i, j
Dim Flag
Dim d2, f2
Dim hhid&, REGION, cntd1, cntd2
Dim LastHHID&, LastPid&
Dim SPNUM&, PID&, wgtsp!, hgtsp
Dim Sex, Age, AgeM, BFStat, PLStat, Origin, Race, Wt2Day&, D1Year, D1Mnth, D1Date, D1Day, D1H2Oo!, D1NRec, D2Year, D2Mnth, D2Date, D2Day, D2H2Oo, D2NRec&
Dim FoodCode&, FCIndex, ModCode&, FoodAmt!, OccTime
Dim NFoods()
Dim RecordsPassed
Dim Pop$()
Dim rcpind As RCPIndex
Dim rcping As RCPIngr
Dim popx
Dim nff
Dim Index
Dim Recno&, keepgoing, NF(), TNF
Dim RACx$, FF
Dim LastRAC$
Dim ffmain, ffmainold, ffing, ffingold
Dim c!
Dim k, n, x
Dim RACName$
Dim tracx#, tracux#, tracw$, tracu$, racu$, racw$, ii$, ffxx$
Dim rac8$
Dim AcuteFl$()
Dim NRacFF
Dim FileList$
Dim nffx(), fffx()
Dim FOOD98 As FOODREC98
Dim FOODNH As FOODRECNH
Dim FFORMS As FFORMSREC
Dim RXX As lookup
Dim FFIndex
Dim Ilong&, IHigh&
Dim Water1!, Water2!, Water3!  '2.0
Dim StatWt2yr!, StatWt4yr!  '2.0  'for nhanes 2003-2006
Dim StatWtDay1!, StatWt2Day!  '2.0  for nhanes 1999-2002
Dim DayofWeek() '2.0
Dim WaterPlain(), WaterTap(), WaterBot(), WaterCarb(), WaterTapSource()
Dim ridreth1, ridreth2  '2.0
Dim Dummy!  '2.0  (dummy variable)
Dim bmi!  '2.0
Dim BfStat1, BfStat2
Dim pidx As PIDxx
Dim WaterIndirectIndex(), WaterDirectIndex()

g_PIDNew& = 0 '1.04

If mode = 5 Then
  ReDim g_WaterTimeEst(6)
  g_WaterTimeEst(1) = 730
  g_WaterTimeEst(2) = 1030
  g_WaterTimeEst(3) = 1330
  g_WaterTimeEst(4) = 1630
  g_WaterTimeEst(5) = 1930
  g_WaterTimeEst(6) = 2230

End If
  
If mode = 3 Then  'chronic means, limit the number of populations to all US or all populations
  If g_TotUSOnly Then
    LastPop = 1
  Else
    LastPop = g_NPops
  End If
End If

If mode = 3 Or mode = 4 Or mode = 5 Then
  'find the largest index number used for any RAC, maxracindex, by examining the RAC index file
     
  If Len(Dir(g_RACIndexFl$)) = 0 Then  '
    MsgBox "Can't find file " & g_RACIndexFl$ & " in current directory " & CurDir, vbInformation, "Make Random Access Recipe Files"
    Exit Sub
  Else
    Open g_RACIndexFl$ For Input As #1
    MaxRACIndex = 0
    While Not EOF(1)
      Input #1, RACx$, Index
      Line Input #1, RACName$
      If Index > MaxRACIndex Then MaxRACIndex = Index
    Wend
    Close 1
  End If
End If

If mode = 3 Then  'set up EPARAC$() array with rac codes, indexed by their index number

  Open g_RACIndexFl$ For Input As #1
  ReDim EPARAC$(MaxRACIndex)

  While Not EOF(1)
    Input #1, RACx$, Index
    If RACx$ <= LastRAC$ Then  'check to make sure all RAC codes are in numerical order
      MsgBox "Error in file " & g_RACIndexFl$ & ". The RACs must be increasing numerical order; after " & Str(LastRAC$) & " the RAC in this file violates this rule. Leave no spaces between lines. Can't continue until this is fixed.", vbInformation, "Make Random Access Recipe Files"
      Close 1
      Exit Sub
    Else
      LastRAC$ = RACx$
    End If
    
    EPARAC$(Index) = RACx$   'note that EPARAC$() (the 8-digit RAC code in csfii, 10-digit for nhanes) is indexed using the index number assigned, which is not the same as using a simple sequential count (there are missing index numbers so you can't just do a sequential count here)
    Line Input #1, RACName$
  Wend
  Close 1
     
End If


If mode = 4 Or mode = 5 Then  'assumes that mode = 3 has already been performed, so that the foodforms file needed is available
  'generate temp lookup file (RA) that can be used to quickly index RAC/ff combinations encountered when computing acute intake files

  frmDSFGen.txtProgress.Text = "Making temporary food-FF look-up array"
  frmDSFGen.Refresh
    
  ReDim ITASx(MaxRACIndex)
  'markkk
  If g_c_NHANES = 0 Then
    Open g_FoodsepaRA$ For Random As #1 Len = Len(FOOD98)
  Else
    Open g_FoodsepaRA$ For Random As #1 Len = Len(FOODNH)
  End If

  ReDim nffx(MaxRACIndex), fffx(MaxRACIndex)
  For i = 1 To MaxRACIndex
    If g_c_NHANES = 0 Then
      Get #1, , FOOD98
      nffx(i) = FOOD98.nff
      fffx(i) = FOOD98.fff
    Else
      Get #1, , FOODNH
      nffx(i) = FOODNH.nff
      fffx(i) = FOODNH.fff
    End If
  Next
  Close 1

  Open g_FFormsepaRA$ For Random As #5 Len = Len(FFORMS)  'get list of food forms used for any RAC in the chronic means analysis
  If Len(Dir("lookuptemp.ran")) Then Kill "lookuptemp.ran"
  Open "lookuptemp.ran" For Random As #9 Len = Len(RXX)   'output for ACUTE files

  RXX.FFIndex = 0
  IHigh& = MaxRACIndex
  IHigh& = IHigh& * 1000
  For Ilong& = 1 To IHigh&  'ZERO OUT FILE FIRST
    Put #9, Ilong&, RXX
  Next
  
  For i = 1 To MaxRACIndex
    If nffx(i) > 0 Then

      For j = 1 To nffx(i)
        FFIndex = fffx(i) - 1 + j
        Get #5, FFIndex, FFORMS
        Recno& = (i - 1)
        Recno& = Recno& * 1000
        Recno& = Recno& + FFORMS.ffcd
        RXX.FFIndex = FFIndex
  ' If RXX.FFIndex = 0 Then Stop
        Put #9, Recno&, RXX
      Next
    End If
  Next
  Close 5  'don't close 9, this is the index lookup file

  Call GetNRACFF(NRacFF)  'net number of active RAC/ff combinations found when applying recipes to this survey
  
  frmDSFGen.txtProgress.Text = ""
  frmDSFGen.Refresh
  
End If


'for the current analysis, determine the first and last intake data sets to be used
If g_c_NHANES = 0 Then
  g_FirstSurveyYear = g_c_FirstSurveyYear_0
  g_LastSurveyYear = g_c_LastSurveyYear_0
ElseIf g_c_NHANES = 1 Then
  g_FirstSurveyYear = g_c_FirstSurveyYear_NH1
  g_LastSurveyYear = g_c_LastSurveyYear_NH1
ElseIf g_c_NHANES = 2 Then
  g_FirstSurveyYear = g_c_FirstSurveyYear_NH2
  g_LastSurveyYear = g_c_LastSurveyYear_NH2
End If
'Call SetUpSurvey(Survey$(), NSets())
Call SetUpSurvey(Survey$(), NSets(), Demog$())  '1.04 get intake data file names needed for this analysis

If mode = 3 Then  'chronic means
  
  Call PopulationNames(Pop$())
  
  If Len(Dir(g_RecipeSetIndexRA$)) = 0 Or Len(Dir(g_RecipeSetIngredRA$)) = 0 Then
    MsgBox "Files " & g_RecipeSetIndexRA$ & " and/or " & g_RecipeSetIngredRA$ & " cannot be located in the current folder (" & CurDir & ").", vbInformation, "Generate Means for Chronic"
    Exit Sub
  End If
End If

If mode = 3 Or mode = 4 Or mode = 5 Then
  'open recipe files
  If Len(Dir(g_SubstituteRecipes$)) Then   'read in recipe subsitutes
    bu = 0
    Call ReadSubRecipes(bu)
    If bu Then Exit Sub
  End If
  
  Open g_RecipeSetIndexRA$ For Random As #2 Len = Len(rcpind) 'recipe files
  Open g_RecipeSetIngredRA$ For Random As #3 Len = Len(rcping)
  Get #2, 1, rcpind
  If rcpind.epa <> 1 Then Stop
  Get #3, 1, rcping
      
End If  'open recipes


If g_c_NHANES = 0 Then  'temp until we have water intake data for nhanes
 
 If mode = 3 Or mode = 4 Then
    'when more hourly water data are available for future surveys, then you want to include mode = 5 here as well
    
  If Len(Dir(g_WaterFl$)) = 0 Then
    'g_WaterFl$ has water data for each individual (with 2 days of valid intake data) in all years of the CSFII 94-98 survey
    MsgBox "File " & g_WaterFl$ & " cannot be located in the current folder (" & CurDir & ").", vbInformation, "Generate Means for Chronic"
    Exit Sub
  End If
  'water file is opened later along with the survey files
 End If
End If

  
If mode = 3 Then  'chronic means
  
  bu = 0 'abort code
  Call SetUpNFCSIndices(MaxNFCSIndex, mode, WaterDirectIndex(), WaterIndirectIndex(), bu)
  If bu = 1 Or g_Maxi = 0 Then
    Close
    Exit Sub
  End If
        
  ReDim infwt!(2, 11), agewt!(2, 100)
  Call compbw(infwt!(), agewt!())  'get average body weights by age and sex to use where no body weight is reported in survey
  'these body weights are in lbs, will be converted to kg later
  
  If g_c_NHANES = 0 And g_TotUSOnly = 1 Then
    If Len(Dir(g_c_PIDFileRA$)) Then Kill g_c_PIDFileRA$
    Open g_c_PIDFileRA$ For Random As #20 Len = Len(pidx)
    Open "PIDtest.txt" For Output As #21
  End If
  

  For popx = g_c_FirstPop To LastPop
    g_PIDNew& = 0  '1.10
    SurveyYear = g_FirstSurveyYear  'this is the index used for cycling through the yearly survey files
    SetNo = 1 'initialization of data file within year, csfii only
    RecordsPassed = 0
    g_CancelRun = 0
    LastHHID& = 0
    
    nff = 100  'arbitrary upper limit for number of active food forms
    ReDim g_trac#(MaxRACIndex, nff)
    ReDim g_racnw&(MaxRACIndex, nff)
    ReDim g_racnu&(MaxRACIndex, nff)
    ReDim g_FFx(MaxRACIndex, nff)

    g_nw& = 0
    g_nu& = 0
    g_NDrinkingWaterDaysW& = 0
    g_NDrinkingWaterDaysu& = 0
    g_TotDW# = 0
    
    GoSub ReadSurveyFile
    GoSub WriteRecord
  Next popx
  Close 2, 3
  GoTo FinishUp

Else  'all other modes
  bu = 0 'abort code
  
  If mode = 2 Then
    'read in the file with NFCS code indices (as set up by Petersen, to be expanded manually when new survey data are included
    'read once to find max index for dimensioning and check to see that all nfcs/mod codes are in strict ascending order, then read again to fill in arrays
    
    Call SetUpNFCSIndices(MaxNFCSIndex, mode, WaterDirectIndex(), WaterIndirectIndex(), bu)
    
    If bu = 1 Or g_Maxi = 0 Then
      Close
      Exit Sub
    End If
            
    ReDim a_ProblemCodes$(2000, 3)  'Array of nfcs codes/mod codes encountered without indices, if any
    'first index: 2000 is arbitrary, second index: 1 = foodcode, 2 = modcode, 3 = number of times encountered
    ReDim a_IndexUsed(g_Maxi)  'Array of valid indices that have been used
    PC = 0  'problem code index (no match)
    
  End If
    
  If mode = 4 Or mode = 5 Then  'generate acute intake files
  
    Call SetUpNFCSIndices(MaxNFCSIndex, mode, WaterDirectIndex(), WaterIndirectIndex(), bu)
    If bu = 1 Or g_Maxi = 0 Then
      Close
      Exit Sub
    End If
        
    ReDim infwt!(2, 11), agewt!(2, 100)
    Call compbw(infwt!(), agewt!())
    
    ReDim AcuteFl$(g_FirstSurveyYear To g_LastSurveyYear)
    'because the nhanes 2-day starts with 2 and ends with 3
    'the following may need to be modified if g_NSurveyParts <> 4
    If mode = 4 Then  '24-hour
      If g_c_NHANES = 0 Then
        AcuteFl$(1) = g_Acute24Fl1$
        AcuteFl$(2) = g_Acute24Fl2$
        AcuteFl$(3) = g_Acute24Fl3$
        AcuteFl$(4) = g_Acute24Fl4$
      ElseIf g_c_NHANES = 1 Then
        AcuteFl$(1) = g_Acute24Fl1$
        AcuteFl$(2) = g_Acute24Fl2$
        AcuteFl$(3) = g_Acute24Fl3$
      ElseIf g_c_NHANES = 2 Then
        AcuteFl$(2) = g_Acute24Fl2$
        AcuteFl$(3) = g_Acute24Fl3$
        AcuteFl$(4) = g_Acute24Fl4$  '1.10
      End If
      
    Else 'mode = 5, LI = Line item
      If g_c_NHANES = 0 Then
        AcuteFl$(1) = g_AcuteLIFl1$
        AcuteFl$(2) = g_AcuteLIFl2$
        AcuteFl$(3) = g_AcuteLIFl3$
        AcuteFl$(4) = g_AcuteLIFl4$
      ElseIf g_c_NHANES = 1 Then
        AcuteFl$(1) = g_AcuteLIFl1$
        AcuteFl$(2) = g_AcuteLIFl2$
        AcuteFl$(3) = g_AcuteLIFl3$
      ElseIf g_c_NHANES = 2 Then
        AcuteFl$(2) = g_AcuteLIFl2$
        AcuteFl$(3) = g_AcuteLIFl3$
        AcuteFl$(4) = g_AcuteLIFl4$  '1.10
      End If
    End If
    
    For i = g_FirstSurveyYear To g_LastSurveyYear  'start over so that file length will not be artifact of previous version
      If Len(Dir(AcuteFl$(i))) Then Kill AcuteFl$(i)
    Next
            
    popx = 1 'set up acute files for all individuals
  
  End If  'mode = 4 or 5


  'read and check the basic survey data
  'if you set up the survey data somewhat differently you will have to adjust the input lines accordingly
  'try to use the same variables where possible
  
  SurveyYear = g_FirstSurveyYear  'this is the index used for cycling through the yearly survey files
  SetNo = 1 'initialization of data file within year, csfii only
  RecordsPassed = 0
  g_CancelRun = 0
  LastHHID& = 0
  GoSub ReadSurveyFile
  Close 2, 3
  
  GoTo FinishUp
  
End If  'mode <> 3

Stop
End 'should not get to here


ReadSurveyFile:

'SurveyYear is set to start with 1 for csfii and nhanes 1-day, starts with 2 for nhanes 2-day
'Start here with first intake file (1 for csfii, 1 for 1-day, 2 for 2-day)

Open Survey$(SurveyYear) & "." & Trim(Str(SetNo)) For Input As #1

If g_c_NHANES Then
  Close 30
  Open Demog$(SurveyYear) For Input As #30  '1.04
  Line Input #30, a$ '1.04  the header line was not in the 1999-2002 demographics file
End If

g_MaxNDays = 0  'will be max number of days in all years for this survey
g_NDays = g_aNDays(SurveyYear)
If g_NDays > g_MaxNDays Then g_MaxNDays = g_NDays

If mode = 4 Or mode = 5 Then
  If SetNo = 1 Then  'first data set within year (only csfii has more than one data set per year)
    Close 5
    Open AcuteFl$(SurveyYear) For Binary As #5
    Seek #5, 1
  End If
End If

If g_c_NHANES = 0 Then
  If mode = 3 Or mode = 4 Then
   'if you have water data for line item then you will want to include mode = 5 as well here
    If SetNo = 1 Then
      Close 12
      Open g_WaterFl$ For Input As #12
    End If
  End If
End If

If mode = 3 Then
  frmDSFGen.txtProgress = "Processing population " & Trim(Str(popx)) & " in Survey " & g_SurveyName$ & ", Year-set " & Str(SurveyYear) & " of" & Str(g_LastSurveyYear)  '& " , Set No. " & Trim(Str(SetNo))
  frmDSFGen.Refresh
Else
  frmDSFGen.txtProgress = "Processing Survey " & g_SurveyName$ & ", Year-set " & Str(SurveyYear) & " of" & Str(g_LastSurveyYear)   ' & ", Set No. "  ' & Trim(Str(SetNo))
  frmDSFGen.Refresh
End If


While Not EOF(1)

  Input #1, hhid&, REGION, cntd1, cntd2

  If hhid& <= LastHHID& Then
    MsgBox "Error at HHID = " & Str(LastHHID&) & " HHIDs must be in inceasing order during any given year in the survey"
    End
  End If

  LastHHID& = hhid&
  RecordsPassed = RecordsPassed + 1

  If RecordsPassed Mod 100 = 0 Then
    DoEvents
    RecordsPassed = 0
    If g_CancelRun Then
      Close
      MsgBox "Processing terminated by user"
      frmDSFGen.txtProgress = ""
      frmDSFGen.Refresh
      frmDSFGen.cmdCancel.Enabled = False
      Exit Sub
    End If
  End If
  
  If mode = 4 Or mode = 5 Then
    
    hh.cntd1 = cntd1
    hh.cntd2 = cntd2
    hh.REGION = REGION
    hh.hhid = hhid&
    Put #5, , hh
         
 
  End If

  If mode = 3 Or mode = 4 Or mode = 5 Then
    
  
    bu = 0
    Call ComputeIntake(mode, hhid&, REGION, cntd1, cntd2, SurveyYear, popx, MaxRACIndex, nff, MaxNFCSIndex, infwt!(), agewt!(), NRacFF, WaterDirectIndex(), WaterIndirectIndex(), bu)  '1.04
    If bu Then
      frmDSFGen.txtProgress = ""
      frmDSFGen.Refresh
      frmDSFGen.cmdCancel.Enabled = False
      Close
      Exit Sub
    End If
    GoTo EndHH
  End If
  
  'you will only get here if mode < 3
  For i = 1 To cntd1
    Input #1, hhid&, SPNUM&, PID&  'with NHANES these are all the same
   
    If hhid& <> LastHHID& Then
      MsgBox "Error at HHID = " & Str(LastHHID&) & " HHIDs do not match within household"
      LastHHID& = hhid&
      End
    End If
     
    If PID& > 0 Then
      
      
      If g_c_NHANES = 0 Then  'csfii
        Input #1, Sex, Age, AgeM, wgtsp!, hgtsp, BFStat, PLStat, Origin, Race, Wt2Day&, D1Year, D1Mnth, D1Date, D1Day, D1H2Oo, D1NRec, D2Year, D2Mnth, D2Date, D2Day, D2H2Oo, D2NRec
        'wgtsp! is bodyweight in lbs with CSFII
        'hgtsp is height in inches
         
        
      Else
        
        If SurveyYear = 1 Then  'NHANES 1999-2002
          ReDim DayofWeek(1)
          'from 1999-2002:  'sex,age, AGEM, wgtsp!, hgtsp, bfstat, plstat, origin, race, wt2day&, wtint4yr!, d1year, d1mnth, d1date, d1day, water1!, water2!, water3!, nfoods
          Input #1, Sex, Age, AgeM, wgtsp!, hgtsp, BFStat, PLStat, ridreth1, Race, StatWt2yr!, StatWt4yr!, Dummy!, Dummy!, Dummy!, DayofWeek(1), Water1!, Water2!, Water3!, D1NRec
          'wgtsp! is bodyweight in kg with NHANES
          'hgtsp is height in cm
 
        Else  'NHANES after 2002
          ReDim DayofWeek(2), WaterPlain(2), WaterTap(2), WaterBot(2), WaterCarb(2), WaterTapSource(2), NFoods(2)
          'from 2003-2006: sex, age, AGEM, wgtsp!, hgtsp, bmi!, BfStat1, BfStat2, ridreth1, ridreth2, StatWtDay1!, StatWt2Day!, 0, 0, 0, DayofWeek(1), WaterPlain(1), WaterTap(1), WaterBot(1), WaterCarb(1), WaterTapSource(1), nfoods(1), 0, 0, 0, DayofWeek(2), WaterPlain(2), WaterTap(2), WaterBot(2), WaterCarb(2), WaterTapSource(2), nfoods(2)
          Input #1, Sex, Age, AgeM, wgtsp!, hgtsp, bmi!, BfStat1, BfStat2, PLStat, ridreth1, Race, StatWtDay1!, StatWt2Day!, Dummy!, Dummy!, Dummy!, DayofWeek(1), WaterPlain(1), WaterTap(1), WaterBot(1), WaterCarb(1), WaterTapSource(1), D1NRec, Dummy!, Dummy!, Dummy!, DayofWeek(2), WaterPlain(2), WaterTap(2), WaterBot(2), WaterCarb(2), WaterTapSource(2), D2NRec
          
          'wgtsp! is bodyweight in kg with NHANES
          'hgtsp is height in cm

        End If
        
        
      End If
      
      'note that wt2day! should be the x-day stat weight used for all y years of the survey
      'where with CSFII 94-98 x = 2 (2-day weights) and y = 4.
      'The wt2day& data for years 1994, 1995, and 96 were taken from my files wt41994.txt, wt41995.txt, and wt41996.txt.
      'The wt2day& data for year 1998 was taken directly from the CSFII survey data for that year
      'Note that for CSFII 94-98 the water intake data for each individual on each day was provided by SAIC and is brought into the
      'final intake files.  It is possible at some future point in time that these (or similar) water data for another survey might be included
      'in the survey data file themselves, and thus some provision would be needed here to include the data here.
      'See sub ComputeIntake to see how the SAIC water data were incorporated into DEEM
         
        
      If mode = 1 Then   'initial parsing of intake data
        If Sex < 1 Or Sex > 2 Then Stop
        If Age < 0 Or Age > 100 Then Stop
        If g_c_NHANES = 0 Then
          If AgeM < 0 Or AgeM > 11 Then Stop
        Else
          If AgeM < 0 Or AgeM > 1200 Then Stop  'age in months does not stop at 1 year in NHANES
        End If
        If BFStat < 0 Or BFStat > 3 Then Stop
        If PLStat < 0 Or PLStat > 6 Then Stop
        If g_c_NHANES = 0 Then  'origin not in nhanes
          If Origin < 1 Or Origin > 5 Then Stop
        End If
        
        If Race < 1 Or Race > 5 Then Stop
    
        If g_c_NHANES = 0 Then
        
          If SurveyYear = 1 Then
            If D1Year < 4 Or D1Year > 5 Then Stop
            If D2Year < 4 Or D2Year > 5 Then Stop
          ElseIf SurveyYear = 2 Then
            If D1Year < 5 Or D1Year > 6 Then Stop
            If D2Year < 5 Or D2Year > 6 Then Stop
          ElseIf SurveyYear = 3 Then
            If D1Year < 6 Or D1Year > 7 Then Stop
            If D2Year < 6 Or D2Year > 7 Then Stop
          ElseIf SurveyYear = 4 Then
            If D1Year < 7 Or D1Year > 8 Then Stop
            If D2Year < 7 Or D2Year > 8 Then Stop
          End If
                 
          If D1Mnth < 1 Or D1Mnth > 12 Then Stop
          If D2Mnth < 1 Or D2Mnth > 12 Then Stop
          If D1Date < 1 Or D1Date > 31 Then Stop
          If D2Date < 1 Or D2Date > 31 Then Stop
          If D1Day < 1 Or D1Day > 7 Then Stop
          If D2Day < 1 Or D2Day > 7 Then Stop
        End If
        
        
        If D1H2Oo < 0 Or D1H2Oo > 999 Then Stop
        If D2H2Oo < 0 Or D2H2Oo > 999 Then Stop
        
        
      End If
            
      ReDim NFoods(g_NDays)
      NFoods(1) = D1NRec
      If g_NDays = 2 Then NFoods(2) = D2NRec

      'read in food intake data

      For d = 1 To g_NDays
                              
        If NFoods(d) Then
          For f = 1 To NFoods(d)
            Input #1, d2, f2, FoodCode&, FCIndex, ModCode&, FoodAmt!, OccTime  'FoodAmt! is in grams for both CSFII and NHANES
     
            If mode = 2 Then
             'check that the nfcs codes in the survey are indexed consistently in g_NFCSIndexFl$ and record frequency of use
               
              If FoodCode& <> 11000000 Then
                tp = 0
                Call GetNFCSModIndex(FoodCode&, ModCode&, tp)
                               
                If tp = 0 Then
                  GoSub ProblemCodes
                  GoTo xxx
                End If
                               
                If ModCode& = 0 Then
                  If g_a_Mod&(tp) = 0 Then  'we are at mod code 0, no need to search through other mods
                    a_IndexUsed(tp) = a_IndexUsed(tp) + 1
                    
                  Else 'we are at highest mod code for this nfcs code, only need to search down
                    Do Until g_a_Mod&(tp) = 0
                      tp = tp - 1
                    Loop
                    If FoodCode& <> g_a_NFCS&(tp) Or g_a_Mod&(tp) <> 0 Then
                      GoSub ProblemCodes
                      GoTo xxx
                    Else
                      a_IndexUsed(tp) = a_IndexUsed(tp) + 1
                    End If
                  End If
                  
                Else  'active mod code, need to match

                  If ModCode& = g_a_Mod&(tp) Then  'match
                    a_IndexUsed(tp) = a_IndexUsed(tp) + 1
                  ElseIf ModCode& > g_a_Mod&(tp) Then  'search up for match
                    Do Until ModCode& = g_a_Mod&(tp)
                      tp = tp + 1
                      If g_a_NFCS&(tp) <> FoodCode& Then 'we have left the foodcode, so there must not be a matching modcode in the foodcode area
                        GoSub ProblemCodes
                        GoTo xxx
                      End If
                    Loop
                    If ModCode& <> g_a_Mod&(tp) Then Stop 'this can only happen if we have a programming error
                    a_IndexUsed(tp) = a_IndexUsed(tp) + 1
                    
                  ElseIf ModCode& < g_a_Mod&(tp) Then 'search down for match
                    Do Until ModCode& = g_a_Mod&(tp)
                      tp = tp - 1
                      If g_a_NFCS&(tp) <> FoodCode& Then 'we have left the foodcode, so there must not be a matching modcode in the foodcode area
                        GoSub ProblemCodes
                        GoTo xxx
                      End If
                    Loop
                    
                    If ModCode& <> g_a_Mod&(tp) Then Stop  'this can only happen if we have a programming error
                    a_IndexUsed(tp) = a_IndexUsed(tp) + 1
                  End If
                End If
              End If

xxx:          'continue
            
            Else
              If FoodCode& < 11000000 Or FoodCode& > 94210200 Then Stop
              If ModCode > 0 Then
                If ModCode < 100000 Or ModCode > 999999 Then Stop
              End If
              If FoodAmt! < 0 Or FoodAmt! > 9999 Then Stop
              If OccTime < 0 Or OccTime > 9999 Then Stop
            End If
          Next f  'end of day d
        End If 'nf(d)>0
      Next d
    Else
      'this is not a valid participant, skip to next participant
    End If  'PID& > 0

  Next i
 
EndHH:

Wend
    
If SetNo < NSets(SurveyYear) Then
  SetNo = SetNo + 1  'csfii only
  Close 1
  GoTo ReadSurveyFile
'ElseIf SurveyYear < g_NSurveyParts Then
 ElseIf SurveyYear < g_LastSurveyYear Then
  SetNo = 1
  SurveyYear = SurveyYear + 1
  LastHHID = 0
  Close 1
  Close 30  '1.04
  GoTo ReadSurveyFile
End If

Close 1, 5, 12
If g_TotUSOnly Then Close 20, 21

Return

FinishUp:

If mode = 1 Then  'step 1, index 0
  MsgBox "All survey years read successfully; formatting appears to be correct"
  frmDSFGen.chkDone(0) = 1 'step 1 checked
  frmDSFGen.lblDate(0) = Date$ & "  " & time$

ElseIf mode = 2 Then  'step 2, index 1
  'list nhanes code/mod code combinations that have been previously indexed
  Open g_NFCSCodesUsed$ For Output As #1
  Print #1, "NHANES", "Mod", "Index", "Freq"
  For i = 1 To g_Maxi
    If a_IndexUsed(i) = 0 Then
      'Print #1, g_a_NFCS&(i), g_a_Mod(i), g_a_NFCSModIndex(i), "NOT USED"
      'don't include this NFCS code in the list, because this is a list of recipes needed
    Else
      Print #1, g_a_NFCS&(i), g_a_Mod(i), g_a_NFCSModIndex(i), a_IndexUsed(i)
    End If
  Next i
  Close
    
  If PC = 0 Then
    
   If Len(Dir("CodesNotIndexed1.txt")) Then Kill "CodesNotIndexed1.txt"
   If Len(Dir("CodesNotIndexed.tmp")) Then Kill "CodesNotIndexed.tmp"
   If Len(Dir("CodesNotIndexed2.txt")) Then Kill "CodesNotIndexed2.txt"
   
  Else
  'list nhanes code/mod code combinations that have not been previously indexed, in order that they are encountered
    ReDim SortIndex(PC), SortVar$(PC)
    Open "CodesNotIndexed1.txt" For Output As #1
    Print #1, "   ", "NHANES", "Mod", "Freq"
    For i = 1 To PC
      Print #1, i, a_ProblemCodes$(i, 1), a_ProblemCodes$(i, 2), a_ProblemCodes$(i, 3)
      SortIndex(i) = i
      SortVar$(i) = Str(a_ProblemCodes$(i, 1))
    Next
    Close 1
    
  'rewrite this list of nhanes code/mod code combinations in numerical order, ignoring mod code
    Call Sort(PC, SortIndex(), SortVar$())  'respecify sortindex() so that it is now in numeric order
  
    Open "CodesNotIndexed.tmp" For Output As #1
    For i = 1 To PC
      Print #1, i, a_ProblemCodes$(SortIndex(i), 1), a_ProblemCodes$(SortIndex(i), 2), a_ProblemCodes$(SortIndex(i), 3)
    Next
    Close 1
  
  'now rewrite this list of nhanes code/mod code combinations in numerical order, including mod code
    
    Open "CodesNotIndexed.tmp" For Input As #2
    Open "CodesNotIndexed2.txt" For Output As #3
    Print #3, "   ", "New Index", "NHANES Code", "Mod Code", "N Eating Occasions"
    
    Dim LastNhanesCode&
    Dim NHANES&, NPC
    Dim ModCodex&()
    Dim i2, i3
    Dim Response
    
    ReDim a_Index(20), a_ProblemCodes$(20, 1), a_ProblemCodes$(20, 2), a_ProblemCodes$(20, 3) '20 = guess as to max number of mod codes used for any given nhanes code
    
    NPC = 1  'first time this nhanes code appears in the list of unindexed codes
    Input #2, Dummy!, a_ProblemCodes$(1, 1), a_ProblemCodes$(1, 2), a_ProblemCodes$(1, 3)
    
    LastNhanesCode& = a_ProblemCodes$(1, 1)
    i2 = 0
    i3 = MaxNFCSIndex
    
    For i = 2 To PC
    
      Input #2, j, NHANES&, ModCode&, n
    
      If NHANES& = LastNhanesCode& Then 'Keep accumulating arrays of this same nhanes code with different mod codes
        NPC = NPC + 1
        a_ProblemCodes$(NPC, 1) = NHANES&
        a_ProblemCodes$(NPC, 2) = ModCode&
        a_ProblemCodes$(NPC, 3) = n
    
      Else 'no longer the same nhanes code, need to write previous array after sorting by mod code
         'we want to sort this array where all nhanes codes are them same but mod codes are different
        If NPC = 1 Then
          i2 = i2 + 1
          i3 = i3 + 1
          Print #3, i2, i3, a_ProblemCodes$(1, 1), a_ProblemCodes$(1, 2), a_ProblemCodes$(1, 3)
        Else
          
          ReDim SortIndex(NPC), SortVar$(NPC)
          
          For k = 1 To NPC
             SortIndex(k) = k
             SortVar$(k) = a_ProblemCodes$(k, 2)
          Next
          
          Call Sort(NPC, SortIndex(), SortVar$())  'respecify sortindex() so that it is now in numeric order
                 
          For k = 1 To NPC
            i2 = i2 + 1
            i3 = i3 + 1
            Print #3, i2, i3, a_ProblemCodes$(SortIndex(k), 1), a_ProblemCodes$(SortIndex(k), 2), a_ProblemCodes$(SortIndex(k), 3)
          Next
        End If
        
        'reinintialize the array:
        ReDim a_ProblemCodes$(20, 1), a_ProblemCodes$(20, 2), a_ProblemCodes$(20, 3)
        
        NPC = 1
        a_ProblemCodes$(NPC, 1) = NHANES&
        a_ProblemCodes$(NPC, 2) = ModCode&
        a_ProblemCodes$(NPC, 3) = n
            
      End If
    
      LastNhanesCode& = NHANES&
      
    Next
    
    'print last nhanes code, sort first if multiple mod codes
    If NPC = 1 Then
      i2 = i2 + 1
      i3 = i3 + 1
      Print #3, i2, i3, a_ProblemCodes$(1, 1), a_ProblemCodes$(1, 2), a_ProblemCodes$(1, 3)
    Else
      ReDim SortIndex(NPC), SortVar$(NPC)
      
      For k = 1 To NPC
        SortIndex(k) = k
        SortVar$(k) = a_ProblemCodes$(k, 2)
      Next
      
      Call Sort(PC, SortIndex(), SortVar$())  'respecify sortindex() so that it is now in numeric order
                 
      For k = 1 To NPC
        i2 = i2 + 1
        i3 = i3 + 1
        Print #3, i2, i3, a_ProblemCodes$(SortIndex(k), 1), a_ProblemCodes$(SortIndex(k), 2), a_ProblemCodes$(SortIndex(k), 3)
      Next
      
    End If
    
    Close 2, 3
    
    
    
    
  
  End If  'PC > 0
  

  If PC = 0 Then
    MsgBox "All survey years processed. All NFCS/Mod codes used in this survey were indexed properly in file " & g_NFCSIndexFl$ & ". NFCS/Mod codes used in this survey and indexed in file " & g_NFCSIndexFl$ & " are saved in file " & g_NFCSCodesUsed$ & " in folder " & CurDir, vbInformation, "NFCS/Mod code checking"
    frmDSFGen.chkDone(1) = 1  'step 2 checked
    frmDSFGen.lblDate(1) = Date$ & "  " & time$
    
  Else
    MsgBox "All survey years processed.  NFCS/Mod codes used in this survey and indexed in file " & g_NFCSIndexFl$ & " are saved in file " & g_NFCSCodesUsed$ & " in folder " & CurDir & ". " & vbCrLf & "NFCS/Mod codes used in this survey and NOT currently indexed are saved in file 'CodesNotIndexed2.txt', along with their new index number assigned here." & vbCrLf & "Note: Do not process the recipes file while there are unresolved NFCS/Mod codes remaining; i.e., until file 'CodesNotIndexed2.txt' is null.", vbInformation, "NFCS/Mod code checking"
    
    'don't check 'Done' because there is a problem with indexing that must be fixed first
    
    'fold these new nhanes/mod codes into the existing index file
    Response = MsgBox("Do you want to fold this file of new NHANES/mod codes with indices into the main index file (" & g_NFCSIndexFl$ & ")?", vbInformation + vbYesNoCancel, "Problem in recipe file.")
    If Response = vbYes Then
      Call MergeIndices
    End If
    
  End If
  
  
  
  
ElseIf mode = 3 Then  'step 5, index 4
  If LastPop = 1 Then
    MsgBox "Chronic means calculated for Tot US Pop only.  Means file saved as file " & g_MeansFFFileRoot$ & ".1", vbInformation, "Generating Population Mean Intake Files"
    If g_c_NHANES = 0 Then '1.11
      MsgBox "File " & g_c_PIDFileRA$ & " generated for use with Calendex and DMFgen", vbInformation, "Generating PID info file"
    End If
    frmDSFGen.chkDone(4) = 1  'step 5 checked
    frmDSFGen.lblDate(4) = Date$ & "  " & time$
  
  Else
   
    MsgBox "Chronic means calculated for population codes " & Str(g_c_FirstPop) & " through " & Str(g_LastPop) & ". Means files saved as files " & g_MeansFFFileRoot$ & "." & Trim(Str(g_c_FirstPop)) & " through " & g_MeansFFFileRoot$ & "." & Trim(Str(g_LastPop)), vbInformation, "Generating Population Mean Intake Files"
    frmDSFGen.chkDone(5) = 1  'step 6 checked
    frmDSFGen.lblDate(5) = Date$ & "  " & time$
  
  End If
  
  
ElseIf mode = 4 Then 'step 8 (24-hour acute file generation), index 7
  
  
  
  'FileList$ = AcuteFl$(1)
  'For i = 2 To g_NSurveyParts
  FileList$ = ""
  For i = g_FirstSurveyYear To g_LastSurveyYear
    FileList$ = FileList$ & AcuteFl$(i)
    If i < g_LastSurveyYear Then FileList$ = FileList$ & ", "
  Next i
  MsgBox "24-hour acute intake files generated and saved as " & FileList$, vbInformation, "Generating Population Mean Intake Files"
  frmDSFGen.chkDone(8) = 1  'step 9 checked
  frmDSFGen.lblDate(8) = Date$ & "  " & time$

ElseIf mode = 5 Then  'step 9, index 8
  'FileList$ = AcuteFl$(1)
  'For i = 2 To g_NSurveyParts
  FileList$ = ""
  For i = g_FirstSurveyYear To g_LastSurveyYear
    FileList$ = FileList$ & AcuteFl$(i)
    If i < g_LastSurveyYear Then FileList$ = FileList$ & ", "
  Next i
  MsgBox "Line-item acute intake files generated and saved as " & FileList$, vbInformation, "Generating Population Mean Intake Files"
  frmDSFGen.chkDone(9) = 1  'step 10 checked
  frmDSFGen.lblDate(9) = Date$ & "  " & time$
  
End If

frmDSFGen.txtProgress = ""
frmDSFGen.Refresh

Close

Exit Sub

ProblemCodes:

  If PC = 0 Then  'first problem code encountered
    PC = 1
    a_ProblemCodes$(PC, 1) = FoodCode&
    a_ProblemCodes$(PC, 2) = ModCode&
    a_ProblemCodes$(PC, 3) = 1
  Else 'subsequent problem codes
    Flag = 0
    For j = 1 To PC 'see if this has already been encountered
      If FoodCode& = a_ProblemCodes$(j, 1) And ModCode& = a_ProblemCodes$(j, 2) Then 'this has been encountered before
        a_ProblemCodes$(j, 3) = a_ProblemCodes$(j, 3) + 1
        Flag = 1
        Exit For
      End If
    Next
    If Flag = 0 Then  'first time this NFCS/Mod code encountered
      PC = PC + 1
      a_ProblemCodes$(PC, 1) = FoodCode&
      a_ProblemCodes$(PC, 2) = ModCode&
      a_ProblemCodes$(PC, 3) = 1
    End If
  End If
                  
  Return

WriteRecord:
'you will need to make your own header

Open g_MeansFFFileRoot$ & "." & Trim(Str$(popx)) For Output As #1
'the number of header lines here must be = g_c_NHeaderLinesMeansFLRoot
Print #1, "Mean daily intake by RAC and foodform for population " & Pop$(popx)
If g_c_NHANES = 0 Then
  Print #1, g_SurveyName$ & " with " & g_RecipeSetIndexRA$ & " And " & g_RecipeSetIngredRA$ & " and SAIC water amounts."
  Print #1, Date$ + time$; "  Drinking water from CSFII (wtd)="; g_TotDW# / g_NDrinkingWaterDaysW&
Else  'for
  Print #1, g_SurveyName$ & " with " & g_RecipeSetIndexRA$ & " And " & g_RecipeSetIngredRA$
  If g_NDrinkingWaterDaysW& Then
    Print #1, Date$ + time$; "  PC Drinking water from NHANES (wtd)="; g_TotDW# / g_NDrinkingWaterDaysW&
  End If
End If
'these are people-days, not people
Print #1, "pop weighted="; g_nw&; "  pop unwtd="; g_nu&; "  pop with valid drinking water-wtd="; g_NDrinkingWaterDaysW&; "  pop with valid drink water-unwtd="; g_NDrinkingWaterDaysu&
Print #1, "   RAC     |Index|FF  |PC Intake |User Int.|Users Unw|Users Wtd"

For k = 1 To MaxRACIndex
  
  x = 1

  While g_FFx(k, x) > 0
    If g_trac#(k, x) Then
      
      'tracx# = g_trac#(k, x) * 2.2  'correct for perc and kg/lbs
      tracx# = g_trac#(k, x)  '1.01 'kg conversion already made now
      tracux# = tracx# / g_racnw&(k, x)  'mean for users
      'If g_c_NHANES = 0 Then
        If (k < 549 Or k > 552) And k <> 532 Then 'per capita means
          tracx# = tracx# / g_nw& 'per capita mean for all foods but drinking water
        Else

          tracx# = tracx# / g_NDrinkingWaterDaysW& 'per capita mean for drinking water
        End If
      'Else
      '  tracx# = tracx# / g_nw& 'per capita mean for all foods but drinking water
      'End If
      tracw$ = Format(tracx#, "0##.#####0")
      Call addblanks(tracw$)
      tracu$ = Format(tracux#, "0##.#####0")
      Call addblanks(tracu$)
      racu$ = Format(g_racnu&(k, x), "0####")
      Call addblanks(racu$)
      racw$ = Format(g_racnw&(k, x), "0########")
      Call addblanks(racw$)
      i = k ': If k >= 500 Then i = k + 390
      ii$ = Format(i, "0###")
      Call addblanks(ii$)
      ffxx$ = Format(g_FFx(k, x), "0#")
      Call addblanks(ffxx$)
      
      'rac8$ = Format(EPARAC$(k), "0########")
      'Call addblanks(rac8$)
      
      'Print #1, rac8$; Tab(10); ii$; Tab(17); ffxx$; Tab(20); tracw$; Tab(32); tracu$; Tab(44); racu$; Tab(52); racw$
      'note: these tab specs are essential to the read back of these lines later at "readback1:" and "readback2"; if you change them here you must also change the read back lines
      Print #1, EPARAC$(k); Tab(12); ii$; Tab(19); ffxx$; Tab(22); tracw$; Tab(34); tracu$; Tab(46); racu$; Tab(54); racw$
    End If
    x = x + 1
  Wend
Next
Close #1

Return

End Sub

Sub IndexRecipes() 'step 4, index 3

'this sub reads the recipe file to be used with DEEM-FCID and checks formatting and consistency
'it also makes a list of all nfcs codes in the dietary survey to make sure that there is a recipe
'for every code
Dim CountLines
Dim a$  'read past title line in file
Dim RAC98&
Dim nfcs&, Modx&, ning, mff
Dim PC
Dim i, j, n, d
Dim NFCS1&, Modx1&, Index, IndexUsed
Dim LastNFCS1&
Dim Rac$(), RFF(), perc!(), CheckRACIndex()
Dim RAC1$(), RAC2$(), Index1()
Dim SortRAC$()
Dim Name1$, Name2$, RACName$
Dim RACx$, LastRAC$, MaxRACIndex
Dim Blank$
Dim Flag
Dim tp, fcx$
Dim NRecipes
Dim rcpind As RCPIndex
Dim rcping As RCPIngr
Dim Rec&
Dim Header$
Dim racxx$, ff1, ff2, ff3, rffx$
Dim testingr

Close 33
Open "missingingredients.txt" For Output As #33

'GoTo ProveRecipes 'un-rem this if you just want to check a given recipe in the random access file generated in this subroutine

frmDSFGen.txtProgress = "Writing temporary recipe file"
frmDSFGen.Refresh
'First check out validity of RAC index file
  If Len(Dir(g_RACIndexFl$)) = 0 Then
    MsgBox "Can't find file " & g_RACIndexFl$ & " in current directory " & CurDir, vbInformation, "Make Random Access Recipe Files"
    Close 33
    Exit Sub
  Else
    Open g_RACIndexFl$ For Input As #1
  End If

  g_Maxi = 0
  MaxRACIndex = 0
  LastRAC$ = 0
  While Not EOF(1)
    Input #1, RACx$, Index
    If RACx$ <= LastRAC$ Then
      MsgBox "Error in file " & g_RACIndexFl$ & ". The RACs must be increasing numerical order; after " & Str(LastRAC$) & " the RAC in this file violates this rule. Can't continue until this is fixed.", vbInformation, "Make Random Access Recipe Files"
      Close 33
      Close 1
      Exit Sub
    Else
      LastRAC$ = RACx$
    End If
    Line Input #1, RACName$
    g_Maxi = g_Maxi + 1
    If Index > MaxRACIndex Then MaxRACIndex = Index
  Wend
  Close 1

  Open g_RACIndexFl$ For Input As #1
  ReDim CheckRACIndex(MaxRACIndex)
  Flag = 0
  While Not EOF(1)
    
    Input #1, RACx$, Index
       
    Line Input #1, RACName$
    If CheckRACIndex(Index) Then
      Flag = 1
      CheckRACIndex(Index) = CheckRACIndex(Index) + 1
    Else
      CheckRACIndex(Index) = 1
    End If
  Wend
  Close 1
  
  If Flag Then
    Open "ProblemRACs.txt" For Output As #1
    Print #1, "The following RAC indices have been used more than once in file " & g_RACIndexFl$
    Print #1, "This file cannot be used until this problem has been corrected"
    
    For i = 1 To MaxRACIndex
      If CheckRACIndex(i) > 1 Then Print #1, i
    Next
    Close 1
    MsgBox "There is a problem in file " & g_RACIndexFl$ & " with the RAC indices.  At least one of these indices has been used more than once.  These problem indices are reported in file ProblemRACs.txt. The Recipe files cannot be further processed until this problem is corrected.", vbInformation, "Make Random Access Recipe Files"
    Exit Sub
  End If
  
'Now read in RAC index file for use in binary search sub
      
  Open g_RACIndexFl$ For Input As #1
  ReDim RAC1$(g_Maxi)
  ReDim RAC2$(MaxRACIndex)
  ReDim SortRAC$(g_Maxi), Index1(g_Maxi)
  
  i = 0
  While Not EOF(1)
    Input #1, RACx$, Index
    Line Input #1, RACName$
    i = i + 1
    RAC1$(i) = RACx$
    RAC2$(Index) = RACx$
    SortRAC$(i) = RACx$
    
    If Len(SortRAC$(i)) = 7 Then SortRAC$(i) = "0" & SortRAC$(i) 'if the rac code only has 7 characters then add a "0" in front to make it 8 characters
    Index1(i) = Index
  Wend
  
  Close 1

'generate a temporary text file with the indexed recipes for inspection (g_RecipesFlQA$)

Open g_NFCSCodesUsed$ For Input As #1 'this contains list of all recipes to be included in RA file, along with nfcs/mod index for each recipe

Line Input #1, a$  'read past title line(s) in file
Open g_RecipesFl$ For Input As #2  '"fcidrecipes94-98.txt", file of recipes, to be indexed by nfcs/mod code and RAC code

a$ = ""
CountLines = 0
For i = 1 To 100  'arbitrary
  Line Input #2, a$  'read past first line
  a$ = Trim(Left(a$, 10))
  If InStr(a$, "11100000") Then Exit For
  CountLines = CountLines + 1
Next
Close 2

If InStr(a$, "11100000") = 0 Then
  MsgBox "Can't find food code 11100000 in recipe file " & g_RecipesFl$ & ".  Can't continue until this file contains this food code.", vbInformation, "Error reading recipe file"
  Close 1, 2
  Exit Sub
End If
 
Open g_RecipesFl$ For Input As #2
For i = 1 To CountLines
  Line Input #2, a$  'read past header lines
Next

Open g_RecipesFlQA$ For Output As #4
Print #4, "This file contains a text version of the indexed recipe file used to generate the random access recipe files"
Print #4, "that are used to translate NFCS codes (foods as eaten) from " & g_SurveyName$
Print #4, "into RACs and food forms for use with DEEM-FCID."
Print #4, "This file was generated at " & time$ & " on " & Date$
Print #4,

nfcs& = 0
Modx& = 0
PC = 0
NRecipes = 0
ReDim MissingCodes&(2000, 3) 'arbitrary 2000
Dim SearchX, SearchFound
Dim NFCS00, LastNFCS00
LastNFCS00 = 0
While Not EOF(1)

  Input #1, NFCS1&, Modx1&, Index, IndexUsed  'these are nfcs/mods that have actually been consumed in this survey
  NFCS00 = Val(Left(Trim(Str(NFCS1&)), 2))
  
  If NFCS00 > LastNFCS00 Then
    frmDSFGen.txtProgress.Text = "At recipes starting with " & Str(NFCS00)
    DoEvents
  End If

  SearchX = 0  'number of times that the recipe database has been read through to the end searching for this match
  SearchFound = 0
  
  Do Until SearchFound = 1
  
    If EOF(2) = True Then
      Close 2
      
      If SearchX = 2 Then  '1.10
        MsgBox "Error: Can't find recipe for NHANES code " & Str(NFCS1&) & " Mod " & Str(Modx1&) & ".  Can't continue until this is resolved"
        End
      End If
      
      If SearchX = 0 Then  'the recipe file has only been searched from the last match to the end one time, so we want to open it again
      'and start searching for a match.  If no match the second time then we conclude that there is no matching NHANES?Mod combo
        Open g_RecipesFl$ For Input As #2
        For i = 1 To CountLines
          Line Input #2, a$  'read past header lines
        Next
        SearchX = SearchX + 1  '1.10 starting the second time through the file
       
      Else
        'This recipe is not available after reading through the recipe data base to end.  But we
        'have already checked to make sure all recipes are available in the previous step so we should
        'never get here.
        Stop  'just in case
        
      End If
    
    End If
    
    Input #2, nfcs&, Modx&, ning, mff

          
    ReDim Rac$(ning), RFF(ning), perc!(ning)

    For i = 1 To ning
                  
      Input #2, d, d, racxx$, perc!(i), ff1, ff2, ff3
          
      If Left(racxx$, 4) = "8601" Then racxx$ = "8602000000" ': Stop 'CHANGE ANY REFERENCE TO DRINKING WATER IN A RECIPE TO INDIRECT WATER ALL SOURCES
      perc!(i) = perc!(i) * 0.01
      rffx$ = Trim(Str(ff1)) & Trim(Str(ff2)) & Trim(Str(ff3))
      RFF(i) = Val(rffx$)
      Rac$(i) = racxx$
      If Len(Rac$(i)) = 9 Then Rac$(i) = "0" & Rac$(i)
        
    Next

    If NFCS1& = nfcs& And Modx1& = Modx& Then
    
      Write #4, nfcs&, Modx&, Index, mff, ning
      For i = 1 To ning
      
        testingr = 1
        If Rac$(i) = 0 Then
          tp = 0
  
        Else
   
          fcx$ = Rac$(i)
        
          If g_c_NHANES = 0 Then
            If Len(fcx$) = 7 Then fcx$ = "0" & fcx$
          Else
            If Len(fcx$) = 9 Then fcx$ = "0" & fcx$
          End If
        
          If Rac$(i) = RAC1$(g_Maxi) Then
            tp = g_Maxi
          Else
            Call binarysearch(SortRAC$(), fcx$, tp)
           
            If tp = 0 Then
              testingr = 0
              Print #33, Rac$(i)
            End If
        
          End If
        End If
      
        'If testingr = 1 Then
        If testingr = 1 And tp > 0 Then
          If Rac$(i) <> RAC2$(Index1(tp)) Then Stop  'this can only happen if we have a programming error; once this has been debugged this statement can be remd
        End If

        Write #4, Rac$(i), Index1(tp), RFF(i), perc!(i)
            
      Next i
      Print #4,
      SearchFound = 1

    End If
    
   Loop
    

      'if you get here, match has not yet been found
  If SearchFound = 0 Then Stop
Wend
Close

'double check to see that all recipes are available
'this test should not fail if programming is correct; thus there is no formal message to user, this is for use by programmer to make sure the program is doing what it is supposed to
Open g_NFCSCodesUsed$ For Input As #1 'this contains list of all recipes to be included in RA file, along with nfcs/mod index for each recipe
Line Input #1, a$  'read past title line(s) in file

Open g_RecipesFlQA$ For Input As #2
n = 0
Do Until InStr(Header$, "11100000")  'find how many lines of header there are in this file before first NFCS code
  Line Input #2, Header$
  n = n + 1
Loop
n = n - 1 'drop the first line of the first recipe from this count
Close 2

Open g_RecipesFlQA$ For Input As #2
For i = 1 To n
  Line Input #2, Header$  'read header lines
Next i

Dim NFCS2&, Mod1&, Mod2&, NSI1, NSI2
While Not EOF(1)
  Input #1, NFCS1&, Mod1&, NSI1, IndexUsed  'these are nfcs/mods that have actually been consumed in this survey
  Input #2, NFCS2&, Mod2&, NSI2, mff, ning
  If NFCS1& <> NFCS2& And Mod1& <> Mod2& Then Stop
  
  'read ingredient lines for bypass
  For i = 1 To ning
    Line Input #2, a$
  Next
  Line Input #2, a$  'space

Wend
Close 1, 2

'Now write the random access files with recipes (*.ind is index file, *.ing is ingredient file)
frmDSFGen.txtProgress = "Writing Recipe Files for Random Access"
frmDSFGen.Refresh

'Open g_RecipesFlQA$ For Input As #2
'N = 0
'Do Until InStr(Header$, "11100000")  'find how many lines of header there are in this file before first NFCS code
'  Line Input #2, Header$
'  N = N + 1
'Loop
'N = N - 1 'drop the first line of the first recipe from this count
'Close

Open g_RecipesFlQA$ For Input As #2
For i = 1 To n
  Line Input #2, Header$  'read header lines
Next
Open g_RecipeSetIndexRA$ For Random As #3 Len = Len(rcpind)
Open g_RecipeSetIngredRA$ For Random As #4 Len = Len(rcping)

For j = 1 To NRecipes
  Put #3, j, rcpind
Next

Rec& = 0
While Not EOF(2)
    
  Input #2, nfcs&, Modx&, Index, mff, ning

  
  If nfcs& < 1000000 Then Stop
  
  rcpind.nfcs = nfcs&
  rcpind.mod = Modx&
  rcpind.epa = Index
  rcpind.FF = mff
  rcpind.numing = ning
  rcpind.firstrec = Rec& + 1
  Put #3, Index, rcpind
  
  ReDim Ing1&(ning), ingcode(ning), perc!(ning), FF(ning)
  ReDim Rac$(ning), Index1(ning), RFF(ning), perc!(ning)
  For j = 1 To ning
    Rec& = Rec& + 1
    
    Input #2, Rac$(j), Index1(j), RFF(j), perc!(j)
    rcping.epaingr = Rac$(j)
    rcping.ingcode = Index1(j)
    rcping.FF = RFF(j)
    rcping.perc = perc!(j)
    Put #4, Rec&, rcping
  Next
  Input #2, Blank$

Wend
Close

frmDSFGen.txtProgress = ""
frmDSFGen.Refresh


ProveRecipes:
'check some recipe beyond first recipe to make sure it agrees with what is in the temp file
Open g_RecipeSetIndexRA$ For Random As #3 Len = Len(rcpind)
Open g_RecipeSetIngredRA$ For Random As #4 Len = Len(rcping)
Index = 10
Get #3, Index, rcpind
Debug.Print rcpind.nfcs, rcpind.mod, rcpind.epa, rcpind.FF, rcpind.numing
For i = 1 To rcpind.numing
  Get #4, rcpind.firstrec + i - 1, rcping
  Debug.Print rcping.epaingr, rcping.ingcode, rcping.FF, rcping.perc
Next
Close

MsgBox "Recipes saved in random access format as files " & g_RecipeSetIndexRA$ & " and " & g_RecipeSetIngredRA$, vbInformation
frmDSFGen.chkDone(3) = 1 'step 4 checked
frmDSFGen.lblDate(3) = Date$ & "  " & time$

  
End Sub
Public Sub binarysearch(newcode$(), target$, targetposition)
'find the target food code in the list of new epa food codes


  Dim Low
  Dim High
  Dim Middle

  targetposition = 0
  Low = LBound(newcode$)
  High = UBound(newcode$)

  Do
    Middle = (Low + High) \ 2
    Select Case newcode$(Middle)
      Case Is = target$
        targetposition = Middle
      Case Is > target$
        High = Middle - 1
      Case Is < target$
        Low = Middle + 1
    End Select
   ' If High < Low Then Stop
  Loop Until (targetposition <> 0) Or (High < Low)

End Sub


Public Sub SetUpNFCSIndices(MaxNFCSIndex, mode, WaterDirectIndex(), WaterIndirectIndex(), bu)

'set up array of NFCS Indices, check to make sure all NFCS codes in this file are in ascending order
  
  Dim LastNFCS&, LastMod&
  'Dim MaxNFCS&
  Dim NFCSx&, Modx&, Index, OldNSI
  Dim i
  Dim CheckDups()
  Dim Flag
  
  Dim FoodCodex$, cg$, cf!, namex$, nffx, fff
    
  If Len(Dir(g_NFCSIndexFl$)) = 0 Then
    MsgBox "Can't find file " & g_NFCSIndexFl$ & " in current directory (" & CurDir & "). Can't index NFCS codes without this file.", vbInformation, "Indexing NFCS Codes"
    bu = 1
    Exit Sub
  End If
    
  Open g_NFCSIndexFl$ For Input As #1
  MaxNFCSIndex = 0
  g_Maxi = 0
  LastNFCS& = 0
  LastMod& = 0
    
  While Not EOF(1)
    
    Input #1, NFCSx&, Modx&, Index, OldNSI
    g_Maxi = g_Maxi + 1
    If Index > MaxNFCSIndex Then MaxNFCSIndex = Index
    'If NFCSx& > MaxNFCS& Then MaxNFCS& = NFCSx&
    If NFCSx& < LastNFCS& Then
      MsgBox "Error in file " & g_NFCSIndexFl$ & " at NFCS code " & Str(NFCSx&) & ". All NFCS codes must be in ascending order in this file. Can't continue until this is fixed."
      Close 1
      Exit Sub
    ElseIf NFCSx& = LastNFCS& Then
      If Modx& <= LastMod& Then
        MsgBox "Error in file " & g_NFCSIndexFl$ & " at NFCS code " & Str(NFCSx&) & " modification code " & Str(Modx&) & ". All NFCS codes must be in ascending order in this file and within NFCS codes all modification codes must be in ascending order. Can't continue until this is fixed."
        Close 1
        Exit Sub
      End If
    End If
    
    LastNFCS& = NFCSx&
    LastMod& = Modx&
    
  Wend
  Close 1
  
  'check for duplicate indices
  Open g_NFCSIndexFl$ For Input As #1
  ReDim CheckDups(MaxNFCSIndex)
  Flag = 0
  While Not EOF(1)
    Input #1, NFCSx&, Modx&, Index, OldNSI
    If CheckDups(Index) Then
      Flag = 1
      CheckDups(Index) = CheckDups(Index) + 1
    Else
      CheckDups(Index) = 1
    End If
  Wend
  Close 1

  If Flag = 1 Then
    Open "BadIndices.txt" For Output As #1
    Print #1, "The following NFCS/Mod indices were used more than once in file " & g_NFCSIndexFl$
    For i = 1 To MaxNFCSIndex
      If CheckDups(i) > 1 Then Print #1, i; " used ", CheckDups(i); " times"
    Next
    Close 1
    MsgBox "The NFCS/Mod index file " & g_NFCSIndexFl$ & " has duplicate indices for some NFCS/Mod codes.  These are reported in file 'BadIndices.txt'. You cannot continue until you have fixed this problem.", vbInformation, "Indexing Problem with NFCS/Mod codes"
    g_Maxi = 0
    Exit Sub
  End If
  
  'set up arrays for later processing
  ReDim g_a_NFCS&(g_Maxi), g_a_Mod(g_Maxi), g_a_NFCSModIndex(g_Maxi)
  ReDim g_a_SortCode$(g_Maxi)
  
  Open g_NFCSIndexFl$ For Input As #1
  
  i = 0
  While Not EOF(1)
    Input #1, NFCSx&, Modx&, Index, OldNSI
    i = i + 1
    g_a_NFCS&(i) = NFCSx&
    g_a_SortCode$(i) = Trim(Str(NFCSx&))
    g_a_Mod(i) = Modx&
    g_a_NFCSModIndex(i) = Index
    
  Wend
  
  Close 1
  
  If g_c_NHANES Then
  
    If mode = 4 Or mode = 5 Then  'acute analysis, get water indices used with RAC/FF
     'this assumes that the nffx and fff variables were computed as mode = 3 previous to this run
      
      ReDim WaterDirectIndex(0 To 4), WaterIndirectIndex(0 To 4)
      
      Open g_Foodsepa$ For Input As #10
      Do Until FoodCodex$ = "8601000000" 'water, direct, all sources
        Input #10, Index, FoodCodex$, cg$, cf!, namex$, nffx, fff
      Loop
      If FoodCodex$ <> "8601000000" Then Stop
        'error: this water code and following water must be in file g_FoodsEpa$ in the order shown, but not necessarilly sequentially
        
      WaterDirectIndex(0) = fff

      Do Until FoodCodex$ = "8602000000"  'indirect water, all sources
        Input #10, Index, FoodCodex$, cg$, cf!, namex$, nffx, fff
      Loop
      
      If FoodCodex$ <> "8602000000" Then Stop
        'error: this water code and following water must be in file g_FoodsEpa$ in the order shown, but not necessarilly sequentially
      WaterIndirectIndex(0) = fff
            
      Do Until FoodCodex$ = "8601100000"  'direct water, tap
        Input #10, Index, FoodCodex$, cg$, cf!, namex$, nffx, fff
      Loop
      If FoodCodex$ <> "8601100000" Then Stop
        'error: this water code and following water must be in file g_FoodsEpa$ in the order shown, but not necessarilly sequentially
      WaterDirectIndex(1) = fff
      
      'now the rest of these water codes are expected to be sequentially available after FoodCodex$ = "8601100000"
        
      Input #10, Index, FoodCodex$, cg$, cf!, namex$, nffx, fff
      If FoodCodex$ <> "8601200000" Then Stop   'water, direct, bottled
      WaterDirectIndex(2) = fff
      Input #10, Index, FoodCodex$, cg$, cf!, namex$, nffx, fff
      If FoodCodex$ <> "8601300000" Then Stop  'water, direct, other
      WaterDirectIndex(3) = fff
      Input #10, Index, FoodCodex$, cg$, cf!, namex$, nffx, fff
      If FoodCodex$ <> "8601400000" Then Stop  'water, direct, source NS
      WaterDirectIndex(4) = fff
      Input #10, Index, FoodCodex$, cg$, cf!, namex$, nffx, fff
      If FoodCodex$ <> "8602100000" Then Stop  'water, indirect, tap
      WaterIndirectIndex(1) = fff
      Input #10, Index, FoodCodex$, cg$, cf!, namex$, nffx, fff
      If FoodCodex$ <> "8602200000" Then Stop  'water, indirect, bottled
      WaterIndirectIndex(2) = fff
      Input #10, Index, FoodCodex$, cg$, cf!, namex$, nffx, fff
      If FoodCodex$ <> "8602300000" Then Stop  'water, indirect, other
      WaterIndirectIndex(3) = fff
      Input #10, Index, FoodCodex$, cg$, cf!, namex$, nffx, fff
      If FoodCodex$ <> "8602400000" Then Stop  'water, indirect, source NS
      WaterIndirectIndex(4) = fff
      
      Close 10

    End If  'modes 4 or 5
  End If
End Sub


Public Sub GetNFCSModIndex(FoodCode&, ModCode&, tp)
  'this sub gets the index number corresponding to the NFCS code, but not the mod code (if there are one or more mod
  'codes associated with this NFCS code, then the index number search needs to be refined further after leaving this sub
  
  Dim fcx$
  
  fcx$ = Trim(Str(FoodCode&))
  If FoodCode& = g_a_NFCS&(g_Maxi) Then
    tp = g_Maxi
  ElseIf FoodCode& = 11000000 Then 'human milk
    tp = 0
  Else
    Call binarysearch(g_a_SortCode$(), fcx$, tp)
    'need to validate return of tp
    
    If tp = 0 Then Exit Sub
    If g_a_NFCS&(tp) <> FoodCode& Then Stop  'this can only happen if we have a programming error; once this has been debugged this statement can be remd
  End If

End Sub

Public Sub CheckRecipes(bu)  'step 3

'this sub reads the recipe file to be used with DEEM-FCID and checks formatting and consistency

Dim RACx$, ff1, ff2, ff3
Dim Rac&
Dim cg
Dim Response
Dim nfcs&, Modx&, ning, mff
Dim Name1$, Name2$, RACName$, Blank$
Dim i, NFCS1&, Modx1&, Index, IndexUsed
Dim a$, CountLines
Dim RFF, perc!
Dim j, d
Dim PC

Dim LastNFCS1&
Dim Txt$
Dim StopShow
Dim Header$
Dim Flag, Flag2
Dim SkipTest
Dim WeightTest
Dim WeightRatio$, WeightRatioAmount!

If Len(Dir(g_RecipesFl$)) = 0 Then
  MsgBox "Can't procede without file " & g_RecipesFl$ & " which is a formatted recipe file containing all recipes needed for this survey.", vbInformation, "Can't procede with recipe processing"
  Exit Sub
End If
   
  Open "RecipeProblems.txt" For Output As #99
  Open g_RecipesFl$ For Input As #2
  a$ = ""
  CountLines = 0

  For i = 1 To 100  'arbitrary
    Line Input #2, a$  'read past first line
    a$ = Trim(Left(a$, 10))
    If InStr(a$, "11100000") Then Exit For
    CountLines = CountLines + 1
  Next
  Close 2
  
  If InStr(a$, "11100000") = 0 Then
    Close 99
    MsgBox "Can't find food code 11100000 in recipe file " & g_RecipesFl$ & ".  Can't continue until this file contains this food code.", vbInformation, "Error reading recipe file"
    Exit Sub
  End If

  Open g_RecipesFl$ For Input As #2
  For i = 1 To CountLines
    Line Input #2, a$  'read past header lines
  Next

Weight_Ratio:
SkipTest = 1
Response = MsgBox("Do you want to flag recipe problems related to ingredient ratios and ingredient codes = 0? ", vbYesNoCancel, "Processing Recipes")
If Response = vbYes Then
  SkipTest = 0
  
  WeightRatio$ = InputBox("What is the maximum weight ratio that you will allow for any single ingredient in a recipe (e.g., 1.0, where 1.0 = 100%)? [Some FCID ingredients have weight ratios > 1; they have asked us to accept these for now.]", "Recipe diagnositic", "1.0")
  If WeightRatio$ = "" Then GoTo Weight_Ratio  'Cancel returned
  
  WeightRatioAmount! = Val(WeightRatio$)
  If WeightRatioAmount! <= 0 Or WeightRatioAmount! > 10 Then
    MsgBox "Invalid reponse for maximum weight ratio.  Must be > 0 and <= 10.", vbInformation, "Invalid weight ratio entered"
    GoTo Weight_Ratio
  End If

ElseIf Response = vbCancel Then
  Close
  bu = 1
  Exit Sub
End If

Txt$ = "Yes = Continue, No = Don't show this message again, Cancel = Stop processing now"
StopShow = 0

While Not EOF(2)
  

  Input #2, nfcs&, Modx&, ning, mff
    
  If nfcs& < 11100000 Or nfcs& > 95000000 Then
    MsgBox "Error at recipe for " & Name1$ & " in file " & g_RecipesFl$ & ". The NFCS code (" & Str(nfcs&) & ") is out of bounds.", vbInformation, "Error in recipe file, can't continue."
    Close 2
    Exit Sub
  End If
  
  For i = 1 To ning
  
    Input #2, d, d, RACx$, perc!, ff1, ff2, ff2
    
    perc! = perc! * 0.01
    RACx$ = Trim(RACx$)
    cg = Left(RACx$, 2)
    
    If Val(RACx$) = 0 Then
      If SkipTest = 0 Then  'don't test any recipes for ingredient code 0
        If StopShow = 0 Then  '
          Response = MsgBox("Error at recipe for " & Name1$ & " in file " & g_RecipesFl$ & ", NFCS code " & Str(nfcs&) & "). The FCID RAC code used (0) implies that there is no valid RAC for this ingredient. You might want to check this, but the recipe processing will continue." & vbCrLf & Txt$, vbInformation + vbYesNoCancel, "Problem in recipe file.")
          Print #99, "Error: at recipe for " & Name1$ & ", NFCS code " & Str(nfcs&) & "). The FCID RAC code used = 0"
          If Response = vbCancel Then
            Close 2
            Exit Sub
          ElseIf Response = vbNo Then
            StopShow = 1
          Else
            'continue
          End If
        End If
      End If
    ElseIf cg < 1 Or cg > 95 Then
      MsgBox "Error at recipe for " & Name1$ & " in file " & g_RecipesFl$ & ", NFCS code " & Str(nfcs&) & "). The crop group id in this FCID RAC code used (" & RACx$ & ") is < 1 or > 95.", vbInformation, "Error in recipe file, can't continue."
      Print #99, "Error: at recipe for " & Name1$ & ", NFCS code " & Str(nfcs&) & "). The crop group id in this FCID RAC code used (" & RACx$ & ") is < 1 or > 95"
      Close 2
      Exit Sub
    End If
    
    If SkipTest = 0 Then
      If perc! <= 0 Or perc! > WeightRatioAmount! Then
        If StopShow = 0 Then
          If Modx& = 0 Then
            Response = MsgBox("Error at recipe for " & Name1$ & " in file " & g_RecipesFl$ & ", NFCS code " & Str(nfcs&) & "). At FCID RAC code " & RACx$ & " the weight ratio " & Str(perc!) & " is out of bounds (should be > 0 and <=1). You might want to check this, but the recipe processing can continue." & vbCrLf & Txt$, vbInformation + vbYesNoCancel, "Problem in recipe file.")
            Print #99, "Error: at recipe for " & Name1$ & ", NFCS code " & Str(nfcs&) & "). At FCID RAC code " & RACx$ & " the weight ratio " & Str(perc!) & " is out of bounds (should be > 0 and <= " & WeightRatio$ & ")."
          Else
            Response = MsgBox("Error at recipe for " & Name1$ & " in file " & g_RecipesFl$ & ", NFCS code " & Str(nfcs&) & " at mod " & Str(Modx&) & ". At FCID RAC code " & RACx$ & " the weight ratio " & Str(perc!) & " is out of bounds (should be > 0 and <=1). You might want to check this, but the recipe processing can continue." & vbCrLf & Txt$, vbInformation + vbYesNoCancel, "Problem in recipe file.")
            Print #99, "Error: at recipe for " & Name1$ & ", NFCS code " & Str(nfcs&) & " at mod " & Str(Modx&) & ". At FCID RAC code " & RACx$ & " the weight ratio " & Str(perc!) & " is out of bounds (should be > 0 and <= " & WeightRatio$ & ")."
          End If
          If Response = vbCancel Then
            Close 2
            bu = 1  'so that the next step after returning to calling program is skipped over
            Exit Sub
          ElseIf Response = vbNo Then
            StopShow = 1
          Else
          'continue
          End If
        End If
      End If
    End If
  Next i
  
Wend
Close 2

CheckMissing:

'now check to make sure that all recipes needed for this survey as listed in the NFCS codes used file are available in the recipe file
If Len(Dir(g_NFCSCodesUsed$)) = 0 Then
  MsgBox "Can't procede without file " & g_NFCSCodesUsed$ & " which is generated when checking NFCS/Mod Indexing and Usage.", vbInformation, "Can't procede with recipe processing"
  Exit Sub
End If

Dim CountCodesUsed
Dim NHANESCode1&(), ModCode1&(), ComboIndex(), GotRecipe()
Dim CountRecipes
Dim NHANESCode2&(), ModCode2&()

CountCodesUsed = 0
Open g_NFCSCodesUsed$ For Input As #1
Line Input #1, a$
While Not EOF(1)
  Input #1, NFCS1&, Modx1&, Index, IndexUsed
  CountCodesUsed = CountCodesUsed + 1
Wend
Close 1

'these are arrays of NHANES/Mod Combos used in surveys

ReDim NHANESCode1&(CountCodesUsed), ModCode1&(CountCodesUsed), ComboIndex(CountCodesUsed), GotRecipe(CountCodesUsed)
Open g_NFCSCodesUsed$ For Input As #1  'set up an array of all NHANES codes and Mod code combinations we need a recipe for
Line Input #1, a$
j = 0
While Not EOF(1)
  Input #1, NFCS1&, Modx1&, Index, IndexUsed
  j = j + 1
  NHANESCode1&(j) = NFCS1&
  ModCode1&(j) = Modx1&
  ComboIndex(j) = Index
Wend
Close 1

'count the number of available recipes in the recipe file
Open g_RecipesFl$ For Input As #2
For i = 1 To CountLines
  Line Input #2, a$  'read past header lines
Next

'read through recipes to count number in file
CountRecipes = 0
While Not EOF(2)
      Input #2, nfcs&, Modx&, ning, mff
      CountRecipes = CountRecipes + 1
            
      For i = 1 To ning
        Line Input #2, a$  'we don't need the individual variables at this point
      Next
                 
Wend
Close 2

 
ReDim NHANESCode2&(CountRecipes), ModCode2&(CountRecipes)
'now we get an array of NHANES/Mod Combos that we have recipes for
Open g_RecipesFl$ For Input As #2
For i = 1 To CountLines
  Line Input #2, a$  'read past header lines
Next

'read through recipes to count number in file
j = 0
While Not EOF(2)
      Input #2, nfcs&, Modx&, ning, mff
      j = j + 1
      NHANESCode2&(j) = nfcs&
      ModCode2&(j) = Modx&
      
      For i = 1 To ning
        Line Input #2, a$  'we don't need the individual variables at this point
      Next
                  
Wend
Close 2

For i = 1 To CountCodesUsed
  Flag = 0
  For j = 1 To CountRecipes
    If NHANESCode1&(i) = NHANESCode2&(j) And ModCode1&(i) = ModCode2&(j) Then
      GotRecipe(i) = GotRecipe(i) + 1
      Flag = 1
      Exit For
    End If
  Next j
Next i

Dim DuplicateRecipe
DuplicateRecipe = 0
For i = 1 To CountCodesUsed
  If GotRecipe(i) > 1 Then DuplicateRecipe = DuplicateRecipe + 1
Next
  
If DuplicateRecipe Then
  Open "DuplicateRecipes.txt" For Output As #1
  Print #1, "The following NHANES/Mod codes used in this survey have duplicate recipes in file " & g_RecipesFl$
  Print #1,
  Print #1, " ##         NHANES code      Mod code      Index"
  For i = 1 To CountCodesUsed
    If GotRecipe(i) > 1 Then Print #1, i, NHANESCode1&(i), ModCode1&(i), ComboIndex(i)
  Next
  Close 1
  MsgBox "Duplicate recipe codes (NHANES and Mod) were written to file 'DuplicateRecipes.txt' in folder " & CurDir & "  You cannot continue processing recipes until the duplicate recipes are removed from this file.", vbInformation, "Recipe records reviewed"
  Close
  bu = 1
  Exit Sub
End If

Dim MissingRecipe
MissingRecipe = 0
For i = 1 To CountCodesUsed
  If GotRecipe(i) = 0 Then MissingRecipe = MissingRecipe + 1
Next

If MissingRecipe Then
  Open "MissingRecipes.txt" For Output As #1
  Print #1, "The following NHANES/Mod codes used in this survey do not have a recipe in file " & g_RecipesFl$
  Print #1,
  Print #1, " ##         NHANES code      Mod code      Index"
  For i = 1 To CountCodesUsed
    If GotRecipe(i) = 0 Then Print #1, i, NHANESCode1&(i), ModCode1&(i), ComboIndex(i)
  Next
  Close 1
  MsgBox "Missing recipe codes (NHANES and Mod) were written to file 'MissingRecipes.txt' in folder " & CurDir, vbInformation, "Recipe records reviewed"
  
  'now check substitute recipes file to see if missing recipes are available by cross reference
  If Len(Dir(g_SubstituteRecipes$)) = 0 Then
    MsgBox "File " & g_SubstituteRecipes$ & " is not avaible in the current folder.  Cant't generate chronic means until you have established a substitute recipe file with recipe cross-matching.", vbInformation, "Recipe records reviewed"
    Exit Sub
  Else
    Call ReadSubRecipes(bu)
    
    If bu Then Exit Sub
        
    'records read in from ReadSubRecipes(bu)
    'g_NSubRecs
    'g_SubRec&(1, j), g_SubMod&(1, j), g_SubInd(1, j), g_SubRec&(2, j), g_SubMod&(2, j), g_SubInd(2, j)
        
    Flag2 = 0
    For i = 1 To CountCodesUsed
      If GotRecipe(i) = 0 Then
        
        Flag = 0
        For j = 1 To g_NSubRecs
          If g_SubInd(1, j) = ComboIndex(i) Then
            Flag = 1
            Exit For
          End If
        Next j
        If Flag = 0 Then Flag2 = Flag2 + 1 'there is no substitute recipe for this index
      End If
      
    Next i
    
    If Flag2 Then
      MsgBox "Please check the substitute recipes file; there are " & Str(Flag2) & " NFCS/Mod codes listed in file 'MissingRecipes.txt' that do not have corresponding substitute recipes in the former file.", vbInformation, "Recipe records reviewed"
      Exit Sub
    End If
    
  End If
  
  MsgBox "All missing recipes were found in file " & g_SubstituteRecipes$, vbInformation, "Recipe records reviewed"
  
Else
  MsgBox "All recipes corresponding to the NFCS codes and mod codes in file " & g_NFCSCodesUsed$ & " were found in file " & g_RecipesFl$, vbInformation, "Recipe records reviewed"
    
End If

Close 2
  
frmDSFGen.chkDone(2) = 1  'step 3 checked
frmDSFGen.lblDate(2) = Date$ & "  " & time$


End Sub



Sub PopulationNames(Pop$())
'g_NPops is a constant listed at the top of this module; it must be consistent with the number of population names listed here
ReDim Pop$(g_NPops)

If g_c_NHANES = 0 Then
Pop$(1) = "Total US Population"
Pop$(2) = "Spring Season"
Pop$(3) = "Summer Season"
Pop$(4) = "Fall Season"
Pop$(5) = "Winter Season"
Pop$(6) = "Northeast"
Pop$(7) = "Midwest"
Pop$(8) = "South"
Pop$(9) = "West"
Pop$(10) = "Hispanic"
Pop$(11) = "Non-Hisp-White"
Pop$(12) = "Non-Hisp-Black"
Pop$(13) = "Non-Hisp-Other"
Pop$(14) = "Nursing Infants"
Pop$(15) = "Non-Nursing Infants"
Pop$(16) = "Female 13+ Preg/Not Nursing"
Pop$(17) = "Female 13+ Nursing"
Pop$(18) = "Children 1-6"
Pop$(19) = "Children 7-12"
Pop$(20) = "Male 13-19"
Pop$(21) = "Female 13-19/NP/NN"
Pop$(22) = "Male 20+"
Pop$(23) = "Females 20+/NP/NN"
Pop$(24) = "Seniors 55+"
Pop$(25) = "All Infants"
Pop$(26) = "Female 13-50"
Pop$(27) = "Children 1-2"
Pop$(28) = "Children 3-5"
Pop$(29) = "Children 6-12"
Pop$(30) = "Youth 13-19"
Pop$(31) = "Adult 20-49"
Pop$(32) = "Adult 50-99"
Pop$(33) = "Female 13-49"

Else 'nhanes has no season or region data

Pop$(1) = "Total US Population"

Pop$(2) = "Hispanic"
Pop$(3) = "Non-Hisp-White"
Pop$(4) = "Non-Hisp-Black"
Pop$(5) = "Non-Hisp-Other"

Pop$(6) = "Nursing Infants"
Pop$(7) = "Non-Nursing Infants"

Pop$(8) = "Female 13+ PREG"
Pop$(9) = "Children 1-6"
Pop$(10) = "Children 7-12"
Pop$(11) = "Male 13-19"
Pop$(12) = "Female 13-19/NP"
Pop$(13) = "Male 20+"
Pop$(14) = "Female 20+/NP"
Pop$(15) = "Seniors 55+"
Pop$(16) = "All Infants"
Pop$(17) = "Female 13-50"
Pop$(18) = "Children 1-2"
Pop$(19) = "Children 3-5"
Pop$(20) = "Children 6-12"
Pop$(21) = "Youth 13-19"
Pop$(22) = "Adults 20-49"
Pop$(23) = "Adults 50-99"
Pop$(24) = "Female 13-49"

End If
End Sub


Public Sub ComputeIntake(mode, hhid&, REGION, cntd1, cntd2, SurveyYear, popx, MaxRACIndex, nff, MaxNFCSIndex, infwt!(), agewt!(), NRacFF, WaterDirectIndex(), WaterIndirectIndex(), bu)  '1.04

  
  Dim seqn, ridstatr, riagendr, ridageyr, ridagemn, dmdeduc, indhhinc, indfminc, indfmpir!, dmdmartl, ridpred, wtint2yr!, wtint4yr!     '1.04
  Dim seqn1&, sddsrvyr, riagenderm, ridageex, ridexprg, sdmvpsu, sdmvstra, bmxwt!, bmxrecum!, bmxht!, bmxbmi!, indfrmpir!
  Dim Participant
  'Dim Index, FoodCodex$, cg$, cf!, namex$, nffx, fff 'rem'd 1.11
  'Dim WaterDirectIndex(), WaterIndirectIndex() 'water direct and indirect indices
  Dim DirWaterAll!, DirWaterCarb!, DirWaterBot!, DirWaterBotOther!, DirWaterTap!, DirWaterOther!, DirWaterNA!
  Dim ValidPLAINDrinkingWater, ValidTAPDrinkingWater, ValidCarbonatedDrinkingWater
  Dim SAICno
  Dim i, d, f, n, k, r, x, z
  Dim t '1.02
  Dim Skip
  Dim dummyx$
  Dim TNF
  Dim SPNUM&, PID&
  Dim Sex, Age, AgeM, wgtsp!, hgtsp, BFStat, PLStat, Origin, Race, Wt2Day&
  Dim D1Year, D1Mnth, D1Date, D1Day, D1H2Oo, D1NRec, D2Year, D2Mnth, D2Date, D2Day, D2H2Oo, D2NRec
  Dim Flag
  'Dim RACIndex, ff, c!
  Dim FF, c!
  Dim NFCSModIndex
  Dim Saichh&, SaicIndiv, SaicBw!, SaicAge
  Dim NWaterCodes
  Dim Saicd1, d1_d_Tot!, d1_d_Tap!, d1_d_Bot!, d1_d_Oth!, d1_d_Mis!, d1_i_Tot!, d1_i_Tap!, d1_i_Bot!, d1_i_Oth!, d1_i_Mis!
  Dim Saicd2, d2_d_Tot!, d2_d_Tap!, d2_d_Bot!, d2_d_Oth!, d2_d_Mis!, d2_i_Tot!, d2_i_Tap!, d2_i_Bot!, d2_i_Oth!, d2_i_Mis!
  Dim wght&
  Dim Hispanic
  Dim ValidDrinkingWater1
  Dim ValidDrinkingWater2  '4-28-2011
  Dim d2, f2, FoodCode&, FCIndex, ModCode&, FoodAmt!, OccTime
  Dim tp
  Dim NF()
  Dim RACx!(), Expos!(), Sum()
  Dim RACff(), IntakeTime()
  Dim Recno&, Recno2&
  Dim Sumx
  
  Dim rcpind As RCPIndex
  Dim rcping As RCPIngr
  Dim hh As rechh
 
  Dim sp1 As spdata1
  
  Dim sp2 As spdata2
    
  Dim RXX As lookup
  Dim cons As RACFF24hr
  Dim RACFFLI As RACFFLineItem
  Dim pidx As PIDxx
  
  Dim Water1!, Water2!, Water3!  '2.0
  Dim StatWt2yr!, StatWt4yr!  '2.0  'for nhanes 2003-2006
  Dim StatWtDay1!, StatWt2Day!  '2.0  for nhanes 1999-2002
  Dim DayofWeek() '2.0
  Dim ridreth1, ridreth2  '2.0
  Dim bmi!  '2.0
  Dim BfStat1, BfStat2
  Dim Dummy!
  Dim WaterPlain!(), WaterTap!(), WaterBot!()  'WaterCarb!(), WaterTapSource()
  Dim NFoods()
  Dim TempExpos!(), TempRACff()  '1.02
  
  SAICno = 0

  For i = 1 To cntd1  'cntd1 is always 1 with nhanes
    
    Input #1, hhid&, SPNUM&, PID&  'hhid& is repeated, this is ok
    
    If g_c_NHANES > 0 And PID& = 0 Then Stop  'make sure we know what we are doing here
    
    If PID& = 0 Then
      If mode = 4 Or mode = 5 Then  '1.01
        Participant = 0
        Put #5, , Participant
      End If
      GoTo endindividual
    End If
                
    g_PIDNew& = g_PIDNew& + 1  '1.04
                
    If g_c_NHANES = 0 Then  'csfii
        Input #1, Sex, Age, AgeM, wgtsp!, hgtsp, BFStat, PLStat, Origin, Race, Wt2Day&, D1Year, D1Mnth, D1Date, D1Day, D1H2Oo, D1NRec, D2Year, D2Mnth, D2Date, D2Day, D2H2Oo, D2NRec
        
        'wgtsp! is in lbs, converted to kg below
        hgtsp = hgtsp / 2.54  'convert to cm  '1.01
        
        If wgtsp! > 995 Or wgtsp! = 0 Then  'use epa suggested body weights where there is no valid body weight
           
          If Age <= 0 Then
            wgtsp! = infwt!(Sex, AgeM) 'bodyweight in kg
          Else
            wgtsp! = agewt!(Sex, Age) 'bodyweight in kg
          End If
          
        Else
          wgtsp! = wgtsp! / 2.2  '1.01  body weight for CSFII is now in Kg from this point on
        End If
          
        If mode = 4 Or mode = 5 Then  '1.01
          If Wt2Day& = 0 Then Stop
          sp1.rectype = "A"
          'sp1.SPNUM = SPNUM&
          
          If AgeM > 0 Then  'this is an old convention I used from way back to pass age in months in the spdata1 record
            sp1.Age = AgeM * -1
          Else
            sp1.Age = Age
          End If
                    
          sp1.Sex = CStr(Sex)
          sp1.BFStat = CStr(BFStat)
          sp1.PLStat = CStr(PLStat)
          sp1.hhid = hhid&
          sp1.Race = CStr(Race)
          sp1.Origin = CStr(Origin)
          sp1.Wt2Day = Wt2Day&
          
          sp1.PID = g_PIDNew&  '1.04
          sp1.indhhinc = indhhinc  '1.04 household income (need coded list)
          sp1.indfminc = indfminc  '1.04 family income used when hh income is not known
          sp1.indfmpir = indfmpir! '1.04 ratio of family income to poverty level
          
          
          sp2.rectype = "B"
          'sp2.SPNUM = SPNUM&
          sp2.bmi = 0  '1.05 no bmi in csfii, but since we change the type spec for spdata2 from SPNUM to bmi we do this for consistency
          
          sp2.wgtsp = wgtsp! 'weight in kg as of version 1.01
          sp2.hgtsp = hgtsp  'height in cm  as of 1.01
          
          sp2.D1Day = D1Day
          sp2.D1Date = D1Date
          sp2.D1Mnth = D1Mnth
          sp2.D1Year = D1Year
          sp2.D1H2Oo = D1H2Oo
          sp2.D1NRec = D1NRec
          
          sp2.D2Day = D2Day
          sp2.D2Date = D2Date
          sp2.D2Mnth = D2Mnth
          sp2.D2Year = D2Year
          sp2.D2H2Oo = D2H2Oo
          sp2.D2NRec = D2NRec
          
        End If
        
    Else  'nhanes
        
        If SurveyYear = 1 Then  'nhanes 1999-2002 (for g_nhanes = 1 only)
        'this will not be accessed with g_c_NHANES = 2 because these 1-day data are not used
          Do Until seqn = hhid&
            Input #30, seqn, ridstatr, riagendr, ridageyr, ridagemn, ridreth1, ridreth2, dmdeduc, indhhinc, indfminc, indfmpir!, dmdmartl, ridpred, sdmvpsu, sdmvstra, wtint2yr!, wtint4yr!  '1.04
          Loop
        
       
          ReDim DayofWeek(1)
  'from 1999-2002:  'sex,age, AGEM, wgtsp!, hgtsp, bfstat, plstat, origin, race, wt2day&, wtint4yr!, d1year, d1mnth, d1date, d1day, water1!, water2!, water3!, nfoods
           'riagendr; ridageyr; ridagemn; bw!; ht!; bfstat; plstat; ridreth1; race; wtint2yr!; wtint4yr!; 0; 0; 0; Day; water1!; water2!; water3!; nfoods
          
          Input #1, Sex, Age, AgeM, wgtsp!, hgtsp, BFStat, PLStat, ridreth1, Race, StatWt2yr!, StatWt4yr!, Dummy!, Dummy!, Dummy!, DayofWeek(1), Water1!, Water2!, Water3!, D1NRec
      
          'wgtsp! is in kg
          'water1! = all plain water (drinking water)
          'water2! = plain tap water from home (drinking water)  'not a category of water we are interested in for DEEM
          'water3! = carbonated water 2001-2002 only (not 1999-2000)  'not included in drinking water as per david hrdy
                
          sp1.rectype = "A"
          sp1.Sex = Sex
          
          'If AgeM > 0 Then  'this is an old convention I used from way back to pass age in months in the spdata1 record
          If AgeM > 0 And AgeM < 12 Then
            sp1.Age = AgeM * -1
          Else
            sp1.Age = Age
          End If
          
          sp1.SPNUM = SPNUM&  'not needed, same as HHID
          
          sp1.BFStat = CStr(BFStat)
          sp1.PLStat = CStr(PLStat)
          sp1.hhid = hhid&
          sp1.Race = CStr(Race)
          sp1.Origin = CStr(Origin)
          sp1.WtDay1 = StatWt4yr! / 2 ' the other half will come from NHANES 2003-2006, 1 quarter from 2003-2004, and the other quarter from 2005-2006
          
          sp1.PID = g_PIDNew&  '1.04
          sp1.indhhinc = indhhinc  '1.04 household income (need coded list)
          sp1.indfminc = indfminc  '1.04 family income used when hh income is not known
          sp1.indfmpir = indfmpir! '1.04 ratio of family income to poverty level
                      
          'If wgtsp! > 995 Or wgtsp! = 0 Then  'use epa suggested body weights where there is no valid body weight
          
          If wgtsp! > 995 Then Stop  'just checking, this was used with csfii but not nhanes for n/a
          
          If wgtsp! = 0 Then  'use epa suggested body weights where there is no valid body weight
            If Age <= 0 Then
              wgtsp! = infwt!(Sex, AgeM)  'these are now in kg as of 1.01
            Else
              wgtsp! = agewt!(Sex, Age)
            End If
          End If
                        
          sp2.rectype = "B"
          'sp2.SPNUM = SPNUM&
          sp2.bmi = 0  '1.05  'no bmi in nhanes 1999-2002
          sp2.wgtsp = wgtsp!
          sp2.hgtsp = hgtsp
          sp2.D1NRec = D1NRec
          'sp2.D2NRec = D2NRec
          sp2.D2NRec = 0
          
          If Water1! < 50000 Then  '1.04  individual 17302 has a water intake of 59472, which is clearly an error, so we set it to -1
            sp2.D1H2Oo = Water1!
          Else
            sp2.D1H2Oo = -1
          End If
          
          sp2.D2H2Oo = 0
                                                 
          'need to test the water summary variables for each participant to make sure they are valid, not -1
          'because otherwise they are counted as having consumed -1 grams
          If Water1! < 0 Then
            ValidPLAINDrinkingWater = 0
          Else
            ValidPLAINDrinkingWater = 1
          End If
          
          
          'as of 4-28-2011 water2! is not specifically reported in DEEM
          'water2 is tap water on day 1, not plain water on day 2
          If Water2! < 0 Then
            ValidTAPDrinkingWater = 0
          Else
            ValidTAPDrinkingWater = 1
          End If
          
          'as of 4-28-2011 water3! is not specifically reported in DEEM
          'carbonated water is included here but not used in DEEM at present
          If hhid& <= 9965 Then  '1999 and 2000 do not have carbonated water as summary item
            ValidCarbonatedDrinkingWater = 0
          Else
            If Water3! < 0 Then
              ValidCarbonatedDrinkingWater = 0
            Else
              ValidCarbonatedDrinkingWater = 1
            End If
          End If
          
        Else  'SurveyYear = 2 or 3 or 4, i.e., 2003-2004, 2005-2006, 2007-08
          'this can be accessed by both g_c_NHANES =1 or g_c_NHANES =2
          Do Until seqn1& = hhid&
            Input #30, seqn1&, sddsrvyr, ridstatr
            Input #30, riagenderm, ridageyr, ridagemn, ridageex, ridreth1, ridreth2, indhhinc, indfminc, indfrmpir!, ridexprg, sdmvpsu, sdmvstra, bmxwt!, bmxrecum!, bmxht!, bmxbmi!
          Loop
           
          If hhid& <> seqn1& Then Stop
          
          ReDim DayofWeek(2), WaterPlain!(2), WaterTap!(2), WaterBot!(2), WaterCarb!(2), WaterTapSource(2), NFoods(2)
          'from 2003-2008: sex, age, AGEM, wgtsp!, hgtsp, bmi!, BfStat1, BfStat2, ridreth1, ridreth2, StatWtDay1!, StatWt2Day!, 0, 0, 0, DayofWeek(1), WaterPlain!(1), WaterTap!(1), WaterBot!(1), WaterCarb!(1), WaterTapSource(1), nfoods(1), 0, 0, 0, DayofWeek(2), WaterPlain!(2), WaterTap!(2), WaterBot!(2), WaterCarb!(2), WaterTapSource(2), nfoods(2)
          
          'Note: waterplain = watertap + waterbot(tled) but does not include WaterCarb
          'WaterCarb is included in 2003-04 but is set at -1 for 2005-06 and 2007-08

          Input #1, Sex, Age, AgeM, wgtsp!, hgtsp, bmi!, BfStat1, BfStat2, PLStat, ridreth1, Race, StatWtDay1!, StatWt2Day!, Dummy!, Dummy!, Dummy!, DayofWeek(1), WaterPlain!(1), WaterTap!(1), WaterBot!(1), WaterCarb!(1), WaterTapSource(1), D1NRec, Dummy!, Dummy!, Dummy!, DayofWeek(2), WaterPlain!(2), WaterTap!(2), WaterBot!(2), WaterCarb!(2), WaterTapSource(2), D2NRec
          
                    
          
          'WaterPlain!(1) is never set at -1 in survey years 2, 3, 4
          'But WaterPlain!(2) is set at -1 for some records in survey years 2, 3, 4
          'Note that waterplain = watertap + waterbot (and both are reported in NHANES 2003-2008)
          'This is proven by the following 4 lines, which should cause a stop if not true
          
          
          If WaterPlain!(1) > WaterTap!(1) + WaterBot!(1) + 1 Then Stop
          If WaterPlain!(1) < WaterTap!(1) + WaterBot!(1) - 1 Then Stop
          If WaterPlain!(2) <> -1 Then
            If WaterPlain!(2) > WaterTap!(2) + WaterBot!(2) + 1 Then Stop
            If WaterPlain!(2) < WaterTap!(2) + WaterBot!(2) - 1 Then Stop
          End If
           'this also proves that if the participant has valid plain water then he has valid tap and bottled water
            
          If bmi! <> bmxbmi! Then Stop  'temp check
                    
          If StatWt2Day! = 0 Then WaterPlain(2) = -1  'this is to prevent the water on day 2 from being be used when the stat wt is 0
          'thus we do not need to test for this later when computing water means

          'some tests I made
          'If StatWtDay1! = 0 Then Stop
          'If StatWt2Day! = 0 And D2NRec > 0 Then Stop
          'If D1NRec = 0 And WaterPlain(1) > 0 Then Stop  'testing
          'If D2NRec = 0 And WaterPlain(2) > 0 Then Stop  'testing
          
          'wgtsp! is in kg
        
            sp1.rectype = "A"
            sp1.Sex = Sex
          
            If AgeM > 0 And AgeM < 12 Then
              sp1.Age = AgeM * -1
            Else
              sp1.Age = Age
            End If
                             
          'sp1.SPNUM = SPNUM&  'not needed, same as HHID
            If BfStat1 = 1 Or BfStat2 = 1 Then
              sp1.BFStat = 1
            Else
              sp1.BFStat = 0  'need to be careful here. In DEEM Acute and Calendex bfstat = "1" is breastfeeding and anything else is not breastfeeding
            'so it doesn't matter if we set bfstat to "0" or "2" for non-breastfeeding
            'but in dmfgen we need to change bfstat from "0" to "2" before using it so that it matches with the proper cohort
            '(this is left over from CSFII definitions)
            End If
          
            sp1.PLStat = CStr(PLStat)
            sp1.hhid = hhid&
            sp1.Race = CStr(Race)
            sp1.Origin = CStr(Origin)
            
            If g_c_NHANES = 1 Then
              Stop  'need to adjust the stat wts to reflect 2007-08 data
              sp1.WtDay1 = StatWtDay1! / 4  '4-29-2011
              sp1.Wt2Day = 0
              'we only use the 1st day
            Else  'g_nhanes = 2
              sp1.WtDay1 = 0
              'sp1.Wt2Day = StatWt2Day! / 2  'Cut stat wt from each of the two surveys (2003-04 and 2005-06) in half so that together they add up to 1
              sp1.Wt2Day = StatWt2Day! / 3  '1.10 Cut stat wt from each of the 3 surveys (2003-04 2005-06 2007-08) in thirds so that together they add up to 1
            '  we use both days
            End If
          
            sp1.PID = g_PIDNew&  '1.04
          
            sp1.indhhinc = indhhinc  '1.04 household income (need coded list)
            sp1.indfminc = indfminc  '1.04 family income used when hh income is not known (need coded list)
            sp1.indfmpir = indfrmpir! '1.04 ratio of family income to poverty level
        
          'If wgtsp! > 995 Or wgtsp! = 0 Then  'use epa suggested body weights where there is no valid body weight
          If wgtsp! > 995 Then Stop  'just checking
          
          If wgtsp! = 0 Then  'use epa suggested body weights where there is no valid body weight
            If Age <= 0 Then
              wgtsp! = infwt!(Sex, AgeM)  'these are now in kg as of 1.01
            Else
              wgtsp! = agewt!(Sex, Age)
            End If
          End If
                        
          sp2.rectype = "B"
          
          'sp2.SPNUM = SPNUM&

          sp2.bmi = bmxbmi!  '1.05
          If bmxbmi! > 150 Then Stop   'just checking
          
          sp2.wgtsp = wgtsp! 'sp2.wgtsp is now defined as 'single', thus saved with decimal point
          sp2.hgtsp = hgtsp
          sp2.D1NRec = D1NRec
          sp2.D2NRec = D2NRec
          
          If WaterPlain!(1) > 50000 Then Stop '1.04
          If WaterPlain!(2) > 50000 Then Stop '1.04
          
          sp2.D1H2Oo = WaterPlain!(1)
          sp2.D2H2Oo = WaterPlain!(2)
                              
          'note: BfStat1 and BfStat2 = 2 for anyone who is not breat fed (wierd but that's the way NHANES coded it)
                   
          If Age <= 3 Then
            'important decision: we are saying that if a child is breast feeding on either day in the 2-day survey then this child is categorized as breast feeding
            'the alternative would be to say that a child is categorized as breast feeding only on days that he actually breast feeds
            If BfStat1 = 1 Or BfStat2 = 1 Then
              BFStat = 1
            Else
              BFStat = 0
            End If
          End If
          
        End If
    End If   'csfii or nhanes
      
    If g_c_NHANES = 0 And g_TotUSOnly = 1 Then 'only in mode = 3, csfii, with single run through total us
      pidx.hhidt = hhid&
      pidx.indivt = SPNUM&
      Put #20, PID&, pidx
      Print #21, PID&, hhid&, SPNUM&
    End If
    
    '--------------
      
    ReDim NF(2)
    NF(1) = D1NRec
    NF(2) = D2NRec
    TNF = NF(1) + NF(2)
      
    If g_c_NHANES = 0 Then
        wght& = Wt2Day&
    
        'how do we skip people without valid second day?
    ElseIf g_c_NHANES = 1 Then  'now has all 10 years (99-08)
        Stop  'we need to resolve these stat wts if we do 1-day analysis
        If SurveyYear = 1 Then  'consistent with FARE, nhanes 1-day
          wght& = StatWt4yr! / 2  'for 1999-2002
        Else  'SurveyYear = 2 and SurveyYear = 3
          wght& = StatWtDay1! / 4 'for years 2003-2004 and 2005-2006
        End If
        
    ElseIf g_c_NHANES = 2 Then  '2003-2006 2-day
        'only with SurveyYear = 2 and SurveyYear = 3
        
        'calculate total weighted subpopulation but don't adjust for missing drinking water
        If StatWt2Day! = 0 Then  'don't include people without a valid second day
        
          If mode = 4 Or mode = 5 Then  '1.01
            Participant = 0
            Put #5, , Participant
          End If
          For Skip = 1 To TNF
            Line Input #1, dummyx$
          Next Skip
          GoTo endindividual
        Else
          'wght& = StatWt2Day! / 2  'using only 2003-2006 surveys , consistent with FARE
          wght& = StatWt2Day! / 3  '1.10  '3 surveys now included
        End If
    End If
      
    If g_c_NHANES = 0 Then
        If mode = 3 Or mode = 4 Then
      
          SAICno = SAICno + 1
          Saichh& = 0
          SaicIndiv = 0
          Do Until Saichh& = hhid And SaicIndiv = SAICno
            Input #12, Saichh&, SaicIndiv, SaicBw!, SaicAge, Saicd1, d1_d_Tot!, d1_d_Tap!, d1_d_Bot!, d1_d_Oth!, d1_d_Mis!, d1_i_Tot!, d1_i_Tap!, d1_i_Bot!, d1_i_Oth!, d1_i_Mis!
            Input #12, Saichh&, SaicIndiv, SaicBw!, SaicAge, Saicd2, d2_d_Tot!, d2_d_Tap!, d2_d_Bot!, d2_d_Oth!, d2_d_Mis!, d2_i_Tot!, d2_i_Tap!, d2_i_Bot!, d2_i_Oth!, d2_i_Mis!
          Loop
            
          'TEST SAIC data for correct match to this individual; if there is a problem here it is likely to be in the data base and not in this program
        
          If Saicd1 <> 1 Then Stop
          If Saicd2 <> 2 Then Stop
          If Saichh& <> hhid& Then Stop
          If SaicIndiv <> SAICno Then Stop
          If Age > 0 Then  'there is a problem with some saic ages for infants (age 0) so can't test for infants
            If SaicAge <> Age Then Stop
          End If
        ElseIf mode = 5 Then
          'don't do LI until water data are available
        End If
       
        '4-28-2011  'ValidDrinkingWater2 now used instead of ValidDrinkingWater1 to signify that there are valid water intake for both days
        ValidDrinkingWater2 = 0
        If D1H2Oo < 997 And D2H2Oo < 997 Then ValidDrinkingWater2 = 1
       
    Else   'nhanes

        'If mode = 3 Or mode = 4  Then  'don't do LI until water data are available
        If mode = 3 Or mode = 4 Or mode = 5 Then  '1.02
          DirWaterAll! = 0
          DirWaterTap! = 0
          DirWaterBot! = 0
          'DirWaterBotOther! = 0
          'DirWaterCarb! = 0
          
          ValidDrinkingWater1 = 1  'default for day 1 only
          If g_c_NHANES = 1 Then
            ValidDrinkingWater2 = 0
          Else
            ValidDrinkingWater2 = 1 'default for 2-day analysis
          End If
          
          If PID <= 9965 Then  '1999-2000 nhanes
               '1990-2000 (PID 1 to PID 9965 1-day) all plain water (water1!) and plain tap water from home (water2!) is reported for the entire day
               'but carbonated water must be extracted from line items 92410110, 92410210, and 92410250
            If Water1! < 0 Then ValidDrinkingWater1 = 0  'validdrinkingwater2 is irrelevant because this is only used with two-day survey data
            
          ElseIf PID <= 21004 Then  '2001-2002 nhanes
             
             '2001-2002 (PID 9966-21004 1-day): in addition to water1 and water2, water3 (carbonated water) is reported
             'be careful not to double count carbonated water from line items 92410110, 92410210, and 92410250
             'there is no propel or vitamin water in 2001-2002
            If Water1! < 0 Then ValidDrinkingWater1 = 0 'plain water
            'validdrinkingwater2 is irrelevant because this is only used with two-day survey data
            
            'if water3! (carb water) is invalid (-1) but plain water is valid I don't drop this individual by assigning ValidDrinkingWater1 = 0
            'but you could do this by unremming this next line
            'If water3! < 0 Then ValidDrinkingWater1 = 0 'carb water
             
          ElseIf PID <= 31126 Then  '2003-2004 nhanes
             '2003-2004 (PID 21006 to 31126, 2-day): we have "water plain", "water tap", "water bottled", and "water carbonated" as summary data
             'again be careful not to double count carbonated water included as a line item
             'propel (94210100) needs to be included as bottled water
             If WaterPlain!(1) < 0 Or (g_c_NHANES = 2 And WaterPlain!(2) < 0) Then ValidDrinkingWater2 = 0 'this is to be used with 2-day analysis
             If WaterPlain!(1) < 0 Then ValidDrinkingWater1 = 0  'this is to be used with 1st day analysis
             
             'At present I only use plain water to validate drinking water status of this individual,
          ElseIf PID <= 41474 Then  '2005-2006 nhanes

             '2005-2006 drinking water is now included as a line item but we will not include this yet
             'so we use the same method as for 2003-04, except that carbonated water is no longer provided as a summary variable (it must be pulled from line items),
             If WaterPlain!(1) < 0 Or WaterPlain!(2) < 0 Then ValidDrinkingWater2 = 0 'this is to be used with 2-day analysis
             If WaterPlain!(1) < 0 Then ValidDrinkingWater1 = 0  'this is to be used with 1st day analysis
             'At present I only use plain water to validate drinking water status of this individual, I have already show above that people with valid drinking water also have valid tap and bottled water estimates
          Else
             '2007-2008 drinking water is now included as a line item but we will not include this yet
             'so we use the same method as for 2003-04, except that carbonated water is no longer provided as a summary variable (it must be pulled from line items),
             
             'apparently there are no cases in the 2007-08 survey where WaterPlain!(1) = -1 or WaterPlain!(2) = -1 but I leave the following check here to be consistent
             If WaterPlain!(1) < 0 Or WaterPlain!(2) < 0 Then ValidDrinkingWater2 = 0 'this is to be used with 2-day analysis
             If WaterPlain!(1) < 0 Then ValidDrinkingWater1 = 0  'this is to be used with 1st day analysis
             
             'At present I only use plain water to validate drinking water status of this individual, I have already show above that people with valid drinking water also have valid tap and bottled water estimates
          End If
          
        End If
    End If
            
      'only count drinking water if valid survey data is available for both days
            
     'PLSTAT CODES
     '1 = PREG
     '2 = LACTATING
     '3 = PREG AND LACT
     '4 = NOT PREG OR LACT
     '5 = NOT FEMALE 10-55
          
    Flag = 0
     
Demographic_Logic:
     
    
     
     'this is where the subpopulations are defined as used in DEEM-FCID Chronic
     'these must correspond to the subpopulations that are listed in that program
     
    If g_c_NHANES = 0 Then  'csfii 94-98
   
      Hispanic = 0
      If Origin > 0 And Origin < 5 Then Hispanic = 1  'already tested to see that it is 0 or 1-4

      If popx = 1 Then  'everybody on board
         Flag = 1
      ElseIf popx = 2 Then  'spring
         If (D1Mnth = 3 And D1Date > 20) Or D1Mnth = 4 Or D1Mnth = 5 Or (D1Mnth = 6 And D1Date < 21) Then Flag = 1
      ElseIf popx = 3 Then  'summer
         If (D1Mnth = 6 And D1Date > 20) Or D1Mnth = 7 Or D1Mnth = 8 Or (D1Mnth = 9 And D1Date < 21) Then Flag = 1
      ElseIf popx = 4 Then  'fall
        If (D1Mnth = 9 And D1Date > 20) Or D1Mnth = 10 Or D1Mnth = 11 Or (D1Mnth = 12 And D1Date < 21) Then Flag = 1
      ElseIf popx = 5 Then  'winter
        If (D1Mnth = 12 And D1Date > 20) Or D1Mnth = 1 Or D1Mnth = 2 Or (D1Mnth = 3 And D1Date < 21) Then Flag = 1
      ElseIf popx = 6 Then 'region = northeast
        If REGION = 1 Then Flag = 1
      ElseIf popx = 7 Then  'midwest
        If REGION = 2 Then Flag = 1
      ElseIf popx = 8 Then  'south
        If REGION = 3 Then Flag = 1
      ElseIf popx = 9 Then  'west
        If REGION = 4 Then Flag = 1
      ElseIf popx = 10 Then  'hispanic
        If Hispanic Then Flag = 1
      ElseIf popx = 11 Then
        If Hispanic = 0 And Race = 1 Then Flag = 1  'white other than hispanic
      ElseIf popx = 12 Then
        If Hispanic = 0 And Race = 2 Then Flag = 1 'black other than hispanic
      ElseIf popx = 13 Then
        If Hispanic = 0 And Race > 2 Then Flag = 1  'other race not hispanic
      ElseIf popx = 14 Then 'nursing infants
        If Age <= 0 And BFStat = 1 Then Flag = 1
      ElseIf popx = 15 Then 'non bf infants
        If Age <= 0 And BFStat <> 1 Then Flag = 1
      ElseIf popx = 16 Then '"FEMALE 13+ PREG/NOT NURSING"
        If Sex = 2 And Age > 12 And PLStat = 1 Then Flag = 1
      ElseIf popx = 17 Then '"FEMALE 13+ NURSING"
        If Sex = 2 And Age > 12 And (PLStat = 2 Or PLStat = 3) Then Flag = 1
      ElseIf popx = 18 Then  'children ages 1-6
        If Age > 0 And Age < 7 Then Flag = 1
      ElseIf popx = 19 Then  'children 7-12
        If Age > 6 And Age < 13 Then Flag = 1
      ElseIf popx = 20 Then  'males 13-19
        If Sex = 1 And (Age > 12 And Age < 20) Then Flag = 1
      ElseIf popx = 21 Then '"FEMALES 13-19/NP/NN"
       If Sex = 2 And PLStat = 4 And (Age > 12 And Age < 20) Then Flag = 1
      ElseIf popx = 22 Then ' "MALES 20+"
        If Sex = 1 And Age > 19 Then Flag = 1
      ElseIf popx = 23 Then 'females 20+ NP/NN
        If Sex = 2 And Age >= 20 Then
          If Age > 55 Then
            Flag = 1
          ElseIf PLStat = 4 Then
            Flag = 1
          End If
        End If
      ElseIf popx = 24 Then 'seniors
        If Age >= 55 Then Flag = 1
      ElseIf popx = 25 Then 'all infants
        If Age <= 0 Then Flag = 1
      ElseIf popx = 26 Then 'F 13-50
       If Sex = 2 And (Age >= 13 And Age <= 50) Then Flag = 1
      ElseIf popx = 27 Then  'children 1-2
        If Age > 0 And Age < 3 Then Flag = 1
      ElseIf popx = 28 Then  'children 3-5
        If Age > 2 And Age < 6 Then Flag = 1
      ElseIf popx = 29 Then 'children 6-12
        If Age > 5 And Age < 13 Then Flag = 1
      ElseIf popx = 30 Then 'teens 13-19
        If Age > 12 And Age < 20 Then Flag = 1
      ElseIf popx = 31 Then 'adults 20-49
       If Age > 19 And Age < 50 Then Flag = 1
      ElseIf popx = 32 Then  'adults 50+
        If Age > 49 Then Flag = 1
      ElseIf popx = 33 Then 'females 12-49
        If (Age > 12 And Age < 50) And Sex = 2 Then Flag = 1
      End If
    Else 'nhanes 1999-2006
     
     'bw = body weight in kg
     'ht = height in cm
     'bmi is body mass index
      
      'the following code was used when setting up the NHANES intake/demographic files:
      
      'If ridpred = 1 Then  'there is no info about lactating women in nhanes
      '  'pregnancy status (females) (1 = pregnant; 2 = not preg; 9 = don't know)
      '  plstat = 1  'preg
      'Else '(2 or 9)
      '  plstat = 0  'not preg, don't know
      'End If
            
      'for NHANES 1999-2002, breast feeding is determined by:
      'If Status = 4 Then  'this is  breast fed infant or child
      '  bfstat = 1
      'Else  'not breast fed
      '  If ridageyr <= 3 Then
      '    bfstat = 2  '3 years or under but not breast fed
      '  Else
      '    bfstat = 0  'older than 3 years, not breast fed
      '  End If
      'End If
      'but for NHANES 2003-2006 breast feeding is determined for each day in the 2-day survey
      'BfStat1 = BreastFed(1)
      'BfStat2 = BreastFed(2)
      'note above that we have decided to make the child breast feeding if he/she is breast fed on either day
      'but this can be easily changed in the code above

     'If ridreth1 = 1 Or ridreth1 = 2 Then  'mex am/ other hispanic
     ' race = 1  'hispanic
     'ElseIf ridreth1 = 3 Then 'nh white
       'race = 2 'nh white
     'ElseIf ridreth1 = 4 Then 'nh black
     '  race = 3 'nh black
     'Else
     '  race = 4 'other
     'End If
        
          
      If popx = 1 Then  'everybody on board
        Flag = 1
      ElseIf popx = 2 Then  'hispanic
        If Race = 1 Then Flag = 1
      ElseIf popx = 3 Then
        If Race = 2 Then Flag = 1  'white other than hispanic
      ElseIf popx = 4 Then
        If Race = 3 Then Flag = 1 'black other than hispanic
      ElseIf popx = 5 Then
        If Race = 4 Then Flag = 1  'other race not hispanic
      ElseIf popx = 6 Then 'nursing infants  'under 1 year
        If Age <= 0 And BFStat = 1 Then Flag = 1
      ElseIf popx = 7 Then 'non nursing infants  'under 1 year
        If Age <= 0 And BFStat <> 1 Then Flag = 1
      ElseIf popx = 8 Then '"FEMALE 13+ PREG
        If Sex = 2 And Age > 12 And PLStat = 1 Then Flag = 1
      ElseIf popx = 9 Then  'children ages 1-6
        If Age > 0 And Age < 7 Then Flag = 1
      ElseIf popx = 10 Then  'children 7-12
        If Age > 6 And Age < 13 Then Flag = 1
      ElseIf popx = 11 Then  'males 13-19
        If Sex = 1 And (Age > 12 And Age < 20) Then Flag = 1
      ElseIf popx = 12 Then '"FEMALES 13-19/Not preg
        If Sex = 2 And PLStat = 0 And (Age > 12 And Age < 20) Then Flag = 1
      ElseIf popx = 13 Then ' "MALES 20+"
        If Sex = 1 And Age > 19 Then Flag = 1
      ElseIf popx = 14 Then 'females 20+ Not preg
        If Sex = 2 And Age >= 20 Then
          If Age > 55 Then
            Flag = 1
          ElseIf PLStat = 0 Then
            Flag = 1
          End If
        End If
      ElseIf popx = 15 Then 'seniors
        If Age >= 55 Then Flag = 1
      ElseIf popx = 16 Then 'all infants
        If Age <= 0 Then Flag = 1
      ElseIf popx = 17 Then 'F 13-50
        If Sex = 2 And (Age >= 13 And Age <= 50) Then Flag = 1
      ElseIf popx = 18 Then  'children 1-2
        If Age > 0 And Age < 3 Then Flag = 1
      ElseIf popx = 19 Then  'children 3-5
        If Age > 2 And Age < 6 Then Flag = 1
      ElseIf popx = 20 Then 'children 6-12
        If Age > 5 And Age < 13 Then Flag = 1
      ElseIf popx = 21 Then 'teens 13-19
        If Age > 12 And Age < 20 Then Flag = 1
      ElseIf popx = 22 Then 'adults 20-49
       If Age > 19 And Age < 50 Then Flag = 1
      ElseIf popx = 23 Then  'adults 50+
        If Age > 49 Then Flag = 1
      ElseIf popx = 24 Then 'females 12-49
        If (Age > 12 And Age < 50) And Sex = 2 Then Flag = 1
      End If
   
    End If
   
     
   'the following code is for all values of g_NHANES
     
    If Flag = 0 Then
   
      For Skip = 1 To TNF
        Line Input #1, dummyx$
      Next Skip
      GoTo endindividual
      
    End If
  'markkk
    If mode = 3 Or mode = 4 Then
      If g_c_NHANES = 0 Then
      
        If ValidDrinkingWater2 = 1 Then
          'first prove that the saic estimates are the same as the csfii amounts, csfii amounts are in ounces, saic amounts are in grams
          If d1_d_Tot! < D1H2Oo * 29.57 * 0.999 Or d1_d_Tot! > D1H2Oo * 29.57 * 1.001 Then Stop
          If d2_d_Tot! < D2H2Oo * 29.57 * 0.999 Or d2_d_Tot! > D2H2Oo * 29.57 * 1.001 Then Stop
          'g_TotDW# = g_TotDW# + (d1_d_Tot! + d2_d_Tot!) * wght& / (wgtsp! / 2.2)   'g/ounce * stat wt/bw-kg
          g_TotDW# = g_TotDW# + (d1_d_Tot! + d2_d_Tot!) * wght& / wgtsp!    'wgtsp is now in kg, no longer needs to be adjusted here
        End If
        
      ElseIf g_c_NHANES = 1 Then  'all below 4-28-2011
        If ValidDrinkingWater1 = 1 Then
          If SurveyYear = 1 Then
            g_TotDW# = g_TotDW# + Water1! * wght& / wgtsp!    'wgtsp is now in kg, no longer needs to be adjusted here
          Else
            g_TotDW# = g_TotDW# + WaterPlain!(1) * wght& / wgtsp!
          End If
        End If
        
      ElseIf g_c_NHANES = 2 Then  'only surveyyear = 2 and surveyyear = 3
      
      'markkk
        If ValidDrinkingWater2 = 1 Then
          g_TotDW# = g_TotDW# + (WaterPlain!(1) + WaterPlain!(2)) * wght& / wgtsp!    'wgtsp is now in kg, no longer needs to be adjusted here
        End If
      
      End If
    End If
      
    If mode = 4 Then  'making 24-hour acute intake file
    
       ReDim Expos!(NRacFF, g_MaxNDays), Sum(g_MaxNDays)     'nracff was d1
       
    ElseIf mode = 5 Then 'making line-item acute intake file
    
       'ReDim Expos!(1000, g_MaxNDays), Sum(g_MaxNDays)     '1000 is a safe guess as to max number of RAC/ff eaten on any given day
       'ReDim RACff(1000, g_MaxNDays)
       'ReDim IntakeTime(1000, g_MaxNDays)
       ReDim Expos!(NRacFF, g_MaxNDays), Sum(g_MaxNDays)     '1.02
       ReDim RACff(NRacFF, g_MaxNDays)
       ReDim IntakeTime(NRacFF, g_MaxNDays)
    End If
     
    
    For d = 1 To g_NDays  '2.0  'count people-days used
         
      ReDim RACx!(MaxRACIndex, nff)
         
      If g_c_NHANES = 0 Then
         
           g_nw& = g_nw& + wght& 'count individuals passing screen (use sample weight) (person-days wtd)
           g_nu& = g_nu& + 1 'number of actual person-days
           
           If ValidDrinkingWater2 Then  '1st day only
             g_NDrinkingWaterDaysW& = g_NDrinkingWaterDaysW& + wght&
             g_NDrinkingWaterDaysu& = g_NDrinkingWaterDaysu& + 1
           End If
                  
      ElseIf g_c_NHANES = 1 And d = 1 Then  '1st day only
           
           g_nw& = g_nw& + wght& 'count individuals passing screen (use sample weight)
           g_nu& = g_nu& + 1 'number of actual person-days
         
           If ValidDrinkingWater1 Then  '1st day only
             g_NDrinkingWaterDaysW& = g_NDrinkingWaterDaysW& + wght&
             g_NDrinkingWaterDaysu& = g_NDrinkingWaterDaysu& + 1
           End If
           
      ElseIf g_c_NHANES = 2 Then
           g_nw& = g_nw& + wght& 'count individuals passing screen (use sample weight) (person-days wtd)
           g_nu& = g_nu& + 1 'number of actual person-days
           
           If ValidDrinkingWater2 Then  'first and second day valid drinking water
             g_NDrinkingWaterDaysW& = g_NDrinkingWaterDaysW& + wght&
             g_NDrinkingWaterDaysu& = g_NDrinkingWaterDaysu& + 1
           End If
         
      End If
      
    'some tests I ran
     ' If d = 1 Then
     '    If NF(1) = 0 And (ValidDrinkingWater1 = 1 Or ValidDrinkingWater2 = 1) Then Stop  'testing to see if there are any people who do not eat but might have water consumption
     ' End If
         
     ' If d = 2 Then  'this is not meant to remain in code after local qa
     '   If g_c_NHANES = 2 And NF(2) = 0 And ValidDrinkingWater2 = 1 Then Stop         'testing to see if there are any people who do not eat but might have water consumption
     ' End If

         
         'NB if you are doing a two day analysis and one or both days of direct water intake reporting is missing, then this person will be skipped
         'but if you are doing a 1-day analysis and the person has valid direct water intake on day 1 then this person is used,
         'even if he does not have valid drinking water on day 2
         'Thus ValidDrinkingWater2 only is relevant when doing a 2-day analysis, which is always the case with CSFII,
         'but not always the case with NHANES
         
      'all values of g_c_NHANES:
      
      If NF(d) > 0 Or (g_c_NHANES = 1 And ValidDrinkingWater1 = 1) Or (g_c_NHANES <> 1 And ValidDrinkingWater2 = 1) Then
        
         'even if this is a g_c_nhanes = 1 analysis (1st day only) you still need to read in the intake line here on day 2
         'even if there is no food intake on this day, you still need to include direct water if any
         
        'we only want to include direct water if mode = 5  (line item)
        'direct water is only included in the NHANES data as a line item after 2005
        'we do not want to use the recipe for direct water because it has a 0 for ingredient and 0 for amount
        
'the following is taken from NFCSCodesUsedNH2.txt generated by this program
'it shows which water-related codes are actually encountered in the line item food intake
'we need to make sure that we don't double count direct water when using the waterplain, watertap, and waterbottled variables
'that are provide outsided of the line item food intakes
        
' 94000000      0             9746          2819   'water as ingreditent
' 94000100      0             11211         29663  'tap water direct
' 94100100      0             11212         19788  'bottled water direct
' 94100200      0             11213         130
' 94100300      0             11735         6
' 94210100      0             11214         199
' 94210200      0             11215         120

        
        

Dim TotPlainWater!  'this is used to check on total line item amounts of tap and bottled water for each individual on each day
'FoodCodes = 94000100 and 94100100 are not reported in 2003-2004

'NB: If we are computing chronic water intake amounts or 24-hour total amounts of tap and bottled water
'(modes 3 or 4) we need to use the WaterPlain!(d) = WaterTap!(d) + WaterBot!(d) amounts and skip over
'any line item intake involving 94000100 and 94100100
'But if we are doing line item amounts (mode = 5) then we need to fake the timing of tap and bottled water intake
'over the day for surveyyear = 2 (2003-2004) using the WaterTap!(d) and WaterBot!(d)

'note that carbonated water is not included in waterplain, and that in the EPA FCID recipes they have no
'water-related ingredients, meaning that it is based on commercial water, which is not included in the FCID recipes
'So that FoodCodes 92410110 or 92410210 or 92410250 result in no direct water intake
'92410110,5671,"CARBONATED WATER,SWEETEND(INCL TONIC,QUININE WATER)","Carbonated water, sweetened"
'92410210,5672,"CARBONATED WATER, UNSWEETENED (INCL CLUB SODA)","Carbonated water, unsweetened"
'92410250,5673,"CARBONATED  WATER, SUGAR-FREE","Carbonated water, sugar-free"


TotPlainWater! = 0
        For f = 1 To NF(d)  'process the daily food consumption items from the food consumption records

          Input #1, d2, f2, FoodCode&, FCIndex, ModCode&, FoodAmt!, OccTime
       'the following two lines are used to show that the line item intakes for tap and bottled water add up to total plain water reported outside of the line item intakes
       
          If FoodCode& = 94000100 Or FoodCode& = 94100100 Then 'tap and bottled (unsweetened) drinking water, but these only show up in 2005-2008
          
            TotPlainWater! = TotPlainWater! + FoodAmt!  'this is just used in internal QA to check that total tap water and bottled water unsweetened reported as line items are consistent with waterplain!(d), watertap!(d), waterbot!(d)
            If mode < 5 Then GoTo SkipToNextF  'We don't want to double count direct water and except for mode 5 it is taken from waterplain, watertap, waterbot data for this individual
            'so we skip further processing unless we are generating Line Item Acute files
          End If
          
          
'the following lines were used to research where the codes started showing up in the NHANES surveys
          'If FoodCode& = 94000100 Then Stop   'tap water starting 2005
          'If FoodCode& = 94100100 Then Stop  'bottled water unsweet starting 2005
          'If FoodCode& = 94100200 Then Stop  'bottled water sweet starting 2005
          
       'the following lines of code were used to show where certain water related code began to show up in NHANES
            'If FoodCode& = 94000000 Then Stop   'water as ingredient starting 1999
'            If FoodCode& = 94000100 Then Stop   'tap water starting 2005
'            If FoodCode& = 94100100 Then Stop   'Water, bottled, unsweetened starting 2005
'            If FoodCode& = 94100200 Then Stop   'Water, bottled, sweetened starting 2005
          ' If FoodCode& = 94210100 Then Stop   'Propel Fitness Water starting 2003
 '           If FoodCode& = 94210200 Then Stop   'Vitamin Water starting 2005
          'If FoodCode& = 92410110 Then Stop  'carbonated water sweet starting 1999
          'If FoodCode& = 92410210 Then Stop  'carbonated water unsweeted with  starting 1999
          'If FoodCode& = 92410250 Then Stop  'carbonated water  sugar free starting 1999

'markw
                    
          If d = 1 Or (d = 2 And g_c_NHANES <> 1) Then  'skip day 2 when running with one-day only nhanes
            If FoodCode& = 11000000 Then
               'skip mother's milk
               
            
              
              'as of 4-28-2011 we are going to skip the reporting of water intake based on individual intake items and use only the daily amounts reported separately
              
              'the following direct-water-related codes are not going to be included in direct water intake for now
              'before we look up ingredients for foods we want to intercept any water codes that we consider to be direct water
              'ElseIf g_c_NHANES > 0 And FoodCode& = 94100100 Then 'tap water starting 2005
              '  DirWaterTap! = DirWaterTap! + FoodAmt!

              'ElseIf g_c_NHANES > 0 And FoodCode& = 94100200 Then 'Water, bottled, sweetened, with low or no calorie sweetener" starting 2003
              '  DirWaterBotOther! = DirWaterBotOther! + FoodAmt!

              'ElseIf g_c_NHANES > 0 And FoodCode& = 94210100 Then 'Propel Fitness Water starting 2003
              '  DirWaterBotOther! = DirWaterBotOther! + FoodAmt!

              'ElseIf g_c_NHANES > 0 And FoodCode& = 94210200 Then 'Vitamin Water starting 2005
              '  DirWaterBotOther! = DirWaterBotOther! + FoodAmt!

              'ElseIf g_c_NHANES > 0 And FoodCode& = 92410110 Then 'carbonated water sweetened starting 1999
              '  DirWaterCarb! = DirWaterCarb! + FoodAmt!

              'ElseIf g_c_NHANES > 0 And FoodCode& = 92410210 Then 'carbonated water unsweetened starting 1999
              '  DirWaterCarb! = DirWaterCarb! + FoodAmt!

              'ElseIf g_c_NHANES > 0 And FoodCode& = 92410250 Then 'carbonated water sugar-free starting 1999
              '  DirWaterCarb! = DirWaterCarb! + FoodAmt!
              
            'ElseIf mode = 5 And (FoodCode& = 94000100 Or FoodCode& = 94100100 Or FoodCode& = 94100200) Then
            ElseIf mode = 5 And (FoodCode& = 94000100 Or FoodCode& = 94100100) Then  'TAP AND BOTTLED (UNSWEETENED) DIRECT WATER
               
              'note that for the years 1999-2004 there is no line item breakout for tap and bottled drinking water
              If SurveyYear < 3 Then Stop  'just to prove that there is no line item breakout for drinkng water before 2005
              Sum(d) = Sum(d) + 1
              Expos!(Sum(d), d) = FoodAmt!
              RACff(Sum(d), d) = WaterDirectIndex(0)  'we are not breaking out tap and bottled here, but instead making it just drinking water all sources
              IntakeTime(Sum(d), d) = OccTime
                            
              'if we use the following lines to break out tap and bottled direct water we would be double counting
              'instead we have forced all FoodCode& = 94000100 Or FoodCode& = 94100100 to be registered as drinking water all sources
              
                'If FoodCode& = 94000100 Then
                '  Sum(d) = Sum(d) + 1
                '  Expos!(Sum(d), d) = FoodAmt!
                '  RACff(Sum(d), d) = WaterDirectIndex(1)  'tap water direct
                '  IntakeTime(Sum(d), d) = OccTime
                'Else
                '  Sum(d) = Sum(d) + 1
                '  Expos!(Sum(d), d) = FoodAmt!
                '  RACff(Sum(d), d) = WaterDirectIndex(2)  'bottled water direct
                '  IntakeTime(Sum(d), d) = OccTime
                'End If
              
            Else
            
              
 
              tp = 0
              Call GetNFCSModIndex(FoodCode&, ModCode&, tp)
              'If FoodCode& = 94000100 Or FoodCode& = 94100100 Or FoodCode& = 94100200 Then Stop
              If tp = 0 Then Stop

              If ModCode& = 0 Then
                 If g_a_Mod&(tp) = 0 Then  'we are at mod code 0, no need to search through other mods
                   NFCSModIndex = g_a_NFCSModIndex(tp)
                 Else 'we are at highest mod code for this nfcs code, only need to search down
                   Do Until g_a_Mod&(tp) = 0
                     tp = tp - 1
                   Loop
                   If FoodCode& <> g_a_NFCS&(tp) Or g_a_Mod&(tp) <> 0 Then
                     Stop 'temp
                   Else
                     NFCSModIndex = g_a_NFCSModIndex(tp)
                   End If
                 End If
              Else  'active mod code, need to match

                 If ModCode& = g_a_Mod&(tp) Then  'match
                   NFCSModIndex = g_a_NFCSModIndex(tp)
                                    
                 ElseIf ModCode& > g_a_Mod&(tp) Then  'search up for match
                   Do Until ModCode& = g_a_Mod&(tp)
                     tp = tp + 1
                     If g_a_NFCS&(tp) <> FoodCode& Then 'we have left the foodcode, so there must not be a matching modcode in the foodcode area
                       Stop  'TEMP
                     End If
                   Loop
                   If ModCode& <> g_a_Mod&(tp) Then Stop 'this can only happen if we have a programming error
                   NFCSModIndex = g_a_NFCSModIndex(tp)
                    
                 ElseIf ModCode& < g_a_Mod&(tp) Then 'search down for match
                   Do Until ModCode& = g_a_Mod&(tp)
                     tp = tp - 1
                     If g_a_NFCS&(tp) <> FoodCode& Then 'we have left the foodcode, so there must not be a matching modcode in the foodcode area
                       Stop  'TEMP
                     End If
                   Loop
                    
                   If ModCode& <> g_a_Mod&(tp) Then Stop  'this can only happen if we have a programming error
                   NFCSModIndex = g_a_NFCSModIndex(tp)
                     
                 End If
                
              End If
              
              Get #2, NFCSModIndex, rcpind
              
              If rcpind.nfcs = 0 Then  'look up substitute recipe
                 Flag = 0
                 For z = 1 To g_NSubRecs
                   If g_SubInd(1, z) = NFCSModIndex Then
                     Flag = 1
                     FoodCode& = g_SubRec&(2, z)
                     ModCode& = g_SubMod&(2, z)
                     NFCSModIndex = g_SubInd(2, z)
                     Get #2, NFCSModIndex, rcpind
                     Exit For
                   End If
                 Next z
                
                 If Flag = 0 Then
                   MsgBox "No recipe available for foodcode:" & Str(FoodCode&) & " mod code:" & Str(ModCode&) & " index:" & Str(NFCSModIndex) & ". Can't continue without this recipe or entry in recipe substitution file.", vbInformation, "Computing Means for Chronic Module"
                   bu = 1
                   Exit Sub
                 End If
              End If

              If FoodCode& = rcpind.nfcs Then

                 If rcpind.mod Then
                   If ModCode <> rcpind.mod Then Stop
                 End If

                 For n = 1 To rcpind.numing
                     
                   Get #3, rcpind.firstrec + n - 1, rcping
                   k = rcping.ingcode  'rac index
                   FF = rcping.FF  'foodform
                   c! = FoodAmt! * rcping.perc
                  ' If k = 440 And FF = 901 Then Stop
                   
                   
                   If FF < 100 Then

                     FF = 100
                       'this should not happen with final recipes but this will let the program continue while testing
                        If PID = 1 And d = 1 And f = 1 And n = 1 Then Stop  'KEEP THIS HERE UNTIL WE ARE SURE THAT ff<100 does NOT occur
                   End If
                   
                   If FF > 999 Then Stop  'should never happen

                   If k = 0 Then
                     'skip this ingredient
                   Else
                     If k = 553 Then k = 533   '1.10 convert water, indirect, tap to all sources
                     If k = 554 Then k = 533 '1.10 convert water, indirect, bottled to all sources
                     If k = 555 Then k = 533  '1.10 convert water, indirect, other to all sources
                     If k = 556 Then k = 533  '1.10 convert water, indirect, source ns to all sources
                   
                     If mode = 3 Then  'the total consumption of this RAC/FF is summed, for later division by the number of individuals, to get the mean consumption amount
                       
                       For x = 1 To nff  'arbitrarily set to 100 as this is the most number of foodforms likely to be found for any given RAc
                         If FF = g_FFx(k, x) Then
                           RACx!(k, x) = RACx!(k, x) + c!  'this food form for this RAC has already been found, add consumption to this FF
                           Exit For
                         ElseIf g_FFx(k, x) = 0 Then  'this is the first time that this FF has been encountered for this RAC
                         'so it is added to the list of FF known for this RAC with its consumption
                           RACx!(k, x) = c!
                           g_FFx(k, x) = FF
                           Exit For
                         End If
                         
                       Next x

                     ElseIf mode = 4 Or mode = 5 Then  'acute files are generated here

                       If c! Then '1.10 we don't want to include rac/ff with 0 consumption amount
                         Recno& = k - 1
                         Recno2& = Recno& * 1000 + FF
                         Get #9, Recno2&, RXX
                         
                         If RXX.FFIndex < 1 Or RXX.FFIndex > NRacFF Then Stop  'temp check, shouldn't happen once code is  debugged
                         
                         If mode = 4 Then  '24-hour file generation, don't preserve each line item
                           Expos!(RXX.FFIndex, d) = Expos!(RXX.FFIndex, d) + c!
                         Else 'mode = 5, each line item RAC/FF is preserved with amount and time
                           Sum(d) = Sum(d) + 1
                           Expos!(Sum(d), d) = c!
                           RACff(Sum(d), d) = RXX.FFIndex
                           IntakeTime(Sum(d), d) = OccTime
                         End If
                       End If  '1.10
                    End If
                     
                   End If
                 Next n

              Else  'FoodCode& = rcpind.nfcs
                 Stop 'TEMP
             
              End If
            End If  'If FoodCode& = 11000000 Then
          End If  'd = 1 Or (d = 2 And g_c_NHANES <> 1)
SkipToNextF:
        Next f
        
  If WaterPlain!(d) <> -1 And SurveyYear >= 3 Then  'tap and bottled water are not line items in survey years 1999-2004
    'this proves that the total line item tap and bottled water amounts for this individual in 2005-2008 are equal to the WaterPlain!(d) amount reported with the demographic data for this individual
    
    If TotPlainWater! > WaterPlain!(d) + 1 Then Stop
    If TotPlainWater! < WaterPlain!(d) - 1 Then Stop
  End If
     
           
        If mode = 3 Then  'chronic means, all g_c_NHANES

          If d = 1 Or (d = 2 And g_c_NHANES <> 1) Then 'skip day 2 when running with one-day only nhanes
          'now that we have read through all foods eaten on day d for this individual, we need to adjust consumption amounts for each RAC/FF by
          'the body weight of the individual and weight the result using the appropriate stat weight

               For k = 1 To MaxRACIndex

                 If (k < 549 Or k > 556) And k <> 532 Then   'these are the water indices handled below
                 'NB if these water indices change then these boundaries will change
               
                 'g_trac#(k, x), g_racnu&(k, x), g_racnw&(k, x) are global variables and do not need to be in the argument list for this subroutine
                   
                   x = 1
                   While g_FFx(k, x) > 0

                     If RACx!(k, x) Then
                       g_trac#(k, x) = g_trac#(k, x) + RACx!(k, x) * wght& / wgtsp!
                       g_racnu&(k, x) = g_racnu&(k, x) + 1
                       g_racnw&(k, x) = g_racnw&(k, x) + wght&
                     End If
                     x = x + 1
                   Wend
                 End If
               
               Next k
               
               

               If g_c_NHANES = 0 Then  'CSFII only
            'process the saic water data, which is in grams/day
            'the current code here is valid only for CSFII, not NHANES
            'for drinking water, only process if a valid drinking water amount is available for both days
            'racx!(533,1) is taken from recipe files, so it does not show up here
            'the second index for racx!() is ff, so this is always 1 for direct water because the only food form for direct water is 110
               
               'with CSFII (g_c_NHANES = 0) we only use ValidDrinkingWater2
                 If d = 1 Then
                   If ValidDrinkingWater2 Then
                     RACx!(532, 1) = d1_d_Tot!  'direct water
                     RACx!(549, 1) = d1_d_Tap!
                     RACx!(550, 1) = d1_d_Bot!
                     RACx!(551, 1) = d1_d_Oth!
                     RACx!(552, 1) = d1_d_Mis!
                   End If
                   RACx!(553, 1) = d1_i_Tap!  'indirect water
                   RACx!(554, 1) = d1_i_Bot!
                   RACx!(555, 1) = d1_i_Oth!
                   RACx!(556, 1) = d1_i_Mis!
                 Else 'd = 2
                   If ValidDrinkingWater2 Then
                     RACx!(532, 1) = d2_d_Tot!  'direct water
                     RACx!(549, 1) = d2_d_Tap!
                     RACx!(550, 1) = d2_d_Bot!
                     RACx!(551, 1) = d2_d_Oth!
                     RACx!(552, 1) = d2_d_Mis!
                   End If
                   RACx!(553, 1) = d2_i_Tap!  'Indirect water
                   RACx!(554, 1) = d2_i_Bot!
                   RACx!(555, 1) = d2_i_Oth!
                   RACx!(556, 1) = d2_i_Mis!
                 End If
                 
                 If ValidDrinkingWater2 Then
                   k = 532  'direct water from survey
                   If RACx!(k, 1) Then
                     g_trac#(k, 1) = g_trac#(k, 1) + RACx!(k, 1) * wght& / wgtsp!
                     g_racnu&(k, 1) = g_racnu&(k, 1) + 1
                     g_racnw&(k, 1) = g_racnw&(k, 1) + wght&
                     g_FFx(k, 1) = 110
                   End If
          
                   For k = 549 To 552  'direct water
                     If RACx!(k, 1) Then
                       g_trac#(k, 1) = g_trac#(k, 1) + RACx!(k, 1) * wght& / wgtsp!
                       g_racnu&(k, 1) = g_racnu&(k, 1) + 1
                       g_racnw&(k, 1) = g_racnw&(k, 1) + wght&
                       g_FFx(k, 1) = 110
                     End If
                   Next k
                  
                 End If
                      
                 For k = 553 To 556 'indirect water
                   If RACx!(k, 1) Then
                     g_trac#(k, 1) = g_trac#(k, 1) + RACx!(k, 1) * wght& / wgtsp!
                     g_racnu&(k, 1) = g_racnu&(k, 1) + 1
                     g_racnw&(k, 1) = g_racnw&(k, 1) + wght&
                     g_FFx(k, 1) = 110
                   End If
                 Next k
               
               
               Else  'g_c_NHANES = 1 or 2
               
             'be careful, water in NHANES is reported by the gram, in CSFII it was by ounce
             'only total indirect water is available here (8602000000); there is no way to break out tap, bottled, other, NS as with CSFII (based on SAIC analysis)
             'indirect water is extracted from the recipes and the reporting of 94000000 as a line item
             'Indirect water is reported as variable "8602000000",389,"86B","Water, indirect, all sources"
             
             'for direct water, total, tap, and bottled, are available in some years but the source is different in 2-year set of NHANES data
             'as per David Hrdy we are not including carbonated water as direct water
             'this means that carbonated water intake (if any) is not included in the DEEM database
             'unless it is reported as a line item, which it is in later years but not earlier years
             'but it doesn't really matter because carbonated water (unsweetened) is based on "commercial" water which is not included in the FCID
             'recipes and thus doesn't show up in DEEMFCID
             
             'Seeing as how there is inconsistency between tap and bottled water before 2003, we probably don't want to
             'continue generating 1-day analyses for 1999-2008, but I am leaving code here so that you can see how
             'the direct water would be treated in different years

                 DirWaterAll! = 0
                 If PID <= 9965 Then  '1999-2000 nhanes
                  '1990-2000 (PID 1 to PID 9965 1-day) all plain water (water1!) and plain tap water from home (water2!) is reported for the entire day
                  'but no bottled water per se is reported
                   If ValidDrinkingWater1 Then DirWaterAll! = Water1!  '4-28-2011, this is only used when g_c_NHANES = 1
                 ElseIf PID <= 21004 Then  '2001-2002 nhanes
                  '2001-2002 (PID 9966-21004 1-day): in addition to water1 and water2, water3 (carbonated water) is reported
                  'but no bottled water per se is reported
                                    
                   If ValidDrinkingWater1 Then DirWaterAll! = Water1!   '4-28-2011, this is only used when g_c_NHANES = 1
                 
                 Else '2003-2008
                   '2003-2004 (PID 21006 to 31126, 2-day): we have "water plain", "water tap", "water bottled"

                   If g_c_NHANES = 1 Then
                     If ValidDrinkingWater1 Then DirWaterAll! = WaterPlain!(1)   '4-28-2011
                   Else
                     If ValidDrinkingWater2 Then DirWaterAll! = WaterPlain!(d)
                   End If
                   
                 'Else  '1.10
                 ''ElseIf PID <= 41474 Then  '2005-2006 nhanes
                 ''2005-2008 drinking water is now included as a line item but we will not include this yet
                   
                 '  If g_c_NHANES = 1 Then
                 '     If ValidDrinkingWater1 Then DirWaterAll! = WaterPlain!(1)   '4-28-2011
                 '  Else
                 '     If ValidDrinkingWater2 Then DirWaterAll! = WaterPlain!(d)
                 '  End If
                 End If
                 
                 If DirWaterAll! < 0 Then Stop  'just checking, shouldn't happen
                 
               'still in g_c_NHANES = 1 or 2
               'still in 'for d = 1 to ndays
               'still in mode = 3, chronic means
               
                 'continuing with direct water breakout by RAC for all sources, tap and bottled, for means
               
                 If d = 1 Then
                 
                   If (g_c_NHANES = 1 And ValidDrinkingWater1 = 1) Or (g_c_NHANES = 2 And ValidDrinkingWater2 = 1) Then '4-28-2011
                  'NB This means that if you are doing a two day analysis and one or both days of direct water intake reporting is missing, then this person will be skipped
                    'the second index for racx!() is ff, so this is always 1 for direct water because the only food form for direct water is 110
                    'WaterPlain!(2), WaterTap!(2), WaterBot!(2)

                     RACx!(532, 1) = DirWaterAll!
                     If g_c_NHANES = 2 Then
                       RACx!(549, 1) = WaterTap!(1)
                       RACx!(550, 1) = WaterBot!(1)
                     Else  'DON'T DO THIS for 1-day analysis because we don't have tap and bottled water for all years
                       RACx!(549, 1) = 0
                       RACx!(550, 1) = 0
                     End If
                 
                   End If
                     'for indirect water with NHANES we are currently picking up multiple food forms; if we ever get a
                     'break out of tap/bot/other for indirect the following will need to be modified for multiple food forms
                   
                     'racx!(533, 1) = indirect water all,  picked up by recipes applied to intake items, this code (inherited from CSFII/SAIC) will not be compatible with direct water food forms
                     'racx!(553, 1) = indirect water tap 'placeholder, not defined for NHANES
                     'racx!(554, 1) = indirect water bottled 'placeholder, not defined for NHANES
                     'racx!(555, 1) = indirect water other 'placeholder, not defined for NHANES
                     'racx!(556, 1) = indirect water n/s 'placeholder, not defined for NHANES
                 Else 'd = 2
                 
                   If g_c_NHANES = 2 And ValidDrinkingWater2 = 1 Then   'this can only happen with two day analysis
                     RACx!(532, 1) = DirWaterAll! 'direct water, this is plainwater!(2)
                     RACx!(549, 1) = WaterTap!(2)
                     RACx!(550, 1) = WaterBot!(2)
                   Else
                     RACx!(532, 1) = 0
                     RACx!(549, 1) = 0
                     RACx!(550, 1) = 0
                   End If
                     
                 
                  'for indirect water with NHANES we are currently picking up multiple food forms; if we ever get a
                  'break out of tap/bot/other for indirect the following will need to be modified for multiple food forms
               
                  'racx!(533, 1)  = indirect water all,  picked up by recipes
                  'racx!(553, 1) = indirect water tap 'placeholder, not defined for NHANES
                  'racx!(554, 1) = indirect water bottled 'placeholder, not defined for NHANES
                  'racx!(555, 1) = indirect water other 'placeholder, not defined for NHANES
                  'racx!(556, 1) = indirect water n/s 'placeholder, not defined for NHANES
                 End If
                 
               'still in g_c_NHANES = 1 or 2
               'still in 'for d = 1 to ndays
               'still in mode = 3, chronic means
               
               'now that we have generated direct water amounts for day d for this individual, we need to adjust consumption amounts  by
               'the body weight of the individual and weight the result using the appropriate stat weight
               
                 If (g_c_NHANES = 1 And ValidDrinkingWater1 = 1) Or (g_c_NHANES = 2 And ValidDrinkingWater2 = 1) Then '4-28-2011

                   k = 532  'direct water from survey
                   If RACx!(k, 1) > 0 Then
                     g_trac#(k, 1) = g_trac#(k, 1) + RACx!(k, 1) * wght& / wgtsp!
                     g_racnu&(k, 1) = g_racnu&(k, 1) + 1
                     g_racnw&(k, 1) = g_racnw&(k, 1) + wght&
                     g_FFx(k, 1) = 110
                   End If
                    
                   If g_c_NHANES = 2 Then
                     For k = 549 To 550 '552  'direct water tap and bottled
                       If RACx!(k, 1) Then
                         g_trac#(k, 1) = g_trac#(k, 1) + RACx!(k, 1) * wght& / wgtsp!
                         g_racnu&(k, 1) = g_racnu&(k, 1) + 1
                         g_racnw&(k, 1) = g_racnw&(k, 1) + wght&
                         g_FFx(k, 1) = 110
                       End If
                     Next k
                   End If
                   
                 End If
                    
                'for now there is no breakdown for indirect water by source
                'For k = 553 To 556 'indirect water
                '  If racx!(k, 1) Then
                '    g_trac#(k, 1) = g_trac#(k, 1) + racx!(k, 1) * wght& / wgtsp!
                '    g_racnu&(k, 1) = g_racnu&(k, 1) + 1
                '    g_racnw&(k, 1) = g_racnw&(k, 1) + wght&
                '    g_FFx(k, 1) = 110
                '  End If
               'Next k
               End If 'g_c_nhanes = 1 or 2
             
             End If  'd = 1 Or (d = 2 And g_c_NHANES <> 1)
             
             'this is end of mode = 3
             
  ' - - - - - - - - - -
        ElseIf mode = 4 Then
        
          '24 hour summaries of direct water
          
           
          
          If g_c_NHANES = 0 Then  'csfii
               If d = 1 Then
                 If ValidDrinkingWater2 Then
                   Expos!(2309, 1) = d1_d_Tot! 'we have already shown that this is same as sp1.d1h2oo
                   Expos!(2409, 1) = d1_d_Tap!
                   Expos!(2410, 1) = d1_d_Bot!
                   Expos!(2411, 1) = d1_d_Oth!
                   Expos!(2412, 1) = d1_d_Mis!
                 End If
                 Expos!(2413, 1) = d1_i_Tap!
                 Expos!(2414, 1) = d1_i_Bot!
                 Expos!(2415, 1) = d1_i_Oth!
                 Expos!(2416, 1) = d1_i_Mis!
               Else 'd = 2
                 If ValidDrinkingWater2 Then
                   Expos!(2309, 2) = d2_d_Tot!  'we have already shown that this is same as sp1.d2h2oo
                   Expos!(2409, 2) = d2_d_Tap!
                   Expos!(2410, 2) = d2_d_Bot!
                   Expos!(2411, 2) = d2_d_Oth!
                   Expos!(2412, 2) = d2_d_Mis!
                 End If
                 Expos!(2413, 2) = d2_i_Tap!
                 Expos!(2414, 2) = d2_i_Bot!
                 Expos!(2415, 2) = d2_i_Oth!
                 Expos!(2416, 2) = d2_i_Mis!
               End If
          Else  'nhanes
          
             'note that the line item equivalents of these summary direct water amounts were skipped over
             'for mode = 4 so that there was no double counting
             
              If d = 1 Then
                 'initialize
                 Expos!(WaterDirectIndex(0), 1) = 0  'direct water all sources
                 Expos!(WaterDirectIndex(1), 1) = 0  'tap
                 Expos!(WaterDirectIndex(2), 1) = 0  'bottled

                 'If ValidDrinkingWater1 Then
                 If (g_c_NHANES = 1 And ValidDrinkingWater1 = 1) Or (g_c_NHANES = 2 And ValidDrinkingWater2 = 1) Then  '4-28-2011
                   If WaterDirectIndex(0) = 0 Then Stop 'shouldn't get here
                                      
                   If SurveyYear = 1 Then  '
                     Expos!(WaterDirectIndex(0), 1) = Water1!  '1.04
                   Else  'survey years from 2003 on
                     Expos!(WaterDirectIndex(0), 1) = WaterPlain!(1)
                   End If
                   
                   If g_c_NHANES = 2 Then
                     If WaterDirectIndex(1) = 0 Or WaterDirectIndex(2) = 0 Then Stop  'shouldn't get here
                    
                     Expos!(WaterDirectIndex(1), 1) = WaterTap!(1) 'DirWaterTap!  '4-28-2011
                     Expos!(WaterDirectIndex(2), 1) = WaterBot!(1) 'DirWaterBot!
                     
                   End If

                 End If
                 'The following will be needed if we get more info on source of indirect water
                 'If WaterIndirectIndex(1) Then Expos!(WaterIndirectIndex(1), 1) = indirect tap water day1
                 'If WaterIndirectIndex(2) Then Expos!(WaterIndirectIndex(2), 1) = indirect bot water day1
                 'If WaterIndirectIndex(3) Then Expos!(WaterIndirectIndex(3), 1) = indirect other water day1
                 'If WaterIndirectIndex(4) Then Expos!(WaterIndirectIndex(4), 1) = indirect NS water day1
              Else 'd = 2, 2003 and later
                 
                 Expos!(WaterDirectIndex(0), 2) = 0  'plain water
                 Expos!(WaterDirectIndex(1), 2) = 0
                 Expos!(WaterDirectIndex(2), 2) = 0

                 If g_c_NHANES = 2 And ValidDrinkingWater2 = 1 Then  '4-28-2011
                   Expos!(WaterDirectIndex(0), 2) = WaterPlain!(2)
                   Expos!(WaterDirectIndex(1), 2) = WaterTap!(2) 'DirWaterTap!  '4-28-2011
                   Expos!(WaterDirectIndex(2), 2) = WaterBot!(2) 'DirWaterBot!
                   
                 End If
                 'The following will be needed if we get more info on source of indirect water
                 'If WaterIndirectIndex(1) Then Expos!(WaterIndirectIndex(1), 2) = indirect tap water day2
                 'If WaterIndirectIndex(2) Then Expos!(WaterIndirectIndex(2), 2) = indirect bot water day2
                 'If WaterIndirectIndex(3) Then Expos!(WaterIndirectIndex(3), 2) = indirect other water day2
                 'If WaterIndirectIndex(4) Then Expos!(WaterIndirectIndex(4), 2) = indirect NS water day2
              End If
               
          End If  'g_c_NHANES = 0
          
        ElseIf mode = 5 Then  'line item water amounts
        
          If g_c_NHANES = 0 Then Stop  'there is no consensus on how to handle direct water as a line item for CSFII
          
          If g_c_NHANES = 1 Then Stop  'not ready for this yet, but we will probably never implement this mode for 1-day analysis
        
          If g_c_NHANES = 2 And SurveyYear = 2 Then  '1.02 all
          'line item, 2-day,  2003-04 (where water is not broken out by time of day in original records)
          'add in direct water all sources (WaterPlain!(d)) for days 1 or 2, making sure that the timing is interspersed with the food intake timing
          'note that we are not breaking out tap and bottled water for use with line item in 2003-2004
    'NB:  'thus we should not allow the user to use tap or bottled water with line item analysis
          'even though we will have this information in years 2005-2008
          
          'we are still in d loop
          
            If ValidDrinkingWater2 = 1 And WaterPlain!(d) > 0 Then
         
                For t = 1 To 6  'divide plain water intake into 6 occasions 3 hours apart from 07:30 to 22:30 and add to end of existing intake records
                  Sum(d) = Sum(d) + 1
                  Expos!(Sum(d), d) = WaterPlain!(d) / 6
                  RACff(Sum(d), d) = WaterDirectIndex(0)
                  IntakeTime(Sum(d), d) = g_WaterTimeEst(t)
                Next
                
                'now resort all line item intake records by time for day d
                
                ReDim SortIndex(Sum(d)), SortVar$(Sum(d)), TempExpos!(Sum(d)), TempRACff(Sum(d))
                For t = 1 To Sum(d)
                  SortIndex(t) = t
                  SortVar$(t) = Trim(Str(IntakeTime(t, d)))
                  If Len(SortVar$(t)) = 1 Then  'add leading zeros to make sure that the alpha sort goes well
                    SortVar$(t) = "000" & SortVar$(t)
                  ElseIf Len(SortVar$(t)) = 2 Then
                    SortVar$(t) = "00" & SortVar$(t)
                  ElseIf Len(SortVar$(t)) = 3 Then
                    SortVar$(t) = "0" & SortVar$(t)
                  End If
                  TempExpos!(t) = Expos!(t, d)
                  TempRACff(t) = RACff(t, d)
                Next
                
                Call Sort(Sum(d), SortIndex(), SortVar$())  'sort sum(d) records by time of day for day d
                
                For t = 1 To Sum(d)
                  IntakeTime(t, d) = Val(SortVar$(SortIndex(t)))
                  Expos!(t, d) = TempExpos!(SortIndex(t))
                  RACff(t, d) = TempRACff(SortIndex(t))
                Next t
              
            End If
          End If
             
        End If  'mode = 3, 4, 5
           
      End If 'If NF(d) > 0 Or (g_c_NHANES = 1 And ValidDrinkingWater1 = 1) Or (g_c_NHANES <> 1 And ValidDrinkingWater2 = 1)
       
    Next d
       
    If mode = 4 Then  '24hour
       
      For d = 1 To g_MaxNDays
        Sumx = 0
        For r = 1 To NRacFF
          If Expos!(r, d) Then Sumx = Sumx + 1
        Next
        Sum(d) = Sumx  'number of RAC/FF items consumed on day d
      Next d
         
    ElseIf mode = 5 Then
      'sum(1) and sum(2) are defined as each intake RAC/FF is recorded
      
    End If
       
    If mode = 4 Or mode = 5 Then

         Participant = 1
         Put #5, , 1   'this person is participant in survey
         Put #5, , sp1
         
         sp2.D1NRec = Sum(1)
         If g_c_NHANES <> 1 Then
           sp2.D2NRec = Sum(2)
         Else
           sp2.D2NRec = 0
         End If
         Put #5, , sp2

         'For d = 1 To g_MaxNDays
         For d = 1 To g_NDays
           If d = 1 Or (d = 2 And (g_c_NHANES = 0 Or g_c_NHANES = 2)) Then
             If mode = 4 Then  '24 hor
               For r = 1 To NRacFF
                 If Expos!(r, d) Then
                   cons.Rac = r
                   cons.amount = Expos!(r, d)
                   Put #5, , cons
                 End If
               Next r
             Else  'mode = 5
               For r = 1 To Sum(d)
                 RACFFLI.Rac = RACff(r, d)
                 RACFFLI.amount = Expos!(r, d)
                 RACFFLI.time = IntakeTime(r, d)
                 Put #5, , RACFFLI
               Next
             End If
           End If 'd = 1 Or (d = 2 And (g_c_NHANES = 0 Or g_c_NHANES = 2))
         Next d

    End If 'mode =4, 5
       
       
    
endindividual:
  Next i
  
End Sub
Private Sub compbw(infwt!(), agewt!())
'updated using epa-provided body weights by age and sex
Dim m

'at version 1.01 I removed conversion from kg to lbs
For m = 0 To 5
  infwt(1, m) = 6 ' * 2.2  'need to convert to lbs becuase weights in survey are in lbs; conversion back to kg is done later
  infwt(2, m) = 6 '* 2.2
Next
For m = 6 To 11
  infwt(1, m) = 9.4 ' * 2.2
  infwt(2, m) = 8.8 ' * 2.2
Next

Dim y

agewt(1, 1) = 11.8
agewt(1, 2) = 13.6
agewt(1, 3) = 15.7
agewt(1, 4) = 17.8
agewt(1, 5) = 19.8
agewt(1, 6) = 23#
agewt(1, 7) = 25.1
agewt(1, 8) = 28.2
agewt(1, 9) = 31.1
agewt(1, 10) = 36.4
agewt(1, 11) = 40.3
agewt(1, 12) = 44.2
agewt(1, 13) = 49.9
agewt(1, 14) = 57.1
agewt(1, 15) = 61#
agewt(1, 16) = 67.1
agewt(1, 17) = 66.7
agewt(1, 18) = 70
For y = 19 To 100
  agewt(1, y) = agewt(1, 18)
Next

agewt(2, 1) = 10.8
agewt(2, 2) = 13#
agewt(2, 3) = 14.9
agewt(2, 4) = 17#
agewt(2, 5) = 19.6
agewt(2, 6) = 22.1
agewt(2, 7) = 24.7
agewt(2, 8) = 27.9
agewt(2, 9) = 31.9
agewt(2, 10) = 36.1
agewt(2, 11) = 41.8
agewt(2, 12) = 46.4
agewt(2, 13) = 50.9
agewt(2, 14) = 54.8
agewt(2, 15) = 55.1
agewt(2, 16) = 58.1
agewt(2, 17) = 59.6
agewt(2, 18) = 60
For y = 19 To 100
  agewt(2, y) = agewt(2, 18)
Next

'For y = 1 To 100  '1.01
'  agewt(1, y) = agewt(1, y) * 2.2
'  agewt(2, y) = agewt(2, y) * 2.2
'Next

End Sub

Public Sub addblanks(z$)
  Dim i
  Dim x
  x = InStr(z$, ".")
  If x Then x = x - 2 Else x = Len(z$) - 1
  For i = 1 To x
    If Mid$(z$, i, 1) = "0" Then
      Mid$(z$, i, 1) = " "
    Else
      Exit For
    End If
  Next
  

End Sub

Public Sub CombineMeans()  'step 7, index 6

'reads in all of the individual population RAC/FF means files and puts the per capita means into a single text file

Dim a$
Dim IndexRAC
Dim RACCode$, RACCodex$()
Dim FF
Dim Amt!
Dim i, j
Dim Pop
Dim flage
Dim mask$, f$
Dim Indexx$, ffxx$, meanxx$
Dim NRacFF
Dim Index(), FFX(), CMean!()
Dim nl
Dim mn As means
Dim mnNH As meansNH
Dim PopNo$
Dim Dummy$
Dim MaxRACIndex, RACx$
Dim RACName$
'Dim code$, CGx$, cf!, Name$, nff, fff  'remd 1.11
Dim Temp
Dim lastnsi, lastff

Call GetNRACFF(NRacFF)

ReDim Index(NRacFF), FFX(NRacFF)
ReDim CMean!(g_NPops, NRacFF)

'read in the US Total Pop means file to find a list of all non-zero mean intake RAC/FF combinations
Open g_MeansFFFileRoot$ & ".1" For Input As #1
For i = 1 To g_c_NHeaderLinesMeansFLRoot
  Line Input #1, a$
Next i

i = 0
While Not EOF(1)
  Line Input #1, a$
readback1:
  
  'important note: if you change the layout of the lines of RAC/FF data you will need to change the following locations of variables (RAC, code, FF, amt)
  
  RACCode$ = Mid(a$, 1, 10)
  IndexRAC = Val(Mid(a$, 12, 4))
  FF = Val(Mid(a$, 19, 3))
  i = i + 1
  Index(i) = IndexRAC
  FFX(i) = FF
  
Wend
Close 1

'read in mean intake files for all other subpopulations
For Pop = g_c_FirstPop To g_NPops

  If Len(Dir(g_MeansFFFileRoot$ & "." & Trim(Str(Pop)))) = 0 Then
    MsgBox "Means file " & g_MeansFFFileRoot$ & "." & Trim(Str(Pop)) & " is not available, this must be computed before you can proceed with combining means.", vbInformation, "Combining Intake Means"
    Exit Sub
  End If
  
  Open g_MeansFFFileRoot$ & "." & Trim(Str(Pop)) For Input As #1
  For i = 1 To g_c_NHeaderLinesMeansFLRoot
    Line Input #1, a$
  Next i
  
  i = 1
  While Not EOF(1)
X1:
    On Error GoTo x3
    flage = 0
    Line Input #1, a$
    
    If flage Then GoTo x4
    On Error GoTo 0
    
readback2:
    'Print #1, EPARAC$(k); Tab(12); ii$; Tab(19); ffxx$; Tab(22); tracw$; Tab(34); tracu$; Tab(46); racu$; Tab(54); racw$
    'important note: if you change the layout of the lines of RAC/FF data you will need to change the following locations of variables (RAC, code, FF, amt)
        
    RACCode$ = Mid(a$, 1, 10)
    IndexRAC = Val(Mid(a$, 12, 4))
    FF = Val(Mid(a$, 19, 3))
    Amt! = Val(Mid(a$, 22, 11))
    
    If FF < 100 Or FF > 999 Then Stop
x2:
    If IndexRAC = Index(i) And FF = FFX(i) Then
      CMean!(Pop, i) = Amt!
      i = i - 50
      If i < 1 Then i = 1
      GoTo X1
    Else
      i = i + 1
      If i > NRacFF Then Stop
      GoTo x2
    End If
    
  Wend
x4:
  Close 1
  On Error GoTo 0
  
Next

'get EPA RAC codes corresponding to RAC indices for later use in this subroutine

ReDim RACCodex$(NRacFF) 'get RAC codes with index numbers

Open g_RACIndexFl$ For Input As #1
i = 1
While Not EOF(1)
  Input #1, RACCode$, IndexRAC
  Line Input #1, a$
  If IndexRAC < 1 Or IndexRAC > NRacFF Then Stop
  RACCodex$(IndexRAC) = RACCode$
Wend
Close 1

'generate plain text file of intake means by RAC and FF for all subpopulations
Open g_MeansFFFileRoot$ & ".txt" For Output As #1

Print #1, "DMFgen per capita means for" & Str(g_NPops) & " populations for " & g_SurveyName$ & " generated " & Date & " " & time$

Print #1, "EPA RAC     Index   FF  Pop:";

mask$ = " ###      "
For Pop = 1 To g_NPops
  f$ = Format(Pop, mask$)
  setdecimal mask$, f$, PopNo$
  Print #1, PopNo$; " ";
Next
Print #1,

For i = 1 To NRacFF

  If Index(i) = 0 Then Stop
  mask$ = "### "
  f$ = Format(Index(i), mask$)
  setdecimal mask$, f$, Indexx$
  
  mask$ = "  ### "
  f$ = Format(FFX(i), mask$)
  setdecimal mask$, f$, ffxx$
  
  Print #1, Chr$(34); RACCodex$(Index(i)); Chr$(34), Indexx$; ffxx$;
 
  mask$ = "###.######"
  For Pop = 1 To g_NPops
    f$ = Format(CMean!(Pop, i), mask$)
    setdecimal mask$, f$, meanxx$
    Print #1, meanxx$; " ";
    
  Next
  Print #1,
Next
Close

'Now write out random access equivalent of the means file generated above
'note that food forms are not in ascending order yet so this file cannot be used by the Chronic module
'the food forms will be sorted in numerical order in sub MakeChronicFiles

Open g_MeansFFFileRoot$ & ".txt" For Input As #1
Line Input #1, Dummy$
Line Input #1, Dummy$

If g_c_NHANES = 0 Then
  Open "ffmeanstemp.ran" For Random As #2 Len = Len(mn)
Else
  Open "ffmeanstemp.ran" For Random As #2 Len = Len(mnNH)
End If

nl = 0 'number of lines


For j = 1 To NRacFF
  If g_c_NHANES = 0 Then
    Input #1, mn.epa
    Input #1, mn.NSI, mn.FF
    lastnsi = mn.NSI
    lastff = mn.FF
    nl = nl + 1

    For i = 1 To g_NPops
      Input #1, mn.mean(i)
    Next
    Put #2, nl, mn
  Else
    Input #1, mnNH.epa
    Input #1, mnNH.NSI, mnNH.FF
    lastnsi = mnNH.NSI
    lastff = mnNH.FF
    nl = nl + 1

    For i = 1 To g_NPops
      Input #1, mnNH.mean(i)
    Next
    Put #2, nl, mnNH
  End If
Next j

Close

If nl <> NRacFF Then Stop  'this should not happen unless files were modified outside this program

If Len(Dir(g_RACIndexFl$)) = 0 Then  'was "epafoodw.cod"
  MsgBox "Can't find file " & g_RACIndexFl$ & " in current directory " & CurDir, vbInformation, "Make Random Access Recipe Files"
  Exit Sub
Else
  Open g_RACIndexFl$ For Input As #1
  MaxRACIndex = 0
  While Not EOF(1)
    Input #1, RACx$, IndexRAC
    Line Input #1, RACName$  'dont need to break out crop group here
    If IndexRAC > MaxRACIndex Then MaxRACIndex = IndexRAC
  Wend
  Close 1
End If

MsgBox "All " & Str(g_NPops) & " RAC/FF per capita means files combined into text file " & g_MeansFFFileRoot$ & ".txt.", vbInformation, "Combining RAC/FF Means Files"
frmDSFGen.chkDone(6) = 1 'step 7 checked
frmDSFGen.lblDate(6) = Date$ & "  " & time$

Exit Sub


x3:
  flage = 1
  Resume Next

End Sub


Public Sub setdecimal(mask$, f$, f2$)

  'adds leading blanks to formatted numbers to line up decimal points and add final zeros
  'note: masks must be of form "####.###" for use with real numbers without marking commas
  'or "###,###.##" for use with real numbers with marking commas
  'or "#####" for use with integers without marking commas
  'or "###,###,###" for use with integers with marking commas
    
  Dim dp, dp2, mask2$
  
  dp = InStr(mask$, ".")
  
  If dp Then 'assumes that mask has space for leading 0
    If dp = 1 Then
      mask2$ = "." + String(Len(mask$) - 1, "0")
    Else
      mask2$ = String(dp - 2, " ") + "0." + String(Len(mask$) - dp, "0")
    End If
    If f$ = "." Then f$ = ".0"
    dp2 = InStr(f$, ".") '1
    If dp >= dp2 Then
      Mid$(mask2$, dp - dp2 + 1) = f$
      f2$ = mask2$
    Else
      f2$ = f$
    End If
  Else
    If f$ = "" Then f$ = "0"
    If Len(mask$) >= Len(f$) Then
      f2$ = String(Len(mask$) - Len(f$), " ") + f$
    Else
      f2$ = mask2$
    End If
  End If
  
End Sub


Public Sub MakeChronicFiles()  'step 8, index 6

'This sub makes miscellaneous supporting files needed by the DEEM FCID program:
'the filenames are assigned in the common area at the top of this program module


Dim FFORMS As FFORMSREC
Dim mn As means
Dim mnNH As meansNH
Dim FOOD98 As FOODREC98
Dim FOODNH As FOODRECNH
Dim ind As IndexRACx
Dim x
Dim Flag
Dim nff  'number of food forms for any given food in the current survey
Dim fff  'first food form index in array for any given food in current survey
Dim i, j
Dim Name$
Dim a$
Dim cf!(), cfx! '1.11 concentration factor
Dim NRacFF
Dim RACCode$
Dim RACCodex$()
Dim code$
Dim cgx$
Dim cg$()
Dim IndexRAC
Dim namex$()
Dim MaxRACIndex
Dim RACx$, RACName$
Dim MaxNff
Dim FF(), Index()
Dim Temp
Dim Sum!()
Dim files$
Dim Pass

'find highest RAC index, MaxRACIndex:

If Len(Dir(g_RACIndexFl$)) = 0 Then  'was "epafoodw.cod"
  MsgBox "Can't find file " & g_RACIndexFl$ & " in current directory " & CurDir, vbInformation, "Make Random Access Recipe Files"
  Exit Sub
Else
  Open g_RACIndexFl$ For Input As #1
  MaxRACIndex = 0
  While Not EOF(1)
    Input #1, RACx$, IndexRAC
    Line Input #1, RACName$  'dont need to break out crop group here
    If IndexRAC > MaxRACIndex Then MaxRACIndex = IndexRAC
  Wend
  Close 1
End If

'get RAC codes with crop group, name, and default concentration factor
'this is the only place where this file is read that reads these variables into arrays

Open g_RACIndexFl$ For Input As #1 'was
ReDim RACCodex$(MaxRACIndex)
ReDim cg$(MaxRACIndex)
ReDim namex$(MaxRACIndex)
ReDim cf!(MaxRACIndex)  '1.11

While Not EOF(1)
  Input #1, RACx$, IndexRAC
  RACCodex$(IndexRAC) = RACx$
  Input #1, cg$(IndexRAC), namex$(IndexRAC), cf!(IndexRAC)
Wend
Close 1


'generate the master RAC file for DEEM in flat file format for QA (used by all DEEM modules)
'this file contains the RAC EPA code (8-digit), the index number used in DEEM, the crop group, the concentration factor (based in 1.0),
'the RAC name, the number of active foodforms in this survey, and the location of the first foodform for this RAC in the foodform file

'The code is not very elegant here but it is taken from my older program (index98w.vbp), and it works
'set up the chronic means file to includes every food and foodform in the survey
'output is "FoodsTemp3.ran" intermediate file for use later in this sub
'markkk
'
'Open "ffmeanstemp.ran" For Random As #1 Len = Len(MN)  'input from combine means
'Open g_MeansFFFile$ For Random As #2 Len = Len(MN)  'output for use below
'Open g_Foodsepa$ For Input As #3  'input

'ReDim FF(999), Index(60) '60 is estimated maximum number of ff for any one ingredient at present,

'IndexRAC = 0
'Do Until IndexRAC = MaxRACIndex
  
'  Input #3, IndexRAC, code$, CGx$, cf!, Name$, nff, fff  'fff is all we really want out of this line
'
'  If nff = 1 Then
'     Get #1, fff, MN
'     Put #2, fff, MN
'  ElseIf nff > 1 Then
'    For i = 1 To nff
'      Get #1, fff + i - 1, MN
'      FF(i) = MN.FF
'      Index(i) = i
'    Next
'
'    For j = 1 To nff - 1
'      For i = 1 To nff - 1
'        If FF(Index(i)) > FF(Index(i + 1)) Then 'swap Index(i), Index(i + 1)
'          Temp = Index(i + 1)
'          Index(i + 1) = Index(i)
'          Index(i) = Temp
'        End If
'      Next i
'    Next j

'    For i = 1 To nff
'      Get #1, fff + Index(i) - 1, MN
'      Put #2, fff + i - 1, MN
'    Next

'  End If

'Loop
'Close


'Open g_MeansFFFile$ For Random As #3 Len = Len(MN)  '

If g_c_NHANES = 0 Then
  Open "ffmeanstemp.ran" For Random As #3 Len = Len(mn)  'from combinemeans
Else
  Open "ffmeanstemp.ran" For Random As #3 Len = Len(mnNH)  'from combinemeans
End If
Open g_Foodsepa$ For Output As #2

nff = 0
fff = 0
i = 1

For IndexRAC = 1 To MaxRACIndex

  If Len(RACCodex$(IndexRAC)) > 0 Then
    'cf! = 1   '1.11 (concentraction factor) now taken from fcid-nh-foods-sort-c.txt
    Flag = 0
    
X1:
    
    If g_c_NHANES = 0 Then
      Get #3, i, mn
      Pass = 0
      If mn.NSI = IndexRAC Then Pass = 1
    Else
      Get #3, i, mnNH
      Pass = 0
      If mnNH.NSI = IndexRAC Then Pass = 1
    End If
    
    'If mn.NSI = IndexRAC Then
    If Pass = 1 Then
      If Flag = 0 Then
        fff = i
        nff = 1
        Flag = 1
      Else
        nff = nff + 1
      End If
      i = i + 1
      GoTo X1
    Else
    
      'Write #2, IndexRAC; RACCodex$(IndexRAC); cg$(IndexRAC); cf!; namex$(IndexRAC); nff; fff
      Write #2, IndexRAC; RACCodex$(IndexRAC); cg$(IndexRAC); cf!(IndexRAC); namex$(IndexRAC); nff; fff  '1.11

      nff = 0
      fff = 0
    End If
  End If
Next IndexRAC
Close

If g_c_NHANES = 0 Then
  Open "ffmeanstemp.ran" For Random As #1 Len = Len(mn)  'input from combine means
  Open g_MeansFFFile$ For Random As #2 Len = Len(mn)  'output for use below
Else
  Open "ffmeanstemp.ran" For Random As #1 Len = Len(mnNH)  'input from combine means
  Open g_MeansFFFile$ For Random As #2 Len = Len(mnNH)  'output for use below
End If

Open g_Foodsepa$ For Input As #3  'input

ReDim FF(999), Index(60) '60 is estimated maximum number of ff for any one ingredient at present,

IndexRAC = 0
Do Until IndexRAC = MaxRACIndex
  'Input #3, IndexRAC, code$, CGx$, cf!, Name$, nff, fff  'fff is all we really want out of this line
  Input #3, IndexRAC, code$, cgx$, cfx!, Name$, nff, fff  '1.11 fff is all we really want out of this line

  If nff = 1 Then
    If g_c_NHANES = 0 Then
      Get #1, fff, mn
      Put #2, fff, mn
    Else
      Get #1, fff, mnNH

      Put #2, fff, mnNH
    End If
  ElseIf nff > 1 Then
    For i = 1 To nff
      If g_c_NHANES = 0 Then
        Get #1, fff + i - 1, mn
        FF(i) = mn.FF
      Else
        Get #1, fff + i - 1, mnNH

        FF(i) = mnNH.FF
      End If
      Index(i) = i
    Next

    For j = 1 To nff - 1
      For i = 1 To nff - 1
        If FF(Index(i)) > FF(Index(i + 1)) Then 'swap Index(i), Index(i + 1)
          Temp = Index(i + 1)
          Index(i + 1) = Index(i)
          Index(i) = Temp
        End If
      Next i
    Next j
    For i = 1 To nff
      If g_c_NHANES = 0 Then
        Get #1, fff + Index(i) - 1, mn
        Put #2, fff + i - 1, mn
      Else
        Get #1, fff + Index(i) - 1, mnNH
        Put #2, fff + i - 1, mnNH
      End If
    Next
  End If
Loop
Close

'generate the master RAC file for DEEM in random access file format (used by all DEEM modules)

Open g_Foodsepa$ For Input As #1        ' input from IndexRAC.bas

  If g_c_NHANES = 0 Then
    Open g_FoodsepaRA$ For Random As #2 Len = Len(FOOD98)
  Else
    Open g_FoodsepaRA$ For Random As #2 Len = Len(FOODNH)
  End If


For IndexRAC = 1 To MaxRACIndex  'clear out space
  If g_c_NHANES = 0 Then
    Put #2, IndexRAC, FOOD98
  Else
    Put #2, IndexRAC, FOODNH
  End If
Next


IndexRAC = 0
Do Until IndexRAC = MaxRACIndex
  Input #1, IndexRAC, code$, cgx$, cfx!, Name$, nff, fff '1.11
  If g_c_NHANES = 0 Then
    FOOD98.NSI = IndexRAC
    FOOD98.fdcd = code$
    FOOD98.cat = cgx$
    FOOD98.cf = cfx!  '1.11
    FOOD98.fdnm = Name$
    FOOD98.nff = nff
    FOOD98.fff = fff
    Put #2, IndexRAC, FOOD98
  Else
    FOODNH.NSI = IndexRAC
    FOODNH.fdcd = code$
    FOODNH.cat = cgx$
    FOODNH.cf = cfx!  '1.11
    FOODNH.fdnm = Name$
    FOODNH.nff = nff
    FOODNH.fff = fff
    Put #2, IndexRAC, FOODNH

  End If
Loop
Close

'----------------------------------------------------------------

'--------------------------------------
'bring in code equivalent to index298w.vbp

Call GetNRACFF(NRacFF)
'find number of RAC/FF combinations, NRACFF. this file not used in calculations per se

Open g_Foodsepa$ For Input As #1  'source of rac names and adjustment factors from index.bas
'ReDim cfx!(NRacFF), Index(MaxRACIndex)
ReDim cf!(NRacFF), Index(MaxRACIndex)

i = 1
IndexRAC = 0
Do Until IndexRAC = MaxRACIndex
  Input #1, IndexRAC, code$, cgx$, cfx!, Name$, nff, fff  '1.11
  cf!(IndexRAC) = cfx! '1.11
  Index(IndexRAC) = i
  i = i + 1
Loop
Close 1


'make the file of food forms that is the counterpart to the master RAC file (the nff and fff for each RAC in the master file points to this file)
'mark1
'Open "foodstemp3.ran" For Random As #3 Len = Len(MN) 'file of means to be indexed from index395.bas
 
If g_c_NHANES = 0 Then
  Open g_MeansFFFile$ For Random As #3 Len = Len(mn)
Else
  Open g_MeansFFFile$ For Random As #3 Len = Len(mnNH)
End If

Open g_FFormsepa$ For Output As #2 'output index file in text format
Open g_FFormsepaRA$ For Random As #4 Len = Len(FFORMS) 'output index file in random access form for DEEM-FCID Acute

For i = 1 To NRacFF
  If g_c_NHANES = 0 Then
    Get #3, i, mn
   'Print #2, i; mn.FF; cfx!(mn.NSI)
    Print #2, i; mn.FF; cf!(mn.NSI)  '1.11
    FFORMS.ffcd = mn.FF
    FFORMS.ffcf = cf!(mn.NSI)  '1.11
  Else
    Get #3, i, mnNH
    'Print #2, i; mnNH.FF; cfx!(mnNH.NSI)
    Print #2, i; mnNH.FF; cf!(mnNH.NSI)  '1.11
    FFORMS.ffcd = mnNH.FF
    'FFORMS.ffcf = cfx!(mnNH.NSI)
    FFORMS.ffcf = cf!(mnNH.NSI)  '1.11
  End If
    
  Put #4, i, FFORMS
Next
Close 2, 3, 4

'make an RA file of the RAC indices used in the master rac file
'these RAC indices may be discontinuous, this index allows them to be condensed using a second continuous index series (legacy)
Open "foodstemp4.ran" For Random As #1 Len = Len(ind)
For i = 1 To MaxRACIndex
  ind.Index = Index(i)
  Put #1, i, ind
Next
Close 1

Open "foodstemp4.fil" For Output As #1  'this  is for information only, to show what is in the *.ran version
For i = 1 To MaxRACIndex
  If Index(i) Then Print #1, i; Index(i)
Next

Close 1

'make the index file for the master file of chronic means

If g_c_NHANES = 0 Then
  Open g_MeansFile$ For Random As #1 Len = Len(mn)   'output to deem epa, means without ff
  Open g_MeansFFFile$ For Random As #2 Len = Len(mn)  'output for use below
Else
  Open g_MeansFile$ For Random As #1 Len = Len(mnNH)   'output to deem epa, means without ff
  Open g_MeansFFFile$ For Random As #2 Len = Len(mnNH)  'output for use below
End If
 
Open g_Foodsepa$ For Input As #3  'source of rac names and adjustment factors from index.bas

IndexRAC = 0
Do Until IndexRAC = MaxRACIndex
  'Input #3, IndexRAC, code$, CGx$, cf!, Name$, nff, fff
  Input #3, IndexRAC, code$, cgx$, cfx!, Name$, nff, fff  '1.11

  If g_c_NHANES = 0 Then
    If nff = 0 Then
  
      mn.NSI = IndexRAC
      mn.epa = code$
      mn.FF = 0
    
      For i = 1 To g_NPops
        mn.mean(i) = 0
      Next
      mn.epa = "notused"
      Put #1, IndexRAC, mn
    
    ElseIf nff = 1 Then
       Get #2, fff, mn
       mn.FF = 0
       Put #1, IndexRAC, mn
       
    ElseIf nff > 1 Then
      ReDim Sum!(g_NPops)
      For i = 1 To nff
        Get #2, fff + i - 1, mn
  
        If mn.NSI <> IndexRAC Then Stop
        For j = 1 To g_NPops
          Sum!(j) = Sum!(j) + mn.mean(j)
        Next
      Next i

      mn.FF = 0
      For j = 1 To g_NPops
        mn.mean(j) = Sum!(j)
      Next
      Put #1, IndexRAC, mn
      
    End If
  Else

    If nff = 0 Then
  
      mnNH.NSI = IndexRAC
      mnNH.epa = code$
      mnNH.FF = 0
    
      For i = 1 To g_NPops
        mnNH.mean(i) = 0
      Next
      mnNH.epa = "notused"
      Put #1, IndexRAC, mnNH
    
    ElseIf nff = 1 Then
       Get #2, fff, mnNH
       mnNH.FF = 0
       Put #1, IndexRAC, mnNH
       
    ElseIf nff > 1 Then
      ReDim Sum!(g_NPops)
      For i = 1 To nff
        Get #2, fff + i - 1, mnNH
        If mnNH.NSI <> IndexRAC Then Stop
        For j = 1 To g_NPops
          Sum!(j) = Sum!(j) + mnNH.mean(j)
        Next
      Next i

      mnNH.FF = 0
      For j = 1 To g_NPops
        mnNH.mean(j) = Sum!(j)
      Next
      Put #1, IndexRAC, mnNH
      
    End If
  
  End If
Loop
Close

Call MakeSortFile

files$ = g_FoodsepaRA$ & "  " & g_FFormsepaRA$ & "  " & g_MeansFile$ & "  " & g_MeansFFFile$ & "  " & g_RACSortRA$

MsgBox "The following files have been generated for use with DEEM-FCID. Please move them into your DEEM folder: " & files$, vbInformation, "Generating DEEM Chronic Files"
frmDSFGen.chkDone(7) = 1  'step 8 checked
frmDSFGen.lblDate(7) = Date$ & "  " & time$


End Sub


Public Sub GetNRACFF(NRacFF)

  Dim i
  Dim a$

  Open g_MeansFFFileRoot$ & ".1" For Input As #1
  For i = 1 To g_c_NHeaderLinesMeansFLRoot  'read past header lines
    Line Input #1, a$
  Next i

  NRacFF = 0  'read in the number of active RAC/ff combinations
  While Not EOF(1)
    Line Input #1, a$
    NRacFF = NRacFF + 1
  Wend
  Close 1
  
End Sub

Public Sub MakeFileList()
   Dim SurveyFl$
   Dim AcuteFl$
   
   Dim NSets
   Dim i
   
   Call SetUpFiles

   Open g_FileList$ For Output As #1
   Print #1, "DSFGen: DEEM-FCID Support File Generator"
   Print #1, "Survey is " & g_SurveyName$
   
   If g_c_NHANES = 1 Then
     Print #1, "Number of days of intake in this survey = 1"
   Else
     Print #1, "Number of days of intake in this survey = 2"
   End If
   Print #1, "Number of subpopulations defined (including all US) = " & Trim(Str(g_NPops))
   Print #1, "Date of this report: " & Date$ & "| " & time$
   Print #1,
   Print #1, "All file names are specified by user as 'Public Const = ' in the header section of the main module"
   Print #1,
   
   Print #1, "Data files required to run this program"
   Print #1, g_NFCSIndexFl$ & " = A list of all NFCS code/Mod code combinations used in the current survey with index numbers"
   Print #1,
   Print #1, g_RACIndexFl$ & " = A list of all FCID RACs with crop crop and index number, in ascending RAC code order"
   Print #1,
   Print #1, g_RecipesFl$ & " = A flat file of all FCID recipes, by NFCS code/mod code, with FCID-RAC ingredients and ratio to total"
   Print #1,
   Print #1, g_SubstituteRecipes$ & " = A list of NFCS codes/mod codes which have no recipe, but instead use a surrogate recipe in the recipe database, with cross reference"
   Print #1,
   If g_c_NHANES = 0 Then
     Print #1, g_WaterFl$ & " = The SAIC water data for each individual consistent with this survey (in required format)"
     Print #1,
   End If

   Print #1, "Intake survey data files:"

   Dim FirstFile, LastFile, YearSet$
   If g_c_NHANES = 0 Then
     FirstFile = g_c_FirstSurveyYear_0
     LastFile = g_c_LastSurveyYear_0
   ElseIf g_c_NHANES = 1 Then
     FirstFile = g_c_FirstSurveyYear_NH1
     LastFile = g_c_LastSurveyYear_NH2
   ElseIf g_c_NHANES = 2 Then
     FirstFile = g_c_FirstSurveyYear_NH2
     LastFile = g_c_LastSurveyYear_NH2
   End If

   For i = FirstFile To LastFile
     If i = 1 Then
       SurveyFl$ = g_SurveyFl1$
       NSets = g_NSets1
       If g_c_NHANES = 0 Then
         YearSet$ = "1994"
       ElseIf g_c_NHANES = 1 Then
         YearSet$ = "1999-2002"
       End If
       
     ElseIf i = 2 Then
       SurveyFl$ = g_SurveyFl2$
       NSets = g_NSets2
       If g_c_NHANES = 0 Then
         YearSet$ = "1995"
       ElseIf g_c_NHANES Then
         YearSet$ = "2003-2004"
       End If
       
     ElseIf i = 3 Then
       SurveyFl$ = g_SurveyFl3$
       NSets = g_NSets3
       If g_c_NHANES = 0 Then
         YearSet$ = "1996"
       ElseIf g_c_NHANES Then
         YearSet$ = "2005-2006"
       End If
       
     ElseIf i = 4 Then
       SurveyFl$ = g_SurveyFl4$
       NSets = g_NSets4
       If g_c_NHANES = 0 Then
         YearSet$ = "1998"
       ElseIf g_c_NHANES Then
         YearSet$ = "2007-2008"
       End If
       
     'ElseIf i = 5 Then 'unrem this if using 2009-2010
     '  SurveyFl$ = g_SurveyFl5$
     '  NSets = g_NSets5
     '  YearSet$ = "2009-2010
     
     Else
       Stop
       'you will need to add more like this
     End If
     Print #1, "The root name of the formatted survey data file(s) for year set " & YearSet$ & " = " & SurveyFl$ & "."
     Print #1, "Number of data files for this year set = " & Trim(Str(NSets))
     Print #1,
   Next
   
   Print #1,
   Print #1, "Output Files:"
   
   For i = FirstFile To LastFile
     If i = 1 Then
       AcuteFl$ = g_Acute24Fl1$
       If g_c_NHANES = 0 Then
         YearSet$ = "1994"
       ElseIf g_c_NHANES = 1 Then
         YearSet$ = "1999-2002"
       End If
     ElseIf i = 2 Then
       AcuteFl$ = g_Acute24Fl2$
       If g_c_NHANES = 0 Then
         YearSet$ = "1995"
       ElseIf g_c_NHANES Then
         YearSet$ = "2003-2004"
       End If
     ElseIf i = 3 Then
       AcuteFl$ = g_Acute24Fl3$
       If g_c_NHANES = 0 Then
         YearSet$ = "1996"
       ElseIf g_c_NHANES Then
         YearSet$ = "2005-2006"
       End If
     ElseIf i = 4 Then
       AcuteFl$ = g_Acute24Fl4$
       If g_c_NHANES = 0 Then
         YearSet$ = "1998"
       ElseIf g_c_NHANES Then
         YearSet$ = "2007-2008"
       End If
     'ElseIf i = 5 Then
     '  AcuteFl$ = g_Acute24Fl5$
     '  YearSet$ = "2009-2010"
     
     Else
       Stop
       'you will need to add more like this
     End If
     Print #1, "The filename of the 24-hr intake data for each individual for year-set " & YearSet$ & " = "; AcuteFl$
     
     
   Next i
   Print #1,
   
   For i = FirstFile To LastFile
   
     If i = 1 Then
       AcuteFl$ = g_AcuteLIFl1$
     ElseIf i = 2 Then
       AcuteFl$ = g_AcuteLIFl2$
     ElseIf i = 3 Then
       AcuteFl$ = g_AcuteLIFl3$
     ElseIf i = 4 Then
       AcuteFl$ = g_AcuteLIFl4$
     'ElseIf i = 5 Then
     '  AcuteFl$ = g_AcuteLIFl5$
    
     Else
       Stop
       'you will need to add more like this
     End If
     Print #1, "The filename of the line-item (LI) intake data for each individual for year-set " & YearSet$ & " = "; AcuteFl$
     
   Next i
   Print #1,
   Print #1, g_NFCSCodesUsed$ & " = A list of all NFCS codes encountered in this survey"
   Print #1, "CodesNotIndexed.txt" & " = A list of NFCS codes encountered in this survey that are not indexed in file " & g_NFCSIndexFl$
   Print #1, g_RecipeSetIndexRA$ & " = The index file for Random Access recipes generated by this program "
   Print #1, g_RecipeSetIngredRA$ & " = The ingredient file for Random Access recipes generated by this program"
   If g_c_NHANES = 0 Then
     Print #1, g_MeansFFFileRoot$ & ".1, .2,..., .33 = The RAC/FF intake means for each subpopulation "
   Else
     Print #1, g_MeansFFFileRoot$ & ".1, .2,..., .24 = The RAC/FF intake means for each subpopulation "
   End If
   Print #1, g_MeansFFFileRoot$ & ".txt = The RAC/FF intake means for all subpopulations for visual inspection and QA"
   Print #1, g_MeansFile$ & " =  the Random Access file with chronic means by RAC the for DEEM Chronic module"
   Print #1, g_MeansFFFile$ & " = the Random Access file with chronic means by RAC and FF for the for DEEM Chronic module"
   Print #1, g_FoodsepaRA$ & " = the database of valid RACs w/o foodforms for DEEM FCID main module in Random Access format"
   Print #1, g_Foodsepa$ & " = the same info as " & g_FoodsepaRA$ & " but in text file format for QA"
   Print #1, g_FFormsepaRA$ & " = the database of valid RACs with Foodforms for for DEEM FCID main module in Random Access format"
   Print #1, g_FFormsepa$ & " = the text version of " & g_FFormsepaRA$ & " for inspection and QA only"
   Print #1, g_RACSortRA$ & " = The RAC sort-order file (both RAC-Code sort and RAC-name sort) for the residue file editor"
   If g_c_NHANES = 0 Then
     Print #1, g_c_PIDFileRA$ & " = The PID file needed for use with Calendex and DMFgen programs"
   End If
   Close 1


End Sub

Public Sub FileDates()

   Dim i, j
   Dim SurveyFl$, Datex$
   Dim AcuteFl$()
   Dim msg$
   msg$ = "Not yet generated"
   
   Open g_FileDates$ For Output As #1
   
   Print #1, "DSFGen: DEEM-FCID Support File Generator: File Dates"
   Print #1, "Survey is " & g_SurveyName$
   If g_c_NHANES = 1 Then
     Print #1, "Number of days of intake in this survey = 1"
   Else
     Print #1, "Number of days of intake in this survey = 2"
   End If
   Print #1, "Number of subpopulations defined (including all US) = " & Trim(Str(g_NPops))
   Print #1, "Number of discrete survey sets = " & Trim(g_NSurveyParts)
   Print #1, "Date and time of this report = " & Date$ & "| " & time$
   Print #1, "Current working folder = " & CurDir$
    
   Print #1,
   Print #1, "Date of intake survey files (no file generated in steps 2-11 of this program can be older than the newest of these files):"
   
   'yyy
   Dim FirstFile, LastFile, YearSet$
   If g_c_NHANES = 0 Then
     FirstFile = g_c_FirstSurveyYear_0
     LastFile = g_c_LastSurveyYear_0
   ElseIf g_c_NHANES = 1 Then
     FirstFile = g_c_FirstSurveyYear_NH1
     LastFile = g_c_LastSurveyYear_NH2
   ElseIf g_c_NHANES = 2 Then
     FirstFile = g_c_FirstSurveyYear_NH2
     LastFile = g_c_LastSurveyYear_NH2
   End If

   For i = FirstFile To LastFile
     If i = 1 Then
       For j = 1 To g_NSets1
         SurveyFl$ = g_SurveyFl1$ & "." & Trim(Str(j))
         If Len(Dir(g_SurveyFl1$ & "." & Trim(Str(j)))) Then
           Datex$ = FileDateTime(SurveyFl$)
           Print #1, SurveyFl$ & ": " & Datex$
         Else
           Print #1, SurveyFl$ & ": " & msg$
         End If
       Next j
     ElseIf i = 2 Then
       For j = 1 To g_NSets2
         SurveyFl$ = g_SurveyFl2$ & "." & Trim(Str(j))
         If Len(Dir(SurveyFl$)) Then
           Datex$ = FileDateTime(SurveyFl$)
           Print #1, SurveyFl$ & ": " & Datex$
         Else
           Print #1, SurveyFl$ & ": " & msg$
         End If
       Next
     ElseIf i = 3 Then
       For j = 1 To g_NSets3
         SurveyFl$ = g_SurveyFl3$ & "." & Trim(Str(j))
         If Len(Dir(SurveyFl$)) Then
           Datex$ = FileDateTime(SurveyFl$)
           Print #1, SurveyFl$ & ": " & Datex$
         Else
           Print #1, SurveyFl$ & ": " & msg$
         End If
       Next
     ElseIf i = 4 Then
       For j = 1 To g_NSets4
         SurveyFl$ = g_SurveyFl4$ & "." & Trim(Str(j))
         If Len(Dir(SurveyFl$)) Then
           Datex$ = FileDateTime(SurveyFl$)
           Print #1, SurveyFl$ & ": " & Datex$
         Else
           Print #1, SurveyFl$ & ": " & msg$
         End If
       Next
     ElseIf i = 5 Then
       Stop 'you will need to update this section if you add more years of survey data
       'SurveyFl$ = g_SurveyFl5$
       'If Len(Dir(SurveyFl$)) Then
       '  Datex$ = FileDateTime(SurveyFl$)
       '  Print #1, SurveyFl$ & ": " & Datex$
       'Else
       '  Print #1, SurveyFl$ & ": " & msg$
       'End If
     
     Else
       Stop
       'you will need to add more like this
     End If
     
   Next
   
   
   Print #1,
   Print #1, "Other input files must have date/time stamps prior to any file generated by steps 2-11 in this program:"
   If Len(Dir(g_NFCSIndexFl$)) Then
     Print #1, g_NFCSIndexFl$ & ": " & FileDateTime(g_NFCSIndexFl$)
   Else
     Print #1, g_NFCSIndexFl$ & ": " & msg$
   End If
   
   If g_c_NHANES = 0 Then
     If Len(Dir(g_WaterFl$)) Then
       Print #1, g_WaterFl$ & ": " & FileDateTime(g_WaterFl$)
     Else
       Print #1, g_WaterFl$ & ": " & msg$
     End If
   End If
   
   If Len(Dir(g_RACIndexFl$)) Then
     Print #1, g_RACIndexFl$ & ": " & FileDateTime(g_RACIndexFl$)
   Else
     Print #1, g_RACIndexFl$ & ": " & msg$
   End If
   
   If Len(Dir(g_RecipesFl$)) Then
     Print #1, g_RecipesFl$ & ": " & FileDateTime(g_RecipesFl$)
   Else
     Print #1, g_RecipesFl$ & ": " & msg$
   End If
      
   If Len(Dir(g_SubstituteRecipes$)) Then
     Print #1, g_SubstituteRecipes$ & ": " & FileDateTime(g_SubstituteRecipes$)
   Else
     Print #1, g_SubstituteRecipes$ & ": " & msg$
   End If
   Print #1,
   
   
   Print #1, "The following files are generated as the user progresses through the steps 2-11"
   Print #1, "on the main form. The files generated at each step must have a date/time stamp later than any previous step."
   
   Print #1,
   Print #1, "Step 1 (Check Survey data format)"
   Print #1, "  No essential files generated in this step"
   Print #1,
   Print #1, "Step 2 (Check NFCS/Mod indexing and usage)"
   
   If Len(Dir(g_NFCSCodesUsed$)) Then
     Print #1, "  " & g_NFCSCodesUsed$ & ": " & FileDateTime(g_NFCSCodesUsed$)
   Else
     Print #1, "  " & g_NFCSCodesUsed$ & ": " & msg$
   End If
   Print #1,
   
   Print #1, "Step 3 (Check recipe format and completeness)"
   Print #1, "  " & g_RACSortRA$ & ": " & FileDateTime(g_RACSortRA$)
   Print #1, "  RACAlphaTest.txt for QA: " & FileDateTime("RACAlphaTest.txt")
   Print #1,
   
   Print #1, "Step 4 (Generate Random Access Recipe Files)"
   If Len(Dir(g_RecipesFlQA$)) Then
     Print #1, "  " & g_RecipesFlQA$ & " for QA: " & FileDateTime(g_RecipesFlQA$)
   Else
     Print #1, "  " & g_RecipesFlQA$ & ": " & msg$
   End If
   
   If Len(Dir(g_RecipeSetIndexRA$)) Then
     Print #1, "  " & g_RecipeSetIndexRA$ & ": " & FileDateTime(g_RecipeSetIndexRA$)
   Else
     Print #1, "  " & g_RecipeSetIndexRA$ & ": " & msg$
   End If
   
   If Len(Dir(g_RecipeSetIngredRA$)) Then
     Print #1, "  " & g_RecipeSetIngredRA$ & ": " & FileDateTime(g_RecipeSetIngredRA$)
   Else
     Print #1, "  " & g_RecipeSetIngredRA$ & ": " & msg$
   End If
   
   Print #1,
      
   Print #1, "Steps 5 & 6 (Generate Means for Chronic Module)"
      
   Print #1, "Subpopulation Means files:"
   For i = 1 To g_NPops
     If Len(Dir(g_MeansFFFileRoot$ & "." & Trim(Str$(i)))) Then
       Print #1, "  "; i, g_MeansFFFileRoot$ & "." & Trim(Str$(i)) & ": " & FileDateTime(g_MeansFFFileRoot$ & "." & Trim(Str$(i)))
     Else
       Print #1, "  "; i, g_MeansFFFileRoot$ & "." & Trim(Str$(i)) & ": " & msg$
     End If
   Next i
   Print #1,
   
   If g_c_NHANES = 0 Then
     If Len(Dir(g_c_PIDFileRA$)) Then
       Print #1, " "; g_c_PIDFileRA$ & ": " & FileDateTime(g_c_PIDFileRA$)
     Else
       Print #1, " "; g_c_PIDFileRA$ & ": " & msg$
     End If
     Print #1,
   End If
   
   Print #1, "Step 7 (Combine Means into one file)"
   If Len(Dir(g_MeansFFFileRoot$ & ".txt")) Then
     Print #1, "  " & g_MeansFFFileRoot$ & ".txt: " & FileDateTime(g_MeansFFFileRoot$ & ".txt")
   Else
     Print #1, "  " & g_MeansFFFileRoot$ & ".txt: " & msg$
   End If
      
   If Len(Dir(g_MeansFFFile$)) Then
     Print #1, "  " & g_MeansFFFile$ & ": " & FileDateTime(g_MeansFFFile$)
   Else
     Print #1, "  " & g_MeansFFFile$ & ": " & msg$
   End If
   Print #1,
      
   Print #1, "Step 8 (Make Chronic Support Files)"
   If Len(Dir(g_FoodsepaRA$)) Then
     Print #1, "  " & g_FoodsepaRA$ & ":  " & FileDateTime(g_FoodsepaRA$)
   Else
     Print #1, "  " & g_FoodsepaRA$ & ":  " & msg$
   End If
   
   If Len(Dir(g_FFormsepaRA$)) Then
     Print #1, "  " & g_FFormsepaRA$ & ":  " & FileDateTime(g_FFormsepaRA$)
   Else
     Print #1, "  " & g_FFormsepaRA$ & ": not in current folder  "
   End If
   
   If Len(Dir(g_MeansFile$)) Then
     Print #1, "  " & g_MeansFile$ & ":  " & FileDateTime(g_MeansFile$)
   Else
     Print #1, "  " & g_MeansFile$ & ":  " & msg$
   End If
   
   If Len(Dir(g_MeansFFFile$)) Then
     Print #1, "  " & g_MeansFFFile$ & ":  " & FileDateTime(g_MeansFFFile$)
   Else
     Print #1, "  " & g_MeansFFFile$ & ": " & msg$
   End If
   Print #1,
   
   Print #1, "Step 9 (Make 24-HR Acute Files)"
   
   ReDim AcuteFl$(6)  '6 is temp dim, should be big enough for next 4 years
   AcuteFl$(1) = g_Acute24Fl1$
   AcuteFl$(2) = g_Acute24Fl2$
   AcuteFl$(3) = g_Acute24Fl3$
   AcuteFl$(4) = g_Acute24Fl4$  '1.10
   
   
   For i = FirstFile To LastFile
     If Len(AcuteFl$(i)) > 6 Then
       If Len(Dir(AcuteFl$(i))) Then
         Print #1, AcuteFl$(i) & ": " & FileDateTime(AcuteFl$(i))
       Else
         Print #1, AcuteFl$(i) & ": " & msg$
       End If
     End If
   Next i
   Print #1,
   
   Print #1, "Step 10 (Make Line-item Acute Files)"
   ReDim AcuteFl$(6)
   AcuteFl$(1) = g_AcuteLIFl1$
   AcuteFl$(2) = g_AcuteLIFl2$
   AcuteFl$(3) = g_AcuteLIFl3$
   AcuteFl$(4) = g_AcuteLIFl4$  '1.10
      
   
   For i = FirstFile To LastFile
     If Len(AcuteFl$(i)) > 6 Then
       If Len(Dir(AcuteFl$(i))) Then
         Print #1, AcuteFl$(i) & ": " & FileDateTime(AcuteFl$(i))
       Else
         Print #1, AcuteFl$(i) & ": " & msg$
       End If
     End If
   Next i
   
   Print #1,
   
   Print #1, "Step 11 (Make Final Support File List)"
   If Len(Dir(g_SupportFileNames$)) Then
     Print #1, g_SupportFileNames$ & ": " & FileDateTime(g_SupportFileNames$)
   Else
     Print #1, g_SupportFileNames$ & ": " & msg$
   End If
      
   Close 1
   
   

End Sub


Public Sub ReadSubRecipes(bu)
  Dim Header$
  Dim j
  Dim NFCSx&
  
    bu = 0
  
    Open g_SubstituteRecipes$ For Input As #12
    'read past header (must correspond to number of lines in this file, user must make sure of this
    Line Input #12, Header$
    Line Input #12, Header$
    Line Input #12, Header$
    
    j = 0
    g_NSubRecs = 0
    While Not EOF(12)
      Input #12, NFCSx&
      If NFCSx& < 11100000 Or NFCSx& > 95000000 Then  'testing to make sure that the actual substitution line are initialized properly
        MsgBox "In file " & g_SubstituteRecipes$ & " the NFCS codes are not in proper format. Can't continue.", vbInformation, "Generate Means for Chronic"
        bu = 1
        Exit Sub
      Else
        j = j + 1
        Line Input #12, Header$  'dummy read rest of line while we count lines
      End If
    Wend
    g_NSubRecs = j
    Close 12
    
    Open g_SubstituteRecipes$ For Input As #12
    'read past header
    Line Input #12, Header$
    Line Input #12, Header$
    Line Input #12, Header$
    ReDim g_SubRec&(2, g_NSubRecs), g_SubMod&(2, g_NSubRecs), g_SubInd(2, g_NSubRecs)
    For j = 1 To g_NSubRecs
      Input #12, g_SubRec&(1, j), g_SubMod&(1, j), g_SubInd(1, j), g_SubRec&(2, j), g_SubMod&(2, j), g_SubInd(2, j)
    Next
    Close 12

End Sub
Public Sub Sort(n, Index(), amount$())
'in this program, amount is the RAC name
Dim Ptr&()
ReDim Ptr&(n)
Dim n1&, n2&, n3&, n4&, n5&, x&
      
      n3& = 1
      Ptr&(n3&) = n + 1
      n4& = 1
Sort1:
      n2& = Ptr&(n3&)
      n1& = n4& - 1
      If n2& - n4& < 3 Then GoTo Sort6
      n5& = Int((n1& + n2&) / 2)
Sort2:
      n1 = n1 + 1
      If n1 = n2 Then GoTo Sort4
      If amount$(Index(n1)) <= amount$(Index(n5)) Then GoTo Sort2
      
Sort3:
      n2 = n2 - 1
      If n1 = n2 Then GoTo Sort4
      If amount$(Index(n2)) >= amount$(Index(n5)) Then GoTo Sort3
      x = Index(n1): Index(n1) = Index(n2): Index(n2) = x
      GoTo Sort2
Sort4:
      If n1 > n5 Then n1 = n1 - 1
      If n2 = n5 Then GoTo Sort5
      x = Index(n1): Index(n1) = Index(n5): Index(n5) = x
Sort5:
      n3 = n3 + 1
      Ptr&(n3) = n1
      'mark
      GoTo Sort1
Sort6:
      If n2 - n4 < 2 Then GoTo Sort7
      If amount$(Index(n4)) <= amount$(Index(n4 + 1)) Then GoTo Sort7
      x = Index(n4): Index(n4) = Index(n4 + 1): Index(n4 + 1) = x
Sort7:
      n4 = Ptr&(n3) + 1
      n3 = n3 - 1
      If n3 > 0 Then GoTo Sort1
      Erase Ptr&
     
      

End Sub


Sub MakeSortFile()
  'this is called from Step 3. Check Recipes Format and Completeness
  'make RAC sort file for DEEM residue file editor, both text file for inspection and RA file for import
  'this RAC sort file now includes both the initial sort array (ascending RAC code) and alpha sort code (alpha order by name)
  'this one RA sort file is intended to replace the two separate sort files in DEEM-FCID (before the updating of DEEM-FCID to read this single file)


  Dim i
  Dim EPARACx$, EPARAC$()
  Dim RACIndex(), RACNamex$(), SortIndex(), TempIndex()
  Dim SortOrder()
  Dim EPAIndex()
  Dim FDEPA As FoodEPA
  Dim CountRacs
  Dim RACx$, Index, RACName$
  Dim MaxRACIndex
  Dim LastRAC$
  Dim RacIndexx$
  Dim CropGroup$
  Dim cfx!  '1.11
  Dim nff, fff
  
  If Len(Dir(g_Foodsepa$)) = 0 Then
    MsgBox "Can't find file " & g_Foodsepa$ & " in current directory " & CurDir, vbInformation, "Make Random Access Recipe Files"
    Exit Sub
  End If
  
  Open g_Foodsepa$ For Input As #1
  MaxRACIndex = 0
  CountRacs = 0
  While Not EOF(1)
    Input #1, Index, EPARACx$
    Input #1, CropGroup$, cfx! '1.11
    Input #1, RACName$
    Input #1, nff, fff
    If Index > MaxRACIndex Then MaxRACIndex = Index
    CountRacs = CountRacs + 1
  Wend
  Close 1
  
  'now read eparac$() into array and racname$() into array and sort each separately , then write both arrays into a single RA file

  ReDim RACIndex(CountRacs), RACNamex$(CountRacs) ', SortIndex(CountRacs)
  ReDim EPAIndex(CountRacs)
  ReDim EPARAC$(CountRacs)
 
  Open g_Foodsepa$ For Input As #1
    For i = 1 To CountRacs
      Input #1, Index, EPARACx$
      RACIndex(i) = Index
      EPARAC$(i) = EPARACx$
      Input #1, CropGroup$, cfx! '1.11
      Input #1, RACName$
      RACNamex$(i) = RACName$
      Input #1, nff, fff
    Next i
    Close 1
    
    ReDim SortIndex(CountRacs)
    For i = 1 To CountRacs
      SortIndex(i) = i
    Next
 
    Call Sort(CountRacs, SortIndex(), RACNamex$())  'alpha sort by name
    
    ReDim SortOrder(CountRacs, 2)
    
    For i = 1 To CountRacs
      SortOrder(i, 1) = SortIndex(i)
    Next i
    
    'now get ready to sort by EPA RAC code
    ReDim SortIndex(CountRacs)
    For i = 1 To CountRacs
      SortIndex(i) = i
    Next
    
    Call Sort(CountRacs, SortIndex(), EPARAC$())  'alpha sort by EPA RAC code
    
    For i = 1 To CountRacs
      SortOrder(i, 2) = SortIndex(i)
    Next i
    
  
  Call Sort(CountRacs, SortIndex(), RACNamex$())  'respecify sortindex() so that it is now in alpha order
  
  Open "RACAlphaTest.txt" For Output As #2  'flat file for QA inspection only
  
   
  
  
  Print #2, "This file is for QA inspection only. This shows the alpha order of RAC names that will be displayed "
  Print #2, "in the DEEM-FCID residue file editor. If you want to change this order, you will need to modify "
  Print #2, "file " & g_RACIndexFl$ & ", which provides the spelling basis for the RAC names shown here."
  Print #2,
  
  
  
  Print #2, "Row           EPA RAC       RAC Index       Name"

  For i = 1 To CountRacs
     
      Print #2, i, EPARAC$(SortOrder(i, 1)), RACIndex(SortOrder(i, 1)), RACNamex$(SortOrder(i, 1))
 
  Next i
  
  Print #2,
  Print #2,
  
  'Note: we assume that EPA RAC CODE order is correct because the codes are fixed
  Print #2, "EPA RAC code order (for QA, but you should not change these EPA-designated codes)"
  
  Print #2, "Row           EPA RAC       RAC Index       Name"

  For i = 1 To CountRacs
     
      Print #2, i, EPARAC$(SortOrder(i, 2)), RACIndex(SortOrder(i, 2)), RACNamex$(SortOrder(i, 2))
     
  Next i
  Close 2
  
  If Len(Dir(g_RACSortRA$)) Then Kill g_RACSortRA$
  Open g_RACSortRA$ For Random As #3 Len = Len(FDEPA)
  
  FDEPA.Alpha = 0
  FDEPA.EPARAC = 0
  
    
  For i = 1 To CountRacs  'there were 553 racs in DEEM-FCID with CSFII 94-98, with highest RAC index = 556
    Put #3, i, FDEPA  'clear out this file in case there is any junk in this section of memory allocated to the RA file
  Next i
  
  For i = 1 To CountRacs  'this is the way that DEEM-FCID wants the sort order to be recorded, by rac index rather than by counter (i)
      FDEPA.Alpha = RACIndex(SortOrder(i, 1))
      FDEPA.EPARAC = RACIndex(SortOrder(i, 2))
      Put #3, i, FDEPA
  Next i
  Close 3
  
 
  
  
End Sub


Public Sub SetUpFiles()

ReDim g_aNDays(4) 'at present 4 is the max number of intake data sets

If g_c_NHANES = 0 Then  'CSFII ANALYSIS
  g_CGFFNames$ = g_c_CatName_0$
  g_NFCSIndexFl$ = g_c_NFCSIndexFl_0$
  g_RACIndexFl$ = g_c_RACIndexFl_0$
  g_RACSortRA$ = g_c_RACSortRA_0$
  g_RecipesFl$ = g_c_RecipesFl_0$
  g_RecipesFlQA$ = g_c_RecipesFlQA_0$
  
  g_RecipeLineSpace = 1  'there is a space between each recipe in recipe file
  g_NFCSCodesUsed$ = g_c_NFCSCodesUsed_0$
  g_RecipeSetIndexRA$ = g_c_RecipeSetIndexRA_0$
  g_RecipeSetIngredRA$ = g_c_RecipeSetIngredRA_0$
  g_SubstituteRecipes$ = g_c_SubstituteRecipes_0$
  
  g_SurveyName$ = g_c_SurveyName_0$
  g_NPops = g_c_NPops_0
  g_LastPop = g_c_LastPop_0
  g_WaterFl$ = g_c_WaterFl_0$
  g_NSurveyParts = g_c_NSurveyYears_0
  
  
  g_SurveyFl1$ = g_c_SurveyFl1_0$
  g_SurveyFl2$ = g_c_SurveyFl2_0$
  g_SurveyFl3$ = g_c_SurveyFl3_0$
  g_SurveyFl4$ = g_c_SurveyFl4_0$
  
  g_NSets1 = g_c_NSets1_0
  g_NSets2 = g_c_NSets2_0
  g_NSets3 = g_c_NSets3_0
  g_NSets4 = g_c_NSets4_0
  
  g_Acute24Fl1$ = g_c_Acute24Fl1_0$
  g_Acute24Fl2$ = g_c_Acute24Fl2_0$
  g_Acute24Fl3$ = g_c_Acute24Fl3_0$
  g_Acute24Fl4$ = g_c_Acute24Fl4_0$
  
  g_AcuteLIFl1$ = g_c_AcuteLIFl1_0$
  g_AcuteLIFl2$ = g_c_AcuteLIFl2_0$
  g_AcuteLIFl3$ = g_c_AcuteLIFl3_0$
  g_AcuteLIFl4$ = g_c_AcuteLIFl4_0$
  
  g_aNDays(1) = g_c_NDays1_0
  g_aNDays(2) = g_c_NDays2_0
  g_aNDays(3) = g_c_NDays3_0
  g_aNDays(4) = g_c_NDays4_0
      
  g_MeansFFFileRoot$ = g_c_MeansFFFileRoot_0$
  g_MeansFFFile$ = g_c_MeansFFFile_0$
  g_MeansFile$ = g_c_MeansFile_0$
  
  g_FoodsepaRA$ = g_c_FoodsepaRA_0$
  g_Foodsepa$ = g_c_Foodsepa_0$
  g_FFormsepaRA$ = g_c_FFormsepaRA_0$
  g_FFormsepa$ = g_c_FFormsepa_0$
  
  g_FileList$ = g_c_FileList_0$
  g_FileDates$ = g_c_FileDates_0$
  g_MakeCode$ = g_c_MakeCode_0$
  g_SupportFileNames$ = g_c_SupportFileNames_0$

ElseIf g_c_NHANES = 1 Then  '1-day analysis

  
  g_CGFFNames$ = g_c_CatName_NH$
  g_NFCSIndexFl$ = g_c_NFCSIndexFl_NH$
  g_RACIndexFl$ = g_c_RACIndexFl_NH
  g_RACSortRA$ = g_c_RACSortRA_NH$
  g_RecipesFl$ = g_c_RecipesFl_NH$
  g_RecipesFlQA$ = g_c_RecipesFlQA_NH$
  g_RecipeLineSpace = 0  'there is no space between recipes in recipe file
  g_NFCSCodesUsed$ = g_c_NFCSCodesUsed_NH1$  '1.10
  g_RecipeSetIndexRA$ = g_c_RecipeSetIndexRA_NH$
  g_RecipeSetIngredRA$ = g_c_RecipeSetIngredRA_NH$
  g_SubstituteRecipes$ = g_c_SubstituteRecipes_NH$

  g_SurveyName$ = g_c_SurveyName_NH1$
  g_NPops = g_c_NPops_NH
  g_LastPop = g_c_LastPop_NH
  'g_WaterFl$ = g_c_WaterFl_NH1$
  g_NSurveyParts = g_c_NSurveyYears_NH1
  
  g_SurveyFl1$ = g_c_SurveyFl1_NH$
  g_SurveyFl2$ = g_c_SurveyFl2_NH$
  g_SurveyFl3$ = g_c_SurveyFl3_NH$
    
  g_NSets1 = g_c_NSets1_NH
  g_NSets2 = g_c_NSets2_NH
  g_NSets3 = g_c_NSets3_NH
    
  g_Acute24Fl1$ = g_c_Acute24Fl1_NH1$
  g_Acute24Fl2$ = g_c_Acute24Fl2_NH1$
  g_Acute24Fl3$ = g_c_Acute24Fl3_NH1$
   
  g_AcuteLIFl1$ = g_c_AcuteLIFl1_NH1$
  g_AcuteLIFl2$ = g_c_AcuteLIFl2_NH1$
  g_AcuteLIFl3$ = g_c_AcuteLIFl3_NH1$
    
  g_aNDays(1) = g_c_NDays1_NH
  g_aNDays(2) = g_c_NDays2_NH
  g_aNDays(3) = g_c_NDays3_NH
  
    
  g_MeansFFFileRoot$ = g_c_MeansFFFileRoot_NH1$
  g_MeansFFFile$ = g_c_MeansFFFile_NH1$
  g_MeansFile$ = g_c_MeansFile_NH1$
    
  g_FoodsepaRA$ = g_c_FoodsepaRA_NH1$  '1.03
  g_Foodsepa$ = g_c_Foodsepa_NH1$   '1.03
  g_FFormsepaRA$ = g_c_FFormsepaRA_NH1$
  g_FFormsepa$ = g_c_FFormsepa_NH1$
  
  g_FileList$ = g_c_FileList_NH1$
  
  g_FileDates$ = g_c_FileDates_NH1$
  g_MakeCode$ = g_c_MakeCode_NH1$
  g_SupportFileNames$ = g_c_SupportFileNames_NH1$

ElseIf g_c_NHANES = 2 Then   '2-day analysis
  g_CGFFNames$ = g_c_CatName_NH$
  g_NFCSIndexFl$ = g_c_NFCSIndexFl_NH$
  g_RACIndexFl$ = g_c_RACIndexFl_NH$

  g_RACSortRA$ = g_c_RACSortRA_NH$
  g_RecipesFl$ = g_c_RecipesFl_NH$
  g_RecipesFlQA$ = g_c_RecipesFlQA_NH$
  g_RecipeLineSpace = 0  'there is no space between recipes in recipe file
  g_NFCSCodesUsed$ = g_c_NFCSCodesUsed_NH2$  '1.10
  g_RecipeSetIndexRA$ = g_c_RecipeSetIndexRA_NH$
  g_RecipeSetIngredRA$ = g_c_RecipeSetIngredRA_NH$
  g_SubstituteRecipes$ = g_c_SubstituteRecipes_NH$

  g_SurveyName$ = g_c_SurveyName_NH2$
  g_NPops = g_c_NPops_NH
  g_LastPop = g_c_LastPop_NH
  'g_WaterFl$ = g_c_WaterFl_NH2$
  g_NSurveyParts = g_c_NSurveyYears_NH2
    
  g_SurveyFl2$ = g_c_SurveyFl2_NH$
  g_SurveyFl3$ = g_c_SurveyFl3_NH$
  g_SurveyFl4$ = g_c_SurveyFl4_NH$  '1.10
    
  g_NSets2 = g_c_NSets2_NH
  g_NSets3 = g_c_NSets3_NH
  g_NSets4 = g_c_NSets4_NH  '1.10
    
  g_Acute24Fl2$ = g_c_Acute24Fl2_NH2$
  g_Acute24Fl3$ = g_c_Acute24Fl3_NH2$
  g_Acute24Fl4$ = g_c_Acute24Fl4_NH2$ '1.10
  
  g_AcuteLIFl2$ = g_c_AcuteLIFl2_NH2$
  g_AcuteLIFl3$ = g_c_AcuteLIFl3_NH2$
  g_AcuteLIFl4$ = g_c_AcuteLIFl4_NH2$ '1.10
    
  g_aNDays(2) = g_c_NDays2_NH
  g_aNDays(3) = g_c_NDays3_NH
  g_aNDays(4) = g_c_NDays4_NH '1.10
      
  g_MeansFFFileRoot$ = g_c_MeansFFFileRoot_NH2$
  g_MeansFFFile$ = g_c_MeansFFFile_NH2$
  g_MeansFile$ = g_c_MeansFile_NH2$  '1.10
      
  'g_FoodsepaRA$ = g_c_FoodsepaRA_NH$
  'g_Foodsepa$ = g_c_Foodsepa_NH$
  g_FoodsepaRA$ = g_c_FoodsepaRA_NH2$  '1.03
  g_Foodsepa$ = g_c_Foodsepa_NH2$   '1.03
    
  g_FFormsepaRA$ = g_c_FFormsepaRA_NH2$
  g_FFormsepa$ = g_c_FFormsepa_NH2$
  
  
  g_FileList$ = g_c_FileList_NH2$
  g_FileDates$ = g_c_FileDates_NH2$
  g_SupportFileNames$ = g_c_SupportFileNames_NH2$
  g_MakeCode$ = g_c_MakeCode_NH2$
  
  g_MakeCodeOld1$ = g_c_MakeCodeOld1_NH2$
  g_FoodsepaOld1$ = g_c_FoodsepaOld1_NH2$
  g_FFormsepaOld1$ = g_c_FFormsepaOld1_NH2$
  
  'use the following if you want to compare more old RAC/FF sets with new sets
  'g_MakeCodeOld2$ = g_c_MakeCodeOld2_NH2$
  'g_FoodsepaOld2$ = g_c_FoodsepaOld2_NH2$
  'g_FFormsepaOld2$ = g_c_FFormsepaOld2_NH2$
  
  'g_MakeCodeOld3$ = g_c_MakeCodeOld3_NH2$
  'g_FoodsepaOld3$ = g_c_FoodsepaOld3_NH2$
  'g_FFormsepaOld3$ = g_c_FFormsepaOld3_NH2$

  
End If




End Sub

Public Sub MergeIndices()
  'this sub merges the list of new NHANES/mod codes into the master list of NHANES/mod codes as currently set up in g_NFCSIndexFl$
  
  'read g_NFCSIndexFl$ into array
  'read "codesnotindexed2.txt" into array
  'merge these two arrays into new array and save as new file, advise user to change the file designation of g_NFCSIndexFl$ to the new file name (or rename the new file to replace old file)
  
  Dim NFCSx&, Modx&, Index, OldNSI
  Dim MaxNFCSIndex, MaxNewNFCSIndex, NOldIndices, NNewIndices, NTotal
  Dim i2, i3, a_ProblemCodes$(), Dummy!
  Dim a$, i, j, j1, j2
  Dim Nfcsx1&(), Modx1&(), Index1()
  Dim Nfcsx2&(), Modx2&(), Index2()
  Dim MinNewNFCSIndex
  Dim LastIndex, IndexCheck()
  Dim LastNFCS&, LastMod&
  Dim MergedNFCS&(), MergedMod&(), MergedIndex()
   
  Open g_NFCSIndexFl$ For Input As #1
  MaxNFCSIndex = 0
  NOldIndices = 0
  LastNFCS& = 0
  
  While Not EOF(1)
    Input #1, NFCSx&, Modx&, Index, OldNSI
    If NFCSx& < 11100000 Or NFCSx& > 95000000 Then
       MsgBox "In file " & g_NFCSIndexFl$ & "  NFCS code " & Str(NFCSx&) & " is invalid. Can 't continue until this is fixed.", vbInformation, "Merging Index Files"
       Close 1
       Exit Sub
    End If
    
    
    NOldIndices = NOldIndices + 1
    If Index > MaxNFCSIndex Then MaxNFCSIndex = Index
    If NFCSx& < LastNFCS& Then
       MsgBox "In file " & g_NFCSIndexFl$ & " the NFCS codes are not in numerical order at code " & Str(NFCSx&) & ". Can't continue until this is fixed.", vbInformation, "Merging Index Files"
       Close 1
       Exit Sub
    End If
    
    If NFCSx& = LastNFCS& Then
      If Modx& <= LastMod& Then
         MsgBox "In file " & g_NFCSIndexFl$ & " at NFCS code " & Str(NFCSx&) & " the modification codes are not in numerical. Can't continue until this is fixed.", vbInformation, "Merging Index Files"
         Close 1
        Exit Sub
      End If
    End If
    LastNFCS& = NFCSx&
    LastMod& = Modx&
  Wend
  Close 1
  
  
  Open g_NFCSIndexFl$ For Input As #1
  ReDim Nfcsx1&(NOldIndices), Modx1&(NOldIndices), Index1(NOldIndices)
  ReDim IndexCheck(MaxNFCSIndex)
  j = 0
  While Not EOF(1)
    j = j + 1
    Input #1, Nfcsx1&(j), Modx1&(j), Index1(j), OldNSI
    If IndexCheck(Index1(j)) Then
       MsgBox "In file " & g_NFCSIndexFl$ & " Index" & Str(Index1(j)) & " is used more than once. This must be fixed before you can merge these files.", vbInformation, "Merging Index Files"
       Close 1
       Exit Sub
    End If
    IndexCheck(Index1(j)) = 1
  Wend
  Close 1
  
  
  If Len(Dir("CodesNotIndexed2.txt")) = 0 Then
    MsgBox "File 'CodesNotIndexed2.txt' is not available in current directory. Can't do this merge until this has been generated and QA'd.", vbInformation, "Merging index files"
    Exit Sub
  End If

'load and check new index file:


  Open "CodesNotIndexed2.txt" For Input As #2
  MinNewNFCSIndex = 30000 'start arbitrarily high
  NNewIndices = 0
  LastNFCS& = 0
  MaxNewNFCSIndex = 0
  
  Line Input #2, a$
  
  While Not EOF(2)
    Input #2, i2, Index, NFCSx&, Modx&, Dummy!
    If Index < MinNewNFCSIndex Then MinNewNFCSIndex = Index
    NNewIndices = NNewIndices + 1
     
    If NFCSx& < LastNFCS& Then
      MsgBox "In file 'CodesNotIndexed2.txt' the NFCS codes are not in numerical order at code " & Str(NFCSx&) & ". Can't continue until this is fixed.", vbInformation, "Merging Index Files"
      Close 2
      Exit Sub
    End If
    
    If NFCSx& = LastNFCS& Then
      If Modx& <= LastMod& Then
         MsgBox "In file 'CodesNotIndexed2.txt' at NFCS code " & Str(NFCSx&) & " the modification codes are not in numerical. Can't continue until this is fixed.", vbInformation, "Merging Index Files"
         Close 2
        Exit Sub
      End If
    End If
    LastNFCS& = NFCSx&
    LastMod& = Modx&
    
    If Index > MaxNewNFCSIndex Then MaxNewNFCSIndex = Index
     
  Wend
  Close 2
  
  If MinNewNFCSIndex <= MaxNFCSIndex Then
     MsgBox "The lowest NHANES/mod code index in file 'CodesNotIndexed2.txt' (" & Str(MinNewNFCSIndex) & ") is smaller than the maximum NHANES/mod code index in file " & g_NFCSIndexFl$ & " (" & Str(MaxNFCSIndex) & "). Can't merge these files until this is corrected.", vbInformation, "Merging Index Files"
     Exit Sub
  End If
  
  Open "CodesNotIndexed2.txt" For Input As #2
  ReDim Nfcsx2&(NNewIndices), Modx2&(NNewIndices), Index2(NNewIndices)
  ReDim IndexCheck(MinNewNFCSIndex To MaxNewNFCSIndex)
  
  j = 0
  Line Input #2, a$
  While Not EOF(2)
     j = j + 1
     Input #2, i2, Index2(j), Nfcsx2&(j), Modx2&(j), Dummy!

     If IndexCheck(Index2(j)) Then
       MsgBox "In file 'CodesNotIndexed2.txt' Index" & Str(Index2(j)) & " is used more than once. This must be fixed before you can merge these files.", vbInformation, "Merging Index Files"
       Close 2
       Exit Sub
    End If
    IndexCheck(Index2(j)) = 1
  Wend
  Close 2
  
  
  NTotal = NOldIndices + NNewIndices
  ReDim MergedNFCS&(NTotal), MergedMod&(NTotal), MergedIndex(NTotal)
  
  j1 = 1
  j2 = 1
  For i = 1 To NTotal
        
    If Nfcsx1&(j1) < Nfcsx2&(j2) Then
      MergedNFCS&(i) = Nfcsx1&(j1)
      MergedMod&(i) = Modx1&(j1)
      MergedIndex(i) = Index1(j1)
      If j1 < NOldIndices Then
        j1 = j1 + 1
      Else
        Nfcsx1&(j1) = 99999999  'arbitrary big number
      End If
    ElseIf Nfcsx1&(j1) = Nfcsx2&(j2) Then
      If Modx1&(j1) < Modx2&(j2) Then
        MergedNFCS&(i) = Nfcsx1&(j1)
        MergedMod&(i) = Modx1&(j1)
        MergedIndex(i) = Index1(j1)
        If j1 < NOldIndices Then
          j1 = j1 + 1
        Else
          Nfcsx1&(j1) = 99999999  'arbitrary big number
        End If
      ElseIf Modx1&(j1) = Modx2&(j2) Then
        Stop   'you have the same nhanes/mod code in both files, shouldn't happen since second file has only new codes
      Else
        MergedNFCS&(i) = Nfcsx2&(j2)
        MergedMod&(i) = Modx2&(j2)
        MergedIndex(i) = Index2(j2)
        If j2 < NNewIndices Then
          j2 = j2 + 1
        Else
          Nfcsx1&(j2) = 99999999  'arbitrary big number
        End If
      End If
    Else
      MergedNFCS&(i) = Nfcsx2&(j2)
      MergedMod&(i) = Modx2&(j2)
      MergedIndex(i) = Index2(j2)
      If j2 < NNewIndices Then
        j2 = j2 + 1
      Else
        Nfcsx1&(j2) = 99999999  'arbitrary big number
      End If
    End If
  Next i
    
  Open "NewIndexFile.txt" For Output As #1
  For i = 1 To NTotal
    Print #1, MergedNFCS&(i), MergedMod&(i), MergedIndex(i), 0   '0 is to preserve space for nhanes index not used here
  Next
  Close 1

  'check work
  LastNFCS& = 0
  LastMod& = 0
  
  Open "NewIndexFile.txt" For Input As #1
  j = 0
  While Not EOF(1)
    Input #1, NFCSx&, Modx&, Index, Dummy
      j = j + 1
    If NFCSx& < LastNFCS& Then Stop
    If NFCSx& = LastNFCS& Then
      If Modx& <= LastMod& Then Stop
    End If
    LastNFCS& = NFCSx&
    LastMod& = Modx&
  Wend
  If j <> NTotal Then Stop
  Close 1
  
  MsgBox "Files " & g_NFCSIndexFl$ & " and CodesNotIndexed2.txt have been merged.  New file is called 'NewIndexFile.txt'.  You will need to QA this file and rename it, then change 'g_NFCSIndexFl$ = ' in the header information in the main module of this program so that it uses this new name.", vbInformation, "Merging Index Files"

End Sub


'Public Sub SetUpSurvey(Survey$(), NSets())
Public Sub SetUpSurvey(Survey$(), NSets(), Demog$()) '1.04

'note that there is nothing sacred about the number of files that each yearly survey is broken down into;
'early on it was difficult to save and move very large files; now large files are easier to work with,
'so each year can be saved as a single file

ReDim Survey$(g_LastSurveyYear)
ReDim NSets(g_LastSurveyYear)
ReDim Demog$(g_LastSurveyYear)  '1.04

If g_c_NHANES = 0 Then  'csfii, 4 year-sets
  Survey$(1) = g_SurveyFl1$ 'root name of survey data for first year
  NSets(1) = g_NSets1  'number of files in 1994 survey
  Survey$(2) = g_SurveyFl2$
  NSets(2) = g_NSets2 'number of files in 1995 survey
  Survey$(3) = g_SurveyFl3$
  NSets(3) = g_NSets3  'number of files in 1996 survey
  Survey$(4) = g_SurveyFl4$
  NSets(4) = g_NSets4  'number of files in 1998survey
  
ElseIf g_c_NHANES Then   'nhanes 1999-2006, 3 year-sets (note that first set will be skipped over when running 2-day nhanes
  Survey$(1) = g_SurveyFl1$ 'root name of survey data for first year
  NSets(1) = g_NSets1  'number of files in 1999-2002 survey
  Survey$(2) = g_SurveyFl2$
  NSets(2) = g_NSets2 'number of files in  2003-2004 survey
  Survey$(3) = g_SurveyFl3$
  NSets(3) = g_NSets3  'number of files in 2005-2006 survey
  Survey$(4) = g_SurveyFl4$  '1.10
  NSets(4) = g_NSets4  '1.10 number of files in 2005-2006 survey
  Demog$(1) = g_c_Demographics1_NH$  '1.04
  Demog$(2) = g_c_Demographics2_NH$  '1.04
  Demog$(3) = g_c_Demographics3_NH$  '1.04
  Demog$(4) = g_c_Demographics4_NH$  '1.10

End If
  

End Sub


Public Sub WriteSupportFile()

  Dim i
  'Dim Flag
  'Dim Response
  'Dim Survey$(), NSets()
  Dim Pop$()
  
  Dim HighNSICode$
  Dim HighNSIIndex
  'Dim IndexRAC, code$, CGx$, cf!, Name$, nff, fff  'remd 1.11
  Dim NRacFF, NRACs
  Dim MaxRACIndex
  Dim RACx$, Index, RACName$
  Dim Acute24Fl$(), AcuteLIFl$()
    
  
  
  
  Open g_RACIndexFl$ For Input As #1
  MaxRACIndex = 0
  NRACs = 0
  While Not EOF(1)
    Input #1, RACx$, Index
    Line Input #1, RACName$  'read rest of line, don't need to break out further at this point
    If Index Then NRACs = NRACs + 1  'count actual number of RACs in this file
    If Index > MaxRACIndex Then MaxRACIndex = Index
  Wend
  Close 1
     
  Call GetNRACFF(NRacFF)
  
    
  Open g_SupportFileNames$ For Output As #1
  Print #1, "This is the DEEM-FCID support file list for survey " & g_SurveyName$
  Print #1, "NHANES CODE ="; g_c_NHANES
  Print #1, g_MakeCode$  'version number if this support list, should always be updated in constant declarations before making a new official set of support files
  Print #1, g_SurveyName$  'Name of this survey
  Print #1, g_CGFFNames$  'this is a pass through of filename for the file that contains crop groups and food forms
  Print #1, g_FoodsepaRA$   'RAC definition file
  Print #1, g_FFormsepaRA$  'RAC/FF definition file
  Print #1, g_RACSortRA$   'replaces BOTH sort files in old DEEm (alphasortw.ran and epasortw.ran)
  Print #1, g_MeansFile$  'chronic means file for RAC's
  Print #1, g_MeansFFFile$ 'chronic means file for RAC/FF's
  If g_c_NHANES = 0 Then Print #1, g_c_PIDFileRA$
  
 ' Print #1, "N Survey Parts (groups of years) ="; g_NSurveyParts 'number of parts the acute files are broken down into (years for csfii, collection of years for NHANES)
  
  ReDim Acute24Fl$(4), AcuteLIFl$(4)
  '24 hour acute intake files
  If g_c_NHANES = 0 Then
    g_FirstSurveyYear = g_c_FirstSurveyYear_0
    g_LastSurveyYear = g_c_LastSurveyYear_0
    Acute24Fl$(1) = g_Acute24Fl1$
    Acute24Fl$(2) = g_Acute24Fl2$
    Acute24Fl$(3) = g_Acute24Fl3$
    Acute24Fl$(4) = g_Acute24Fl4$
  ElseIf g_c_NHANES = 1 Then
    g_FirstSurveyYear = g_c_FirstSurveyYear_NH1
    g_LastSurveyYear = g_c_LastSurveyYear_NH1
    Acute24Fl$(1) = g_Acute24Fl1$
    Acute24Fl$(2) = g_Acute24Fl2$
    Acute24Fl$(3) = g_Acute24Fl3$
  ElseIf g_c_NHANES = 2 Then
    g_FirstSurveyYear = g_c_FirstSurveyYear_NH2
    g_LastSurveyYear = g_c_LastSurveyYear_NH2
    Acute24Fl$(2) = g_Acute24Fl2$
    Acute24Fl$(3) = g_Acute24Fl3$
    Acute24Fl$(4) = g_Acute24Fl4$
  End If
  
  Print #1, "First survey year ="; g_FirstSurveyYear
  Print #1, "Last survey year ="; g_LastSurveyYear
  
  Print #1, "24-hour intake files:"
  For i = g_FirstSurveyYear To g_LastSurveyYear
     Print #1, Acute24Fl$(i)
  Next i
  
  'LI acute intake files
  If g_c_NHANES = 0 Then
    AcuteLIFl$(1) = g_AcuteLIFl1$
    AcuteLIFl$(2) = g_AcuteLIFl2$
    AcuteLIFl$(3) = g_AcuteLIFl3$
    AcuteLIFl$(4) = g_AcuteLIFl4$
  ElseIf g_c_NHANES = 1 Then
    AcuteLIFl$(1) = g_AcuteLIFl1$
    AcuteLIFl$(2) = g_AcuteLIFl2$
    AcuteLIFl$(3) = g_AcuteLIFl3$
    AcuteLIFl$(4) = g_AcuteLIFl4$
  ElseIf g_c_NHANES = 2 Then
    AcuteLIFl$(2) = g_AcuteLIFl2$
    AcuteLIFl$(3) = g_AcuteLIFl3$
    AcuteLIFl$(4) = g_AcuteLIFl4$
  End If
  
  Print #1, "Line-item intake files:"
  For i = g_FirstSurveyYear To g_LastSurveyYear
     Print #1, AcuteLIFl$(i)
  Next i
 
  
  Print #1, "Highest RAC index ="; MaxRACIndex  'highest nsi index
  Print #1, "Number of RACS = "; NRACs
  Print #1, "Number of RAC/FF combinations = "; NRacFF 'number of record in primary RAC/ff means file
  
  
  Call SetUpFiles
  Call PopulationNames(Pop$())
  Print #1, "Number of populations ="; g_NPops
  For i = 1 To g_NPops
    Write #1, Pop$(i)
  Next i
  
  Close 1

End Sub

Public Sub CompareRACFF(OldMakeCode$, OldRACFile$, OldRACFFFile$)

Dim NewRACFile$
Dim NewFFFile$
NewRACFile$ = g_Foodsepa$
NewFFFile$ = g_FFormsepa$

Dim a$
Dim NSI, Rac$, cg$, cf!, namex$, nff, fff
Dim NSI2, RAC2$, cg2$, cf2!, namex2$, nff2, fff2
Dim MaxNSI
Dim NSIi()
Dim FlagNewRac
Dim FlagNewFF
Dim MinFF, MaxFF
Dim i, n, FF
Dim aFF()
Dim CountFF


Print #5, "Since MakeCode version "; OldMakeCode$
Print #5,
'Print #5, "New RAC/FF = "; RAC$, FF


'find the highest RAC index code in new RAC file
Open NewRACFile$ For Input As #1
While Not EOF(1)
  Input #1, NSI
  If NSI > MaxNSI Then MaxNSI = NSI  'assumes that no RAC was dropped from RAC file in new survey, only added
  Line Input #1, a$
Wend
Close 1

ReDim NSIi(MaxNSI)

'check to see if there are new RACs
'for each RAC, test to see if there are new FF's
'Open "foodsepa99-06-nh1.txt" For Input As #3
Open OldRACFile$ For Input As #3
While Not EOF(3)  'read old RAC file and set up array of all RACs appearing in this file
  Input #3, NSI2, RAC2$, cg2$, cf2!, namex2$, nff2, fff2
  NSIi(NSI2) = 1
Wend
Close 3

FlagNewRac = 0
'Open "FoodsEPA03-08-NH2-d.txt" For Input As #1
Open NewRACFile$ For Input As #1


While Not EOF(1)  'read the new RAC file, look to see if there are any new RACs
  Input #1, NSI, Rac$, cg$, cf!, namex$, nff, fff
  If NSIi(NSI) = 0 Then
    FlagNewRac = 1
    Print #5, "New RAC = "; NSI, Rac$
  End If
Wend
Close 1

If FlagNewRac = 0 Then Print #5, "No new RACS"
Print #5,

MinFF = 1000
MaxFF = 0
ReDim aFF(999)

Open OldRACFFFile$ For Input As #4
While Not EOF(4)
  Input #4, i, FF, cf!
  If FF < MinFF Then MinFF = FF
  If FF > MaxFF Then MaxFF = FF
  aFF(FF) = 1
Wend
Close 4

CountFF = 0
For i = 1 To 999
  If aFF(i) Then CountFF = CountFF + 1  'aFF() is array of all FFs used in older survey
Next

Dim FFi()  'Food Form Index
ReDim FFi(999)

n = 0
For i = 1 To 999
  If aFF(i) Then
    n = n + 1
    FFi(i) = n  'n is index for FF
  End If
Next


ReDim FFX(MaxNSI, CountFF)

Open OldRACFile$ For Input As #3
Open OldRACFFFile$ For Input As #4

While Not EOF(3)
  Input #3, NSI2, RAC2$, cg2$, cf2!, namex2$, nff2, fff2
  For i = 1 To nff2
    Input #4, n, FF, cf!
    FFX(NSI2, FFi(FF)) = 1
  Next
Wend
Close 3, 4

Open NewRACFile$ For Input As #1
Open NewFFFile$ For Input As #2
FlagNewFF = 0



While Not EOF(1)  'read the new RAC file, look to see if there are any new RACs
  Input #1, NSI, Rac$, cg$, cf!, namex$, nff, fff
  
  If NSIi(NSI) Then
    For i = 1 To nff
      Input #2, n, FF, cf!
      
      If FFi(FF) = 0 Then 'this is a new FF never used before
        If FlagNewFF = 0 Then Print #5, "                RAC", "FoodForm"
        Print #5, "New RAC/FF = "; Rac$, FF
        FlagNewFF = 1
      Else
        If FFX(NSI, FFi(FF)) = 0 Then
          If FlagNewFF = 0 Then Print #5, "                RAC", "FoodForm"
          Print #5, "New RAC/FF = "; Rac$, FF
          FlagNewFF = 1
        End If
      End If
    Next
  End If
Wend

If FlagNewFF = 0 Then Print #5, "No new RAC/FF combinations"

Print #5,

Close 1, 2

End Sub


Public Sub ChangeCF(bu) '1.12  all
Dim MaxRACIndex
Dim RACx$, Index
Dim IndexRAC
Dim RACName$

Dim RACCode$(), RACCodex$
Dim cg$(), cgx$
Dim namex$()
Dim cf!(), cfx!
Dim x
Dim nff, fff

Dim FoodsEpaNew$

Dim FOOD98 As FOODREC98
Dim FOODNH As FOODRECNH
Dim Response

x = InStr(UCase(g_Foodsepa$), ".TXT")
FoodsEpaNew$ = Left(g_Foodsepa$, x) + "new"



Response = MsgBox("The 'Change Default Concentration Factors' option will re-read file " & g_RACIndexFl$ & " (after the supporting files for DEEM Chronic have already been computed) and change the coresponding default concentration factors for the RACs in the DEEM Chronic support files. A new QA file will be generated, named " & FoodsEpaNew$, vbOKCancel, "Change Default Concentration Factors")
If Response = vbCancel Then
  bu = 1
  Exit Sub
End If

If Len(Dir(g_RACIndexFl$)) = 0 Then  '
    MsgBox "Can't find file " & g_RACIndexFl$ & " in current directory " & CurDir, vbInformation, "Change Default Concentration Factors"
    bu = 1
    Exit Sub
  Else
    Open g_RACIndexFl$ For Input As #1
    MaxRACIndex = 0
    While Not EOF(1)
      Input #1, RACx$, Index
      Line Input #1, RACName$
      If Index > MaxRACIndex Then MaxRACIndex = Index
    Wend
    Close 1
  End If


Open g_RACIndexFl$ For Input As #1
ReDim RACCode$(MaxRACIndex)
ReDim cg$(MaxRACIndex)
ReDim namex$(MaxRACIndex)
ReDim cf!(MaxRACIndex)

While Not EOF(1)
  Input #1, RACx$, IndexRAC
  RACCode$(IndexRAC) = RACx$
  Input #1, cg$(IndexRAC), namex$(IndexRAC), cf!(IndexRAC)

Wend
Close 1

If Len(Dir(g_FoodsepaRA$)) = 0 Then
  MsgBox "DEEM support file " & g_FoodsepaRA$ & " has not yet been generated.  This conversion option is only available after the DEEM Chronic support files have been generated.", vbInformation, "Change Default Concentration Factors"
  bu = 1
  Exit Sub
End If
  
 
If g_c_NHANES = 0 Then
  Open g_FoodsepaRA$ For Random As #2 Len = Len(FOOD98)
Else
  Open g_FoodsepaRA$ For Random As #2 Len = Len(FOODNH)
End If


For IndexRAC = 1 To MaxRACIndex
  
  If g_c_NHANES = 0 Then
    Get #2, IndexRAC, FOOD98
    FOOD98.cf = cf!(IndexRAC)
    Put #2, IndexRAC, FOOD98
  Else
    Get #2, IndexRAC, FOODNH
    FOODNH.cf = cf!(IndexRAC)
    Put #2, IndexRAC, FOODNH
  End If

Next
Close


Open g_Foodsepa$ For Input As #1  'source of rac names and adjustment factors from index.bas
Open FoodsEpaNew$ For Output As #2


IndexRAC = 0
Do Until IndexRAC = MaxRACIndex
  Input #1, IndexRAC, RACCodex$, cgx$, cfx!, RACName$, nff, fff  '1.11
  Write #2, IndexRAC; RACCodex$; cgx$; cf!(IndexRAC); RACName$; nff; fff '1.11

Loop
Close 1, 2

MsgBox "Default Concentration Factors updated successfully.  Please examine the QA file " & FoodsEpaNew$ & " to make sure that these new factors appear correctly. You must move file " & g_FoodsepaRA$ & " to the DEEM folder and replace the old file with the same name.", vbInformation, "Change Default Concentration Factors"

End Sub
